/* apprunner.c generated by valac 0.40.6, the Vala compiler
 * generated from apprunner.vala, do not modify */

/*
 * Copyright 2014-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <nuvolaruntime-base.h>
#include <stdio.h>
#include <dioriteglib4.h>
#include <gio/gio.h>
#include <nuvolaruntime-runner.h>


#define NUVOLA_TYPE_ARGS (nuvola_args_get_type ())
typedef struct _NuvolaArgs NuvolaArgs;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NuvolaArgs {
};


extern gboolean nuvola_args_debug;
gboolean nuvola_args_debug = FALSE;
extern gboolean nuvola_args_verbose;
gboolean nuvola_args_verbose = FALSE;
extern gboolean nuvola_args_version;
gboolean nuvola_args_version = FALSE;
extern gchar* nuvola_args_app_dir;
gchar* nuvola_args_app_dir = NULL;

GType nuvola_args_get_type (void) G_GNUC_CONST;
NuvolaArgs* nuvola_args_dup (const NuvolaArgs* self);
void nuvola_args_free (NuvolaArgs* self);
gint nuvola_main (gchar** args,
                  int args_length1);

const GOptionEntry NUVOLA_ARGS_options[5] = {{"app-dir", 'a', 0, G_OPTION_ARG_FILENAME, &nuvola_args_app_dir, "Web app to run.", "DIR"}, {"verbose", 'v', 0, G_OPTION_ARG_NONE, &nuvola_args_verbose, "Print informational messages", NULL}, {"debug", 'D', 0, G_OPTION_ARG_NONE, &nuvola_args_debug, "Print debugging messages", NULL}, {"version", 'V', 0, G_OPTION_ARG_NONE, &nuvola_args_version, "Print version and exit", NULL}, {NULL}};

NuvolaArgs*
nuvola_args_dup (const NuvolaArgs* self)
{
	NuvolaArgs* dup;
	dup = g_new0 (NuvolaArgs, 1);
	memcpy (dup, self, sizeof (NuvolaArgs));
	return dup;
}


void
nuvola_args_free (NuvolaArgs* self)
{
	g_free (self);
}


GType
nuvola_args_get_type (void)
{
	static volatile gsize nuvola_args_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_args_type_id__volatile)) {
		GType nuvola_args_type_id;
		nuvola_args_type_id = g_boxed_type_register_static ("NuvolaArgs", (GBoxedCopyFunc) nuvola_args_dup, (GBoxedFreeFunc) nuvola_args_free);
		g_once_init_leave (&nuvola_args_type_id__volatile, nuvola_args_type_id);
	}
	return nuvola_args_type_id__volatile;
}


gint
nuvola_main (gchar** args,
             int args_length1)
{
	gint result = 0;
	const gchar* _tmp15_;
	GLogLevelFlags _tmp17_ = 0;
	gboolean _tmp18_;
	FILE* _tmp21_;
	const gchar* _tmp22_;
	GFile* app_dir = NULL;
	const gchar* _tmp23_;
	GFile* _tmp24_;
	gboolean _tmp25_;
	gint _tmp37_ = 0;
	GError * _inner_error_ = NULL;
	{
		GOptionContext* opt_context = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GOptionContext* _tmp4_;
		GOptionContext* _tmp5_;
		GOptionContext* _tmp6_;
		GOptionContext* _tmp7_;
		GOptionContext* _tmp8_;
		GOptionContext* _tmp9_;
		_tmp0_ = nuvola_get_app_name ();
		_tmp1_ = _tmp0_;
		_tmp2_ = g_strdup_printf ("- %s", _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_option_context_new (_tmp3_);
		_tmp5_ = _tmp4_;
		_g_free0 (_tmp3_);
		_g_free0 (_tmp1_);
		opt_context = _tmp5_;
		_tmp6_ = opt_context;
		g_option_context_set_help_enabled (_tmp6_, TRUE);
		_tmp7_ = opt_context;
		g_option_context_add_main_entries (_tmp7_, NUVOLA_ARGS_options, NULL);
		_tmp8_ = opt_context;
		g_option_context_set_ignore_unknown_options (_tmp8_, TRUE);
		_tmp9_ = opt_context;
		g_option_context_parse (_tmp9_, &args_length1, &args, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp10_ = 0;
			_g_option_context_free0 (opt_context);
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			_g_option_context_free0 (opt_context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp10_;
		}
		_g_option_context_free0 (opt_context);
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = stderr;
		_tmp12_ = e;
		_tmp13_ = _tmp12_->message;
		fprintf (_tmp11_, "option parsing failed: %s\n", _tmp13_);
		result = 1;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp14_ = 0;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp14_;
	}
	_tmp15_ = nuvola_args_app_dir;
	if (_tmp15_ == NULL) {
		gchar* _tmp16_;
		_tmp16_ = g_strdup (".");
		_g_free0 (nuvola_args_app_dir);
		nuvola_args_app_dir = _tmp16_;
	}
	_tmp18_ = nuvola_args_debug;
	if (_tmp18_) {
		_tmp17_ = G_LOG_LEVEL_DEBUG;
	} else {
		GLogLevelFlags _tmp19_ = 0;
		gboolean _tmp20_;
		_tmp20_ = nuvola_args_verbose;
		if (_tmp20_) {
			_tmp19_ = G_LOG_LEVEL_INFO;
		} else {
			_tmp19_ = G_LOG_LEVEL_WARNING;
		}
		_tmp17_ = _tmp19_;
	}
	_tmp21_ = stderr;
	drt_logger_init (_tmp21_, _tmp17_, TRUE, "Runner");
	_tmp22_ = g_getenv ("NUVOLA_TEST_ABORT");
	if (g_strcmp0 (_tmp22_, "runner") == 0) {
		g_error ("apprunner.vala:67: App runner abort requested.");
	}
	_tmp23_ = nuvola_args_app_dir;
	_tmp24_ = g_file_new_for_path (_tmp23_);
	app_dir = _tmp24_;
	_tmp25_ = nuvola_args_version;
	if (_tmp25_) {
		FILE* _tmp26_;
		GFile* _tmp27_;
		_tmp26_ = stdout;
		_tmp27_ = app_dir;
		result = nuvola_startup_print_web_app_version (_tmp26_, _tmp27_);
		_g_object_unref0 (app_dir);
		return result;
	}
	{
		gint _tmp28_ = 0;
		GFile* _tmp29_;
		_tmp29_ = app_dir;
		_tmp28_ = nuvola_startup_run_web_app_with_dbus_handshake (_tmp29_, args, args_length1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp30_ = 0;
			if (_inner_error_->domain == NUVOLA_WEB_APP_ERROR) {
				goto __catch1_nuvola_web_app_error;
			}
			_g_object_unref0 (app_dir);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp30_;
		}
		result = _tmp28_;
		_g_object_unref0 (app_dir);
		return result;
	}
	goto __finally1;
	__catch1_nuvola_web_app_error:
	{
		GError* e = NULL;
		FILE* _tmp31_;
		FILE* _tmp32_;
		const gchar* _tmp33_;
		FILE* _tmp34_;
		GError* _tmp35_;
		const gchar* _tmp36_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp31_ = stderr;
		fputs ("Failed to load web app!\n", _tmp31_);
		_tmp32_ = stderr;
		_tmp33_ = nuvola_args_app_dir;
		fprintf (_tmp32_, "Dir: %s\n", _tmp33_);
		_tmp34_ = stderr;
		_tmp35_ = e;
		_tmp36_ = _tmp35_->message;
		fprintf (_tmp34_, "Error: %s\n", _tmp36_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (app_dir);
		return result;
	}
	__finally1:
	_g_object_unref0 (app_dir);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return _tmp37_;
}


int
main (int argc,
      char ** argv)
{
	return nuvola_main (argv, argc);
}



