/* control.c generated by valac 0.40.6, the Vala compiler
 * generated from control.vala, do not modify */

/*
 * Copyright 2014-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <nuvolaruntime-base.h>
#include <glib/gstdio.h>
#include <dioriteglib4.h>
#include <nuvolaruntime-runner.h>
#include <gio/gio.h>
#include <json-glib/json-glib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define NUVOLA_TYPE_ARGS (nuvola_args_get_type ())
typedef struct _NuvolaArgs NuvolaArgs;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define NUVOLA_TYPE_CONTROL (nuvola_control_get_type ())
#define NUVOLA_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_CONTROL, NuvolaControl))
#define NUVOLA_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_CONTROL, NuvolaControlClass))
#define NUVOLA_IS_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_CONTROL))
#define NUVOLA_IS_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_CONTROL))
#define NUVOLA_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_CONTROL, NuvolaControlClass))

typedef struct _NuvolaControl NuvolaControl;
typedef struct _NuvolaControlClass NuvolaControlClass;
#define _nuvola_control_unref0(var) ((var == NULL) ? NULL : (var = (nuvola_control_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
typedef struct _NuvolaControlPrivate NuvolaControlPrivate;
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
typedef struct _NuvolaParamSpecControl NuvolaParamSpecControl;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NuvolaArgs {
};

struct _NuvolaControl {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NuvolaControlPrivate * priv;
};

struct _NuvolaControlClass {
	GTypeClass parent_class;
	void (*finalize) (NuvolaControl *self);
};

struct _NuvolaControlPrivate {
	DrtRpcChannel* conn;
};

struct _NuvolaParamSpecControl {
	GParamSpec parent_instance;
};


extern gboolean nuvola_args_debug;
gboolean nuvola_args_debug = FALSE;
extern gboolean nuvola_args_verbose;
gboolean nuvola_args_verbose = FALSE;
extern gboolean nuvola_args_version;
gboolean nuvola_args_version = FALSE;
extern gchar* nuvola_args_app;
gchar* nuvola_args_app = NULL;
extern gchar* nuvola_args_log_file;
gchar* nuvola_args_log_file = NULL;
extern gchar** nuvola_args_command;
gchar** nuvola_args_command = NULL;
static gpointer nuvola_control_parent_class = NULL;

GType nuvola_args_get_type (void) G_GNUC_CONST;
NuvolaArgs* nuvola_args_dup (const NuvolaArgs* self);
void nuvola_args_free (NuvolaArgs* self);
gint nuvola_quit (gint code,
                  const gchar* format,
                  ...) G_GNUC_PRINTF(2,3);
#define NUVOLA_DESCRIPTION "Commands:\n" \
"\n" \
"  list-actions\n" \
"    - list available actions\n" \
"\n" \
"  action NAME [STATE]\n" \
"    - invoke action with name NAME\n" \
"    - STATE parameter is used to select option of a radio action\n" \
"\n" \
"  action-state NAME\n" \
"    - get state of radio or toggle action with name NAME\n" \
"    - does nothing for simple actions\n" \
"    - you can set state actions with `action` command\n" \
"\n" \
"  track-info [KEY]\n" \
"   - prints track information\n" \
"   - KEY can be 'all' (default), 'title', 'artist', 'album', 'state',\n" \
"     'artwork_location', 'artwork_file' or 'rating'.\n"
gint nuvola_main (gchar** args,
                  int args_length1);
gpointer nuvola_control_ref (gpointer instance);
void nuvola_control_unref (gpointer instance);
GParamSpec* nuvola_param_spec_control (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void nuvola_value_set_control (GValue* value,
                               gpointer v_object);
void nuvola_value_take_control (GValue* value,
                                gpointer v_object);
gpointer nuvola_value_get_control (const GValue* value);
GType nuvola_control_get_type (void) G_GNUC_CONST;
NuvolaControl* nuvola_control_new (DrtRpcChannel* conn);
NuvolaControl* nuvola_control_construct (GType object_type,
                                         DrtRpcChannel* conn);
gint nuvola_control_activate_action (NuvolaControl* self,
                                     const gchar* name,
                                     const gchar* parameter_str,
                                     GError** error);
gint nuvola_control_list_actions (NuvolaControl* self,
                                  GError** error);
gint nuvola_control_action_state (NuvolaControl* self,
                                  const gchar* name,
                                  GError** error);
gint nuvola_control_track_info (NuvolaControl* self,
                                const gchar* key,
                                GError** error);
gint nuvola_call_api_method (DrtRpcChannel* connection,
                             gchar** args,
                             int args_length1,
                             gint offset,
                             GError** error);
static void _vala_JsonNode_free (JsonNode* self);
#define NUVOLA_CONTROL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_CONTROL, NuvolaControlPrivate))
static void nuvola_control_finalize (NuvolaControl * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

const GOptionEntry NUVOLA_ARGS_main_options[7] = {{"app", 'a', 0, G_OPTION_ARG_FILENAME, &nuvola_args_app, "Web app to control.", "ID"}, {"verbose", 'v', 0, G_OPTION_ARG_NONE, &nuvola_args_verbose, "Print informational messages", NULL}, {"debug", 'D', 0, G_OPTION_ARG_NONE, &nuvola_args_debug, "Print debugging messages", NULL}, {"version", 'V', 0, G_OPTION_ARG_NONE, &nuvola_args_version, "Print version and exit", NULL}, {"log-file", 'L', 0, G_OPTION_ARG_FILENAME, &nuvola_args_log_file, "Log to file", "FILE"}, {"", (gchar) 0, 0, G_OPTION_ARG_STRING_ARRAY, &nuvola_args_command, "Command.", "COMMAND PARAMS..."}, {NULL}};

NuvolaArgs*
nuvola_args_dup (const NuvolaArgs* self)
{
	NuvolaArgs* dup;
	dup = g_new0 (NuvolaArgs, 1);
	memcpy (dup, self, sizeof (NuvolaArgs));
	return dup;
}


void
nuvola_args_free (NuvolaArgs* self)
{
	g_free (self);
}


GType
nuvola_args_get_type (void)
{
	static volatile gsize nuvola_args_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_args_type_id__volatile)) {
		GType nuvola_args_type_id;
		nuvola_args_type_id = g_boxed_type_register_static ("NuvolaArgs", (GBoxedCopyFunc) nuvola_args_dup, (GBoxedFreeFunc) nuvola_args_free);
		g_once_init_leave (&nuvola_args_type_id__volatile, nuvola_args_type_id);
	}
	return nuvola_args_type_id__volatile;
}


gint
nuvola_quit (gint code,
             const gchar* format,
             ...)
{
	gint result = 0;
	FILE* _tmp0_;
	va_list _tmp1_ = {0};
	g_return_val_if_fail (format != NULL, 0);
	_tmp0_ = stderr;
	va_start (_tmp1_, format);
	vfprintf (_tmp0_, format, _tmp1_);
	va_end (_tmp1_);
	result = code;
	return result;
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch3_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch3_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally3;
	__catch3_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gint
nuvola_main (gchar** args,
             int args_length1)
{
	gint result = 0;
	gboolean _tmp16_;
	FILE* log = NULL;
	const gchar* _tmp22_;
	FILE* _tmp28_ = NULL;
	FILE* _tmp29_;
	GLogLevelFlags _tmp32_ = 0;
	gboolean _tmp33_;
	gchar** _tmp36_;
	gint _tmp36__length1;
	const gchar* _tmp38_;
	DrtRpcChannel* client = NULL;
	GSocket* socket = NULL;
	GSocket* _tmp82_;
	gchar* command = NULL;
	gchar** _tmp98_;
	gint _tmp98__length1;
	const gchar* _tmp99_;
	gchar* _tmp100_;
	NuvolaControl* control = NULL;
	DrtRpcChannel* _tmp101_;
	NuvolaControl* _tmp102_;
	gint _tmp160_ = 0;
	GError * _inner_error_ = NULL;
	{
		GOptionContext* opt_context = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GOptionContext* _tmp4_;
		GOptionContext* _tmp5_;
		GOptionContext* _tmp6_;
		GOptionContext* _tmp7_;
		GOptionContext* _tmp8_;
		GOptionContext* _tmp9_;
		GOptionContext* _tmp10_;
		_tmp0_ = nuvola_get_app_name ();
		_tmp1_ = _tmp0_;
		_tmp2_ = g_strdup_printf ("- Control %s", _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_option_context_new (_tmp3_);
		_tmp5_ = _tmp4_;
		_g_free0 (_tmp3_);
		_g_free0 (_tmp1_);
		opt_context = _tmp5_;
		_tmp6_ = opt_context;
		g_option_context_set_help_enabled (_tmp6_, TRUE);
		_tmp7_ = opt_context;
		g_option_context_add_main_entries (_tmp7_, NUVOLA_ARGS_main_options, NULL);
		_tmp8_ = opt_context;
		g_option_context_set_ignore_unknown_options (_tmp8_, FALSE);
		_tmp9_ = opt_context;
		g_option_context_set_description (_tmp9_, NUVOLA_DESCRIPTION);
		_tmp10_ = opt_context;
		g_option_context_parse (_tmp10_, &args_length1, &args, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp11_ = 0;
			_g_option_context_free0 (opt_context);
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			_g_option_context_free0 (opt_context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp11_;
		}
		_g_option_context_free0 (opt_context);
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp12_ = stderr;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		fprintf (_tmp12_, "Error: Option parsing failed: %s\n", _tmp14_);
		result = 1;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp15_ = 0;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp15_;
	}
	_tmp16_ = nuvola_args_version;
	if (_tmp16_) {
		FILE* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp17_ = stdout;
		_tmp18_ = nuvola_get_app_name ();
		_tmp19_ = _tmp18_;
		_tmp20_ = nuvola_get_version ();
		_tmp21_ = _tmp20_;
		fprintf (_tmp17_, "%s %s\n", _tmp19_, _tmp21_);
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		result = 0;
		return result;
	}
	log = NULL;
	_tmp22_ = nuvola_args_log_file;
	if (_tmp22_ != NULL) {
		const gchar* _tmp23_;
		FILE* _tmp24_;
		FILE* _tmp25_;
		_tmp23_ = nuvola_args_log_file;
		_tmp24_ = g_fopen (_tmp23_, "w");
		_fclose0 (log);
		log = _tmp24_;
		_tmp25_ = log;
		if (_tmp25_ == NULL) {
			FILE* _tmp26_;
			const gchar* _tmp27_;
			_tmp26_ = stderr;
			_tmp27_ = nuvola_args_log_file;
			fprintf (_tmp26_, "Error: Cannot open log file '%s' for writing.\n", _tmp27_);
			result = 1;
			_fclose0 (log);
			return result;
		}
	}
	_tmp29_ = log;
	if (_tmp29_ != NULL) {
		FILE* _tmp30_;
		_tmp30_ = log;
		_tmp28_ = _tmp30_;
	} else {
		FILE* _tmp31_;
		_tmp31_ = stderr;
		_tmp28_ = _tmp31_;
	}
	_tmp33_ = nuvola_args_debug;
	if (_tmp33_) {
		_tmp32_ = G_LOG_LEVEL_DEBUG;
	} else {
		GLogLevelFlags _tmp34_ = 0;
		gboolean _tmp35_;
		_tmp35_ = nuvola_args_verbose;
		if (_tmp35_) {
			_tmp34_ = G_LOG_LEVEL_INFO;
		} else {
			_tmp34_ = G_LOG_LEVEL_WARNING;
		}
		_tmp32_ = _tmp34_;
	}
	drt_logger_init (_tmp28_, _tmp32_, TRUE, "Control");
	_tmp36_ = nuvola_args_command;
	_tmp36__length1 = _vala_array_length (nuvola_args_command);
	if (_tmp36__length1 < 1) {
		const gchar* _tmp37_;
		_tmp37_ = args[0];
		result = nuvola_quit (1, "Error: No command specified. Type `%s --help` for help.\n", _tmp37_);
		_fclose0 (log);
		return result;
	}
	_tmp38_ = nuvola_args_app;
	if (_tmp38_ == NULL) {
		{
			DrtRpcChannel* master = NULL;
			gchar* _tmp39_;
			gchar* _tmp40_;
			DrtRpcChannel* _tmp41_;
			DrtRpcChannel* _tmp42_;
			GVariant* response = NULL;
			DrtRpcChannel* _tmp43_;
			GVariant* _tmp44_;
			GVariant* _tmp45_;
			GVariant* _tmp46_;
			gboolean _tmp47_ = FALSE;
			const gchar* _tmp48_;
			const gchar* _tmp53_;
			_tmp39_ = nuvola_build_master_ipc_id ();
			_tmp40_ = _tmp39_;
			_tmp41_ = drt_rpc_channel_new_from_name ((guint) 1, _tmp40_, NULL, NULL, (guint) 500, &_inner_error_);
			_tmp42_ = _tmp41_;
			_g_free0 (_tmp40_);
			master = _tmp42_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch1_g_error;
			}
			_tmp43_ = master;
			_tmp44_ = drt_rpc_connection_call_sync ((DrtRpcConnection*) _tmp43_, "/nuvola/core/get_top_runner", NULL, &_inner_error_);
			response = _tmp44_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (master);
				goto __catch1_g_error;
			}
			_tmp45_ = response;
			drt_rpc_check_type_string (_tmp45_, "ms", &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_variant_unref0 (response);
				_g_object_unref0 (master);
				goto __catch1_g_error;
			}
			_tmp46_ = response;
			g_variant_get (_tmp46_, "ms", &nuvola_args_app, NULL);
			_tmp48_ = nuvola_args_app;
			if (_tmp48_ == NULL) {
				_tmp47_ = TRUE;
			} else {
				const gchar* _tmp49_;
				_tmp49_ = nuvola_args_app;
				_tmp47_ = g_strcmp0 (_tmp49_, "") == 0;
			}
			if (_tmp47_) {
				gchar* _tmp50_;
				gchar* _tmp51_;
				gint _tmp52_;
				_tmp50_ = nuvola_get_app_name ();
				_tmp51_ = _tmp50_;
				_tmp52_ = nuvola_quit (1, "Error: No %s instance is running.\n", _tmp51_);
				_g_free0 (_tmp51_);
				result = _tmp52_;
				_g_variant_unref0 (response);
				_g_object_unref0 (master);
				_fclose0 (log);
				return result;
			}
			_tmp53_ = nuvola_args_app;
			g_message ("control.vala:143: Using '%s' as web app id.", _tmp53_);
			_g_variant_unref0 (response);
			_g_object_unref0 (master);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			gchar* _tmp54_;
			gchar* _tmp55_;
			GError* _tmp56_;
			const gchar* _tmp57_;
			gint _tmp58_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp54_ = nuvola_get_app_name ();
			_tmp55_ = _tmp54_;
			_tmp56_ = e;
			_tmp57_ = _tmp56_->message;
			_tmp58_ = nuvola_quit (2, "Error: Communication with %s master instance failed: %s\n", _tmp55_, _tmp57_);
			_g_free0 (_tmp55_);
			result = _tmp58_;
			_g_error_free0 (e);
			_fclose0 (log);
			return result;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp59_ = 0;
			_fclose0 (log);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp59_;
		}
	}
	socket = NULL;
	{
		gchar* uid = NULL;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* path = NULL;
		const gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		NuvolaAppDbusIfce* app_api = NULL;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		NuvolaAppDbusIfce* _tmp72_;
		NuvolaAppDbusIfce* _tmp73_;
		GSocket* _tmp74_ = NULL;
		_tmp60_ = nuvola_args_app;
		_tmp61_ = nuvola_get_dbus_id ();
		_tmp62_ = _tmp61_;
		_tmp63_ = nuvola_web_app_build_uid_from_app_id (_tmp60_, _tmp62_);
		_tmp64_ = _tmp63_;
		_g_free0 (_tmp62_);
		uid = _tmp64_;
		_tmp65_ = uid;
		_tmp66_ = string_replace (_tmp65_, ".", "/");
		_tmp67_ = _tmp66_;
		_tmp68_ = g_strconcat ("/", _tmp67_, NULL);
		_tmp69_ = _tmp68_;
		_g_free0 (_tmp67_);
		path = _tmp69_;
		_tmp70_ = uid;
		_tmp71_ = path;
		_tmp72_ = g_initable_new (NUVOLA_TYPE_APP_DBUS_IFCE_PROXY, NULL, &_inner_error_, "g-flags", G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS | G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES, "g-name", _tmp70_, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", _tmp71_, "g-interface-name", "eu.tiliado.NuvolaApp", "g-interface-info", g_type_get_qdata (NUVOLA_TYPE_APP_DBUS_IFCE, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
		app_api = (NuvolaAppDbusIfce*) _tmp72_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (path);
			_g_free0 (uid);
			goto __catch2_g_error;
		}
		_tmp73_ = app_api;
		nuvola_app_dbus_ifce_get_connection (_tmp73_, &_tmp74_, &_inner_error_);
		_g_object_unref0 (socket);
		socket = _tmp74_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (app_api);
			_g_free0 (path);
			_g_free0 (uid);
			goto __catch2_g_error;
		}
		_g_object_unref0 (app_api);
		_g_free0 (path);
		_g_free0 (uid);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		gchar* _tmp75_;
		gchar* _tmp76_;
		const gchar* _tmp77_;
		GError* _tmp78_;
		const gchar* _tmp79_;
		gint _tmp80_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp75_ = nuvola_get_app_name ();
		_tmp76_ = _tmp75_;
		_tmp77_ = nuvola_args_app;
		_tmp78_ = e;
		_tmp79_ = _tmp78_->message;
		_tmp80_ = nuvola_quit (2, "Error: Failed to connect to %s instance for %s. %s\n", _tmp76_, _tmp77_, _tmp79_);
		_g_free0 (_tmp76_);
		result = _tmp80_;
		_g_error_free0 (e);
		_g_object_unref0 (socket);
		_g_object_unref0 (client);
		_fclose0 (log);
		return result;
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp81_ = 0;
		_g_object_unref0 (socket);
		_g_object_unref0 (client);
		_fclose0 (log);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp81_;
	}
	_tmp82_ = socket;
	if (_tmp82_ == NULL) {
		gchar* _tmp83_;
		gchar* _tmp84_;
		const gchar* _tmp85_;
		gint _tmp86_;
		_tmp83_ = nuvola_get_app_name ();
		_tmp84_ = _tmp83_;
		_tmp85_ = nuvola_args_app;
		_tmp86_ = nuvola_quit (2, "Error: Failed to connect to %s instance for %s. Null socket.\n", _tmp84_, _tmp85_);
		_g_free0 (_tmp84_);
		result = _tmp86_;
		_g_object_unref0 (socket);
		_g_object_unref0 (client);
		_fclose0 (log);
		return result;
	}
	{
		DrtSocketChannel* _tmp87_ = NULL;
		GSocket* _tmp88_;
		DrtSocketChannel* _tmp89_;
		DrtRpcChannel* _tmp90_;
		_tmp88_ = socket;
		_tmp89_ = drt_socket_channel_new_from_socket ((guint) 2, _tmp88_, (guint) 500, &_inner_error_);
		_tmp87_ = _tmp89_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch4_g_error;
		}
		_tmp90_ = drt_rpc_channel_new ((guint) 2, (DrtDuplexChannel*) _tmp87_, NULL, NULL);
		_g_object_unref0 (client);
		client = _tmp90_;
		_g_object_unref0 (_tmp87_);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		gchar* _tmp91_;
		gchar* _tmp92_;
		const gchar* _tmp93_;
		GError* _tmp94_;
		const gchar* _tmp95_;
		gint _tmp96_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp91_ = nuvola_get_app_name ();
		_tmp92_ = _tmp91_;
		_tmp93_ = nuvola_args_app;
		_tmp94_ = e;
		_tmp95_ = _tmp94_->message;
		_tmp96_ = nuvola_quit (2, "Error: Failed to connect to %s instance for %s. %s\n", _tmp92_, _tmp93_, _tmp95_);
		_g_free0 (_tmp92_);
		result = _tmp96_;
		_g_error_free0 (e);
		_g_object_unref0 (socket);
		_g_object_unref0 (client);
		_fclose0 (log);
		return result;
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp97_ = 0;
		_g_object_unref0 (socket);
		_g_object_unref0 (client);
		_fclose0 (log);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp97_;
	}
	_tmp98_ = nuvola_args_command;
	_tmp98__length1 = _vala_array_length (nuvola_args_command);
	_tmp99_ = _tmp98_[0];
	_tmp100_ = g_strdup (_tmp99_);
	command = _tmp100_;
	_tmp101_ = client;
	_tmp102_ = nuvola_control_new (_tmp101_);
	control = _tmp102_;
	{
		const gchar* _tmp103_;
		const gchar* _tmp104_;
		GQuark _tmp106_ = 0U;
		static GQuark _tmp105_label0 = 0;
		static GQuark _tmp105_label1 = 0;
		static GQuark _tmp105_label2 = 0;
		static GQuark _tmp105_label3 = 0;
		static GQuark _tmp105_label4 = 0;
		static GQuark _tmp105_label5 = 0;
		_tmp103_ = command;
		_tmp104_ = _tmp103_;
		_tmp106_ = (NULL == _tmp104_) ? 0 : g_quark_from_string (_tmp104_);
		if (_tmp106_ == ((0 != _tmp105_label0) ? _tmp105_label0 : (_tmp105_label0 = g_quark_from_static_string ("action")))) {
			switch (0) {
				default:
				{
					gchar** _tmp107_;
					gint _tmp107__length1;
					const gchar* _tmp108_ = NULL;
					gchar** _tmp109_;
					gint _tmp109__length1;
					gint _tmp112_ = 0;
					NuvolaControl* _tmp113_;
					gchar** _tmp114_;
					gint _tmp114__length1;
					const gchar* _tmp115_;
					_tmp107_ = nuvola_args_command;
					_tmp107__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp107__length1 < 2) {
						result = nuvola_quit (1, "Error: No action specified.\n");
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					_tmp109_ = nuvola_args_command;
					_tmp109__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp109__length1 == 2) {
						_tmp108_ = NULL;
					} else {
						gchar** _tmp110_;
						gint _tmp110__length1;
						const gchar* _tmp111_;
						_tmp110_ = nuvola_args_command;
						_tmp110__length1 = _vala_array_length (nuvola_args_command);
						_tmp111_ = _tmp110_[2];
						_tmp108_ = _tmp111_;
					}
					_tmp113_ = control;
					_tmp114_ = nuvola_args_command;
					_tmp114__length1 = _vala_array_length (nuvola_args_command);
					_tmp115_ = _tmp114_[1];
					_tmp112_ = nuvola_control_activate_action (_tmp113_, _tmp115_, _tmp108_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch5_g_error;
					}
					result = _tmp112_;
					_nuvola_control_unref0 (control);
					_g_free0 (command);
					_g_object_unref0 (socket);
					_g_object_unref0 (client);
					_fclose0 (log);
					return result;
				}
			}
		} else if (_tmp106_ == ((0 != _tmp105_label1) ? _tmp105_label1 : (_tmp105_label1 = g_quark_from_static_string ("list-actions")))) {
			switch (0) {
				default:
				{
					gchar** _tmp116_;
					gint _tmp116__length1;
					gint _tmp117_ = 0;
					NuvolaControl* _tmp118_;
					_tmp116_ = nuvola_args_command;
					_tmp116__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp116__length1 > 1) {
						result = nuvola_quit (1, "Error: Too many arguments.\n");
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					_tmp118_ = control;
					_tmp117_ = nuvola_control_list_actions (_tmp118_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch5_g_error;
					}
					result = _tmp117_;
					_nuvola_control_unref0 (control);
					_g_free0 (command);
					_g_object_unref0 (socket);
					_g_object_unref0 (client);
					_fclose0 (log);
					return result;
				}
			}
		} else if (_tmp106_ == ((0 != _tmp105_label2) ? _tmp105_label2 : (_tmp105_label2 = g_quark_from_static_string ("action-state")))) {
			switch (0) {
				default:
				{
					gchar** _tmp119_;
					gint _tmp119__length1;
					gint _tmp120_ = 0;
					NuvolaControl* _tmp121_;
					gchar** _tmp122_;
					gint _tmp122__length1;
					const gchar* _tmp123_;
					_tmp119_ = nuvola_args_command;
					_tmp119__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp119__length1 < 2) {
						result = nuvola_quit (1, "Error: No action specified.\n");
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					_tmp121_ = control;
					_tmp122_ = nuvola_args_command;
					_tmp122__length1 = _vala_array_length (nuvola_args_command);
					_tmp123_ = _tmp122_[1];
					_tmp120_ = nuvola_control_action_state (_tmp121_, _tmp123_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch5_g_error;
					}
					result = _tmp120_;
					_nuvola_control_unref0 (control);
					_g_free0 (command);
					_g_object_unref0 (socket);
					_g_object_unref0 (client);
					_fclose0 (log);
					return result;
				}
			}
		} else if (_tmp106_ == ((0 != _tmp105_label3) ? _tmp105_label3 : (_tmp105_label3 = g_quark_from_static_string ("track-info")))) {
			switch (0) {
				default:
				{
					gchar** _tmp124_;
					gint _tmp124__length1;
					const gchar* _tmp125_ = NULL;
					gchar** _tmp126_;
					gint _tmp126__length1;
					gint _tmp129_ = 0;
					NuvolaControl* _tmp130_;
					_tmp124_ = nuvola_args_command;
					_tmp124__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp124__length1 > 2) {
						result = nuvola_quit (1, "Error: Too many arguments.\n");
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					_tmp126_ = nuvola_args_command;
					_tmp126__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp126__length1 == 2) {
						gchar** _tmp127_;
						gint _tmp127__length1;
						const gchar* _tmp128_;
						_tmp127_ = nuvola_args_command;
						_tmp127__length1 = _vala_array_length (nuvola_args_command);
						_tmp128_ = _tmp127_[1];
						_tmp125_ = _tmp128_;
					} else {
						_tmp125_ = NULL;
					}
					_tmp130_ = control;
					_tmp129_ = nuvola_control_track_info (_tmp130_, _tmp125_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch5_g_error;
					}
					result = _tmp129_;
					_nuvola_control_unref0 (control);
					_g_free0 (command);
					_g_object_unref0 (socket);
					_g_object_unref0 (client);
					_fclose0 (log);
					return result;
				}
			}
		} else if (_tmp106_ == ((0 != _tmp105_label4) ? _tmp105_label4 : (_tmp105_label4 = g_quark_from_static_string ("api-master")))) {
			switch (0) {
				default:
				{
					gchar** _tmp131_;
					gint _tmp131__length1;
					_tmp131_ = nuvola_args_command;
					_tmp131__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp131__length1 < 2) {
						result = nuvola_quit (1, "Error: No API method specified.\n");
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					{
						DrtRpcChannel* master = NULL;
						gchar* _tmp132_;
						gchar* _tmp133_;
						DrtRpcChannel* _tmp134_;
						DrtRpcChannel* _tmp135_;
						gint _tmp136_ = 0;
						DrtRpcChannel* _tmp137_;
						gchar** _tmp138_;
						gint _tmp138__length1;
						_tmp132_ = nuvola_build_master_ipc_id ();
						_tmp133_ = _tmp132_;
						_tmp134_ = drt_rpc_channel_new_from_name ((guint) 1, _tmp133_, NULL, NULL, (guint) 500, &_inner_error_);
						_tmp135_ = _tmp134_;
						_g_free0 (_tmp133_);
						master = _tmp135_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							goto __catch6_g_error;
						}
						_tmp137_ = master;
						_tmp138_ = nuvola_args_command;
						_tmp138__length1 = _vala_array_length (nuvola_args_command);
						_tmp136_ = nuvola_call_api_method (_tmp137_, _tmp138_, _tmp138__length1, 1, &_inner_error_);
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							_g_object_unref0 (master);
							goto __catch6_g_error;
						}
						result = _tmp136_;
						_g_object_unref0 (master);
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					goto __finally6;
					__catch6_g_error:
					{
						GError* e = NULL;
						gchar* _tmp139_;
						gchar* _tmp140_;
						GError* _tmp141_;
						const gchar* _tmp142_;
						gint _tmp143_;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp139_ = nuvola_get_app_name ();
						_tmp140_ = _tmp139_;
						_tmp141_ = e;
						_tmp142_ = _tmp141_->message;
						_tmp143_ = nuvola_quit (2, "Error: Communication with %s master instance failed: %s\n", _tmp140_, _tmp142_);
						_g_free0 (_tmp140_);
						result = _tmp143_;
						_g_error_free0 (e);
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					__finally6:
					goto __catch5_g_error;
				}
			}
		} else if (_tmp106_ == ((0 != _tmp105_label5) ? _tmp105_label5 : (_tmp105_label5 = g_quark_from_static_string ("api-app")))) {
			switch (0) {
				default:
				{
					gchar** _tmp144_;
					gint _tmp144__length1;
					_tmp144_ = nuvola_args_command;
					_tmp144__length1 = _vala_array_length (nuvola_args_command);
					if (_tmp144__length1 < 2) {
						result = nuvola_quit (1, "Error: No API method specified.\n");
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					{
						gint _tmp145_ = 0;
						DrtRpcChannel* _tmp146_;
						gchar** _tmp147_;
						gint _tmp147__length1;
						_tmp146_ = client;
						_tmp147_ = nuvola_args_command;
						_tmp147__length1 = _vala_array_length (nuvola_args_command);
						_tmp145_ = nuvola_call_api_method (_tmp146_, _tmp147_, _tmp147__length1, 1, &_inner_error_);
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							goto __catch7_g_error;
						}
						result = _tmp145_;
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					goto __finally7;
					__catch7_g_error:
					{
						GError* e = NULL;
						gchar* _tmp148_;
						gchar* _tmp149_;
						const gchar* _tmp150_;
						GError* _tmp151_;
						const gchar* _tmp152_;
						gint _tmp153_;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp148_ = nuvola_get_app_name ();
						_tmp149_ = _tmp148_;
						_tmp150_ = nuvola_args_app;
						_tmp151_ = e;
						_tmp152_ = _tmp151_->message;
						_tmp153_ = nuvola_quit (2, "Error: Communication with %s instance for %s failed. %s\n", _tmp149_, _tmp150_, _tmp152_);
						_g_free0 (_tmp149_);
						result = _tmp153_;
						_g_error_free0 (e);
						_nuvola_control_unref0 (control);
						_g_free0 (command);
						_g_object_unref0 (socket);
						_g_object_unref0 (client);
						_fclose0 (log);
						return result;
					}
					__finally7:
					goto __catch5_g_error;
				}
			}
		} else {
			switch (0) {
				default:
				{
					const gchar* _tmp154_;
					_tmp154_ = command;
					result = nuvola_quit (1, "Error: Unknown command '%s'.\n", _tmp154_);
					_nuvola_control_unref0 (control);
					_g_free0 (command);
					_g_object_unref0 (socket);
					_g_object_unref0 (client);
					_fclose0 (log);
					return result;
				}
			}
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		gchar* _tmp155_;
		gchar* _tmp156_;
		GError* _tmp157_;
		const gchar* _tmp158_;
		gint _tmp159_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp155_ = nuvola_get_app_name ();
		_tmp156_ = _tmp155_;
		_tmp157_ = e;
		_tmp158_ = _tmp157_->message;
		_tmp159_ = nuvola_quit (2, "Error: Communication with %s instance failed: %s\n", _tmp156_, _tmp158_);
		_g_free0 (_tmp156_);
		result = _tmp159_;
		_g_error_free0 (e);
		_nuvola_control_unref0 (control);
		_g_free0 (command);
		_g_object_unref0 (socket);
		_g_object_unref0 (client);
		_fclose0 (log);
		return result;
	}
	__finally5:
	_nuvola_control_unref0 (control);
	_g_free0 (command);
	_g_object_unref0 (socket);
	_g_object_unref0 (client);
	_fclose0 (log);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return _tmp160_;
}


int
main (int argc,
      char ** argv)
{
	return nuvola_main (argv, argc);
}


static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}


gint
nuvola_call_api_method (DrtRpcChannel* connection,
                        gchar** args,
                        int args_length1,
                        gint offset,
                        GError** error)
{
	gint result = 0;
	GVariant* response = NULL;
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (connection != NULL, 0);
	_tmp0_ = args[offset];
	_tmp1_ = drt_strv_to_variant_dict (args, args_length1, offset + 1);
	_tmp2_ = _tmp1_;
	_tmp3_ = drt_rpc_connection_call_sync ((DrtRpcConnection*) connection, _tmp0_, _tmp2_, &_inner_error_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	response = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp5_ = 0;
		g_propagate_error (error, _inner_error_);
		return _tmp5_;
	}
	if (response != NULL) {
		JsonNode* node = NULL;
		JsonNode* _tmp6_;
		JsonGenerator* generator = NULL;
		JsonGenerator* _tmp7_;
		JsonGenerator* _tmp8_;
		JsonGenerator* _tmp9_;
		JsonNode* _tmp10_;
		gchar* data = NULL;
		JsonGenerator* _tmp11_;
		gchar* _tmp12_;
		FILE* _tmp13_;
		const gchar* _tmp14_;
		_tmp6_ = json_gvariant_serialize (response);
		node = _tmp6_;
		_tmp7_ = json_generator_new ();
		generator = _tmp7_;
		_tmp8_ = generator;
		json_generator_set_pretty (_tmp8_, TRUE);
		_tmp9_ = generator;
		_tmp10_ = node;
		json_generator_set_root (_tmp9_, _tmp10_);
		_tmp11_ = generator;
		_tmp12_ = json_generator_to_data (_tmp11_, NULL);
		data = _tmp12_;
		_tmp13_ = stdout;
		_tmp14_ = data;
		fprintf (_tmp13_, "%s\n", _tmp14_);
		_g_free0 (data);
		_g_object_unref0 (generator);
		__vala_JsonNode_free0 (node);
	}
	result = 0;
	_g_variant_unref0 (response);
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


NuvolaControl*
nuvola_control_construct (GType object_type,
                          DrtRpcChannel* conn)
{
	NuvolaControl* self = NULL;
	DrtRpcChannel* _tmp0_;
	g_return_val_if_fail (conn != NULL, NULL);
	self = (NuvolaControl*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (conn);
	_g_object_unref0 (self->priv->conn);
	self->priv->conn = _tmp0_;
	return self;
}


NuvolaControl*
nuvola_control_new (DrtRpcChannel* conn)
{
	return nuvola_control_construct (NUVOLA_TYPE_CONTROL, conn);
}


gint
nuvola_control_list_actions (NuvolaControl* self,
                             GError** error)
{
	gint result = 0;
	GVariant* response = NULL;
	DrtRpcChannel* _tmp0_;
	GVariant* _tmp1_;
	FILE* _tmp3_;
	GVariantIter* iter = NULL;
	GVariant* _tmp4_;
	GVariantIter* _tmp5_;
	gchar* group_name = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->conn;
	_tmp1_ = drt_rpc_connection_call_sync ((DrtRpcConnection*) _tmp0_, "/nuvola/actions/list-groups", NULL, &_inner_error_);
	response = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp2_ = 0;
		g_propagate_error (error, _inner_error_);
		return _tmp2_;
	}
	_tmp3_ = stdout;
	fprintf (_tmp3_, "Available actions\n\nFormat: NAME (is enabled?) - label\n");
	_tmp4_ = response;
	_tmp5_ = g_variant_iter_new (_tmp4_);
	iter = _tmp5_;
	group_name = NULL;
	while (TRUE) {
		GVariantIter* _tmp6_;
		FILE* _tmp7_;
		const gchar* _tmp8_;
		GVariant* actions = NULL;
		DrtRpcChannel* _tmp9_;
		const gchar* _tmp10_;
		GVariant* _tmp11_;
		GVariant* _tmp12_;
		GVariant* _tmp13_;
		GVariant* _tmp14_;
		GVariant* action = NULL;
		GVariantIter* actions_iter = NULL;
		GVariant* _tmp16_;
		GVariantIter* _tmp17_;
		_tmp6_ = iter;
		if (!g_variant_iter_next (_tmp6_, "s", &group_name, NULL)) {
			break;
		}
		_tmp7_ = stdout;
		_tmp8_ = group_name;
		fprintf (_tmp7_, "\nGroup: %s\n\n", _tmp8_);
		_tmp9_ = self->priv->conn;
		_tmp10_ = group_name;
		_tmp11_ = g_variant_new ("(s)", _tmp10_, NULL);
		g_variant_ref_sink (_tmp11_);
		_tmp12_ = _tmp11_;
		_tmp13_ = drt_rpc_connection_call_sync ((DrtRpcConnection*) _tmp9_, "/nuvola/actions/list-group-actions", _tmp12_, &_inner_error_);
		_tmp14_ = _tmp13_;
		_g_variant_unref0 (_tmp12_);
		actions = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp15_ = 0;
			g_propagate_error (error, _inner_error_);
			_g_free0 (group_name);
			_g_variant_iter_free0 (iter);
			_g_variant_unref0 (response);
			return _tmp15_;
		}
		action = NULL;
		_tmp16_ = actions;
		_tmp17_ = g_variant_iter_new (_tmp16_);
		actions_iter = _tmp17_;
		while (TRUE) {
			GVariantIter* _tmp18_;
			gchar* name = NULL;
			gchar* label = NULL;
			gboolean enabled = FALSE;
			GVariant* options = NULL;
			GVariant* _tmp19_;
			GVariant* _tmp20_;
			GVariant* _tmp21_;
			GVariant* _tmp22_;
			_tmp18_ = actions_iter;
			if (!g_variant_iter_next (_tmp18_, "@*", &action, NULL)) {
				break;
			}
			name = NULL;
			label = NULL;
			enabled = FALSE;
			options = NULL;
			_tmp19_ = action;
			_vala_assert (g_variant_lookup (_tmp19_, "name", "s", &name, NULL), "action.lookup(\"name\", \"s\", out name)");
			_tmp20_ = action;
			_vala_assert (g_variant_lookup (_tmp20_, "label", "s", &label, NULL), "action.lookup(\"label\", \"s\", out label)");
			_tmp21_ = action;
			_vala_assert (g_variant_lookup (_tmp21_, "enabled", "b", &enabled, NULL), "action.lookup(\"enabled\", \"b\", out enabled)");
			_tmp22_ = action;
			if (g_variant_lookup (_tmp22_, "options", "@*", &options, NULL)) {
				const gchar* _tmp23_ = NULL;
				gboolean _tmp24_;
				FILE* _tmp25_;
				const gchar* _tmp26_;
				GVariant* option = NULL;
				GVariantIter* options_iter = NULL;
				GVariant* _tmp27_;
				GVariantIter* _tmp28_;
				_tmp24_ = enabled;
				if (_tmp24_) {
					_tmp23_ = "enabled";
				} else {
					_tmp23_ = "disabled";
				}
				_tmp25_ = stdout;
				_tmp26_ = name;
				fprintf (_tmp25_, " *  %s (%s) - %s\n", _tmp26_, _tmp23_, "invoke with following parameters:");
				option = NULL;
				_tmp27_ = options;
				_tmp28_ = g_variant_iter_new (_tmp27_);
				options_iter = _tmp28_;
				while (TRUE) {
					GVariantIter* _tmp29_;
					GVariant* parameter = NULL;
					GVariant* _tmp30_;
					GVariant* _tmp31_;
					const gchar* _tmp32_ = NULL;
					const gchar* _tmp33_;
					FILE* _tmp35_;
					const gchar* _tmp36_;
					GVariant* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
					_tmp29_ = options_iter;
					if (!g_variant_iter_next (_tmp29_, "@*", &option, NULL)) {
						break;
					}
					parameter = NULL;
					_tmp30_ = option;
					_vala_assert (g_variant_lookup (_tmp30_, "param", "@*", &parameter, NULL), "option.lookup(\"param\", \"@*\", out parameter)");
					_tmp31_ = option;
					_vala_assert (g_variant_lookup (_tmp31_, "label", "s", &label, NULL), "option.lookup(\"label\", \"s\", out label)");
					_tmp33_ = label;
					if (g_strcmp0 (_tmp33_, "") != 0) {
						const gchar* _tmp34_;
						_tmp34_ = label;
						_tmp32_ = _tmp34_;
					} else {
						_tmp32_ = "(No label specified.)";
					}
					_tmp35_ = stdout;
					_tmp36_ = name;
					_tmp37_ = parameter;
					_tmp38_ = g_variant_print (_tmp37_, FALSE);
					_tmp39_ = _tmp38_;
					fprintf (_tmp35_, "    %s %s - %s\n", _tmp36_, _tmp39_, _tmp32_);
					_g_free0 (_tmp39_);
					_g_variant_unref0 (parameter);
				}
				_g_variant_iter_free0 (options_iter);
				_g_variant_unref0 (option);
			} else {
				const gchar* _tmp40_ = NULL;
				gboolean _tmp41_;
				const gchar* _tmp42_ = NULL;
				const gchar* _tmp43_;
				FILE* _tmp45_;
				const gchar* _tmp46_;
				_tmp41_ = enabled;
				if (_tmp41_) {
					_tmp40_ = "enabled";
				} else {
					_tmp40_ = "disabled";
				}
				_tmp43_ = label;
				if (g_strcmp0 (_tmp43_, "") != 0) {
					const gchar* _tmp44_;
					_tmp44_ = label;
					_tmp42_ = _tmp44_;
				} else {
					_tmp42_ = "(No label specified.)";
				}
				_tmp45_ = stdout;
				_tmp46_ = name;
				fprintf (_tmp45_, " *  %s (%s) - %s\n", _tmp46_, _tmp40_, _tmp42_);
			}
			_g_variant_unref0 (options);
			_g_free0 (label);
			_g_free0 (name);
		}
		_g_variant_iter_free0 (actions_iter);
		_g_variant_unref0 (action);
		_g_variant_unref0 (actions);
	}
	result = 0;
	_g_free0 (group_name);
	_g_variant_iter_free0 (iter);
	_g_variant_unref0 (response);
	return result;
}


static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}


gint
nuvola_control_activate_action (NuvolaControl* self,
                                const gchar* name,
                                const gchar* parameter_str,
                                GError** error)
{
	gint result = 0;
	GVariant* parameter = NULL;
	GVariant* response = NULL;
	DrtRpcChannel* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GVariant** _tmp13_;
	GVariant** _tmp14_;
	gint _tmp14__length1;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	gboolean handled = FALSE;
	GVariant* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp30_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (name != NULL, 0);
	{
		GVariant* _tmp0_ = NULL;
		GVariant* _tmp5_;
		if (parameter_str == NULL) {
			const GVariantType* _tmp1_;
			GVariant* _tmp2_;
			_tmp1_ = G_VARIANT_TYPE_BYTE;
			_tmp2_ = g_variant_new_maybe (_tmp1_, NULL);
			g_variant_ref_sink (_tmp2_);
			_g_variant_unref0 (_tmp0_);
			_tmp0_ = _tmp2_;
		} else {
			GVariant* _tmp3_;
			_tmp3_ = g_variant_parse (NULL, parameter_str, NULL, NULL, &_inner_error_);
			_g_variant_unref0 (_tmp0_);
			_tmp0_ = _tmp3_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				gint _tmp4_ = 0;
				_g_variant_unref0 (_tmp0_);
				if (_inner_error_->domain == G_VARIANT_PARSE_ERROR) {
					goto __catch8_g_variant_parse_error;
				}
				_g_variant_unref0 (_tmp0_);
				_g_variant_unref0 (parameter);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return _tmp4_;
			}
		}
		_tmp5_ = _g_variant_ref0 (_tmp0_);
		_g_variant_unref0 (parameter);
		parameter = _tmp5_;
		_g_variant_unref0 (_tmp0_);
	}
	goto __finally8;
	__catch8_g_variant_parse_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		result = nuvola_quit (1, "Failed to parse Variant from string %s: %s\n\n" "See https://developer.gnome.org/glib/stable/gvariant-text.html for for" \
"mat specification.\n", parameter_str, _tmp7_);
		_g_error_free0 (e);
		_g_variant_unref0 (parameter);
		return result;
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp8_ = 0;
		g_propagate_error (error, _inner_error_);
		_g_variant_unref0 (parameter);
		return _tmp8_;
	}
	_tmp9_ = self->priv->conn;
	_tmp10_ = g_variant_new_string (name);
	g_variant_ref_sink (_tmp10_);
	_tmp11_ = parameter;
	_tmp12_ = _g_variant_ref0 (_tmp11_);
	_tmp13_ = g_new0 (GVariant*, 2 + 1);
	_tmp13_[0] = _tmp10_;
	_tmp13_[1] = _tmp12_;
	_tmp14_ = _tmp13_;
	_tmp14__length1 = 2;
	_tmp15_ = g_variant_new_tuple (_tmp14_, 2);
	g_variant_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	_tmp17_ = drt_rpc_connection_call_sync ((DrtRpcConnection*) _tmp9_, "/nuvola/actions/activate", _tmp16_, &_inner_error_);
	_tmp18_ = _tmp17_;
	_g_variant_unref0 (_tmp16_);
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_variant_unref), NULL);
	response = _tmp18_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp19_ = 0;
		g_propagate_error (error, _inner_error_);
		_g_variant_unref0 (parameter);
		return _tmp19_;
	}
	handled = FALSE;
	_tmp20_ = response;
	_tmp21_ = drt_variant_bool (_tmp20_, &handled);
	if (!_tmp21_) {
		gchar* _tmp22_ = NULL;
		GVariant* _tmp23_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gint _tmp29_;
		_tmp23_ = response;
		if (_tmp23_ == NULL) {
			gchar* _tmp24_;
			_tmp24_ = g_strdup ("null");
			_g_free0 (_tmp22_);
			_tmp22_ = _tmp24_;
		} else {
			GVariant* _tmp25_;
			gchar* _tmp26_;
			_tmp25_ = response;
			_tmp26_ = g_variant_print (_tmp25_, TRUE);
			_g_free0 (_tmp22_);
			_tmp22_ = _tmp26_;
		}
		_tmp27_ = nuvola_get_app_name ();
		_tmp28_ = _tmp27_;
		_tmp29_ = nuvola_quit (2, "Got invalid response from %s instance: %s\n", _tmp28_, _tmp22_);
		_g_free0 (_tmp28_);
		result = _tmp29_;
		_g_free0 (_tmp22_);
		_g_variant_unref0 (response);
		_g_variant_unref0 (parameter);
		return result;
	}
	_tmp30_ = handled;
	if (!_tmp30_) {
		gchar* _tmp31_;
		gchar* _tmp32_;
		gint _tmp33_;
		_tmp31_ = nuvola_get_app_name ();
		_tmp32_ = _tmp31_;
		_tmp33_ = nuvola_quit (3, "%s instance doesn't understand requested action '%s'.\n", _tmp32_, name);
		_g_free0 (_tmp32_);
		result = _tmp33_;
		_g_variant_unref0 (response);
		_g_variant_unref0 (parameter);
		return result;
	}
	g_message ("control.vala:311: Action %s %s was successful.", name, parameter_str);
	result = 0;
	_g_variant_unref0 (response);
	_g_variant_unref0 (parameter);
	return result;
}


gint
nuvola_control_action_state (NuvolaControl* self,
                             const gchar* name,
                             GError** error)
{
	gint result = 0;
	GVariant* response = NULL;
	DrtRpcChannel* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (name != NULL, 0);
	_tmp0_ = self->priv->conn;
	_tmp1_ = g_variant_new ("(s)", name, NULL);
	g_variant_ref_sink (_tmp1_);
	_tmp2_ = _tmp1_;
	_tmp3_ = drt_rpc_connection_call_sync ((DrtRpcConnection*) _tmp0_, "/nuvola/actions/get-state", _tmp2_, &_inner_error_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	response = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp5_ = 0;
		g_propagate_error (error, _inner_error_);
		return _tmp5_;
	}
	if (response != NULL) {
		FILE* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp6_ = stdout;
		_tmp7_ = g_variant_print (response, FALSE);
		_tmp8_ = _tmp7_;
		fprintf (_tmp6_, "%s\n", _tmp8_);
		_g_free0 (_tmp8_);
	}
	result = 0;
	_g_variant_unref0 (response);
	return result;
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gint
nuvola_control_track_info (NuvolaControl* self,
                           const gchar* key,
                           GError** error)
{
	gint result = 0;
	GVariant* response = NULL;
	DrtRpcChannel* _tmp0_;
	GVariant* _tmp1_;
	gchar* title = NULL;
	GVariant* _tmp3_;
	gchar* _tmp4_;
	gchar* artist = NULL;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* album = NULL;
	GVariant* _tmp7_;
	gchar* _tmp8_;
	gchar* state = NULL;
	GVariant* _tmp9_;
	gchar* _tmp10_;
	gchar* artwork_location = NULL;
	GVariant* _tmp11_;
	gchar* _tmp12_;
	gchar* artwork_file = NULL;
	GVariant* _tmp13_;
	gchar* _tmp14_;
	gdouble rating = 0.0;
	GVariant* _tmp15_;
	gboolean _tmp16_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->conn;
	_tmp1_ = drt_rpc_connection_call_sync ((DrtRpcConnection*) _tmp0_, "/nuvola/mediaplayer/track-info", NULL, &_inner_error_);
	response = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp2_ = 0;
		g_propagate_error (error, _inner_error_);
		return _tmp2_;
	}
	_tmp3_ = response;
	_tmp4_ = drt_variant_dict_str (_tmp3_, "title");
	title = _tmp4_;
	_tmp5_ = response;
	_tmp6_ = drt_variant_dict_str (_tmp5_, "artist");
	artist = _tmp6_;
	_tmp7_ = response;
	_tmp8_ = drt_variant_dict_str (_tmp7_, "album");
	album = _tmp8_;
	_tmp9_ = response;
	_tmp10_ = drt_variant_dict_str (_tmp9_, "state");
	state = _tmp10_;
	_tmp11_ = response;
	_tmp12_ = drt_variant_dict_str (_tmp11_, "artworkLocation");
	artwork_location = _tmp12_;
	_tmp13_ = response;
	_tmp14_ = drt_variant_dict_str (_tmp13_, "artworkFile");
	artwork_file = _tmp14_;
	_tmp15_ = response;
	rating = drt_variant_dict_double (_tmp15_, "rating", 0.0);
	if (key == NULL) {
		_tmp16_ = TRUE;
	} else {
		_tmp16_ = g_strcmp0 (key, "all") == 0;
	}
	if (_tmp16_) {
		const gchar* _tmp17_;
		const gchar* _tmp20_;
		const gchar* _tmp23_;
		const gchar* _tmp26_;
		const gchar* _tmp29_;
		const gchar* _tmp32_;
		gdouble _tmp35_;
		_tmp17_ = title;
		if (_tmp17_ != NULL) {
			FILE* _tmp18_;
			const gchar* _tmp19_;
			_tmp18_ = stdout;
			_tmp19_ = title;
			fprintf (_tmp18_, "Title: %s\n", _tmp19_);
		}
		_tmp20_ = artist;
		if (_tmp20_ != NULL) {
			FILE* _tmp21_;
			const gchar* _tmp22_;
			_tmp21_ = stdout;
			_tmp22_ = artist;
			fprintf (_tmp21_, "Artist: %s\n", _tmp22_);
		}
		_tmp23_ = album;
		if (_tmp23_ != NULL) {
			FILE* _tmp24_;
			const gchar* _tmp25_;
			_tmp24_ = stdout;
			_tmp25_ = album;
			fprintf (_tmp24_, "Album: %s\n", _tmp25_);
		}
		_tmp26_ = state;
		if (_tmp26_ != NULL) {
			FILE* _tmp27_;
			const gchar* _tmp28_;
			_tmp27_ = stdout;
			_tmp28_ = state;
			fprintf (_tmp27_, "State: %s\n", _tmp28_);
		}
		_tmp29_ = artwork_location;
		if (_tmp29_ != NULL) {
			FILE* _tmp30_;
			const gchar* _tmp31_;
			_tmp30_ = stdout;
			_tmp31_ = artwork_location;
			fprintf (_tmp30_, "Artwork location: %s\n", _tmp31_);
		}
		_tmp32_ = artwork_file;
		if (_tmp32_ != NULL) {
			FILE* _tmp33_;
			const gchar* _tmp34_;
			_tmp33_ = stdout;
			_tmp34_ = artwork_file;
			fprintf (_tmp33_, "Artwork file: %s\n", _tmp34_);
		}
		_tmp35_ = rating;
		if (_tmp35_ != 0.0) {
			FILE* _tmp36_;
			gdouble _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			_tmp36_ = stdout;
			_tmp37_ = rating;
			_tmp38_ = double_to_string (_tmp37_);
			_tmp39_ = _tmp38_;
			fprintf (_tmp36_, "Rating: %s\n", _tmp39_);
			_g_free0 (_tmp39_);
		}
	} else {
		const gchar* _tmp40_;
		GQuark _tmp42_ = 0U;
		static GQuark _tmp41_label0 = 0;
		static GQuark _tmp41_label1 = 0;
		static GQuark _tmp41_label2 = 0;
		static GQuark _tmp41_label3 = 0;
		static GQuark _tmp41_label4 = 0;
		static GQuark _tmp41_label5 = 0;
		static GQuark _tmp41_label6 = 0;
		_tmp40_ = key;
		_tmp42_ = (NULL == _tmp40_) ? 0 : g_quark_from_string (_tmp40_);
		if (_tmp42_ == ((0 != _tmp41_label0) ? _tmp41_label0 : (_tmp41_label0 = g_quark_from_static_string ("title")))) {
			switch (0) {
				default:
				{
					const gchar* _tmp43_;
					_tmp43_ = title;
					if (_tmp43_ != NULL) {
						FILE* _tmp44_;
						const gchar* _tmp45_;
						_tmp44_ = stdout;
						_tmp45_ = title;
						fprintf (_tmp44_, "%s\n", _tmp45_);
					}
					break;
				}
			}
		} else if (_tmp42_ == ((0 != _tmp41_label1) ? _tmp41_label1 : (_tmp41_label1 = g_quark_from_static_string ("artist")))) {
			switch (0) {
				default:
				{
					const gchar* _tmp46_;
					_tmp46_ = artist;
					if (_tmp46_ != NULL) {
						FILE* _tmp47_;
						const gchar* _tmp48_;
						_tmp47_ = stdout;
						_tmp48_ = artist;
						fprintf (_tmp47_, "%s\n", _tmp48_);
					}
					break;
				}
			}
		} else if (_tmp42_ == ((0 != _tmp41_label2) ? _tmp41_label2 : (_tmp41_label2 = g_quark_from_static_string ("album")))) {
			switch (0) {
				default:
				{
					const gchar* _tmp49_;
					_tmp49_ = album;
					if (_tmp49_ != NULL) {
						FILE* _tmp50_;
						const gchar* _tmp51_;
						_tmp50_ = stdout;
						_tmp51_ = album;
						fprintf (_tmp50_, "%s\n", _tmp51_);
					}
					break;
				}
			}
		} else if (_tmp42_ == ((0 != _tmp41_label3) ? _tmp41_label3 : (_tmp41_label3 = g_quark_from_static_string ("state")))) {
			switch (0) {
				default:
				{
					const gchar* _tmp52_;
					_tmp52_ = state;
					if (_tmp52_ != NULL) {
						FILE* _tmp53_;
						const gchar* _tmp54_;
						_tmp53_ = stdout;
						_tmp54_ = state;
						fprintf (_tmp53_, "%s\n", _tmp54_);
					}
					break;
				}
			}
		} else if (_tmp42_ == ((0 != _tmp41_label4) ? _tmp41_label4 : (_tmp41_label4 = g_quark_from_static_string ("artwork_location")))) {
			switch (0) {
				default:
				{
					const gchar* _tmp55_;
					_tmp55_ = artwork_location;
					if (_tmp55_ != NULL) {
						FILE* _tmp56_;
						const gchar* _tmp57_;
						_tmp56_ = stdout;
						_tmp57_ = artwork_location;
						fprintf (_tmp56_, "%s\n", _tmp57_);
					}
					break;
				}
			}
		} else if (_tmp42_ == ((0 != _tmp41_label5) ? _tmp41_label5 : (_tmp41_label5 = g_quark_from_static_string ("artwork_file")))) {
			switch (0) {
				default:
				{
					const gchar* _tmp58_;
					_tmp58_ = artwork_file;
					if (_tmp58_ != NULL) {
						FILE* _tmp59_;
						const gchar* _tmp60_;
						_tmp59_ = stdout;
						_tmp60_ = artwork_file;
						fprintf (_tmp59_, "%s\n", _tmp60_);
					}
					break;
				}
			}
		} else if (_tmp42_ == ((0 != _tmp41_label6) ? _tmp41_label6 : (_tmp41_label6 = g_quark_from_static_string ("rating")))) {
			switch (0) {
				default:
				{
					gdouble _tmp61_;
					_tmp61_ = rating;
					if (_tmp61_ != 0.0) {
						FILE* _tmp62_;
						gdouble _tmp63_;
						gchar* _tmp64_;
						gchar* _tmp65_;
						_tmp62_ = stdout;
						_tmp63_ = rating;
						_tmp64_ = double_to_string (_tmp63_);
						_tmp65_ = _tmp64_;
						fprintf (_tmp62_, "Rating: %s\n", _tmp65_);
						_g_free0 (_tmp65_);
					}
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					result = nuvola_quit (3, "Unknown key '%s'.\n", key);
					_g_free0 (artwork_file);
					_g_free0 (artwork_location);
					_g_free0 (state);
					_g_free0 (album);
					_g_free0 (artist);
					_g_free0 (title);
					_g_variant_unref0 (response);
					return result;
				}
			}
		}
	}
	result = 0;
	_g_free0 (artwork_file);
	_g_free0 (artwork_location);
	_g_free0 (state);
	_g_free0 (album);
	_g_free0 (artist);
	_g_free0 (title);
	_g_variant_unref0 (response);
	return result;
}


static void
nuvola_value_control_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
nuvola_value_control_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		nuvola_control_unref (value->data[0].v_pointer);
	}
}


static void
nuvola_value_control_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = nuvola_control_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
nuvola_value_control_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
nuvola_value_control_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		NuvolaControl * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = nuvola_control_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
nuvola_value_control_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	NuvolaControl ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = nuvola_control_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
nuvola_param_spec_control (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	NuvolaParamSpecControl* spec;
	g_return_val_if_fail (g_type_is_a (object_type, NUVOLA_TYPE_CONTROL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
nuvola_value_get_control (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_CONTROL), NULL);
	return value->data[0].v_pointer;
}


void
nuvola_value_set_control (GValue* value,
                          gpointer v_object)
{
	NuvolaControl * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_CONTROL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_CONTROL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		nuvola_control_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_control_unref (old);
	}
}


void
nuvola_value_take_control (GValue* value,
                           gpointer v_object)
{
	NuvolaControl * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_CONTROL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_CONTROL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_control_unref (old);
	}
}


static void
nuvola_control_class_init (NuvolaControlClass * klass)
{
	nuvola_control_parent_class = g_type_class_peek_parent (klass);
	((NuvolaControlClass *) klass)->finalize = nuvola_control_finalize;
	g_type_class_add_private (klass, sizeof (NuvolaControlPrivate));
}


static void
nuvola_control_instance_init (NuvolaControl * self)
{
	self->priv = NUVOLA_CONTROL_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void
nuvola_control_finalize (NuvolaControl * obj)
{
	NuvolaControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_CONTROL, NuvolaControl);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->conn);
}


GType
nuvola_control_get_type (void)
{
	static volatile gsize nuvola_control_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_control_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { nuvola_value_control_init, nuvola_value_control_free_value, nuvola_value_control_copy_value, nuvola_value_control_peek_pointer, "p", nuvola_value_control_collect_value, "p", nuvola_value_control_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaControl), 0, (GInstanceInitFunc) nuvola_control_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType nuvola_control_type_id;
		nuvola_control_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NuvolaControl", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&nuvola_control_type_id__volatile, nuvola_control_type_id);
	}
	return nuvola_control_type_id__volatile;
}


gpointer
nuvola_control_ref (gpointer instance)
{
	NuvolaControl * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
nuvola_control_unref (gpointer instance)
{
	NuvolaControl * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		NUVOLA_CONTROL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



