/* VersionTuple.c generated by valac 0.40.6, the Vala compiler
 * generated from VersionTuple.vala, do not modify */

/*
 * Copyright 2017-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>


#define NUVOLA_TYPE_VERSION_TUPLE (nuvola_version_tuple_get_type ())
typedef struct _NuvolaVersionTuple NuvolaVersionTuple;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NuvolaVersionTuple {
	guint major;
	guint minor;
	guint micro;
	guint patch;
};



GType nuvola_version_tuple_get_type (void) G_GNUC_CONST;
NuvolaVersionTuple* nuvola_version_tuple_dup (const NuvolaVersionTuple* self);
void nuvola_version_tuple_free (NuvolaVersionTuple* self);
void nuvola_version_tuple_init (NuvolaVersionTuple *self,
                                guint major,
                                guint minor,
                                guint micro,
                                guint patch);
void nuvola_version_tuple_init_uintv (NuvolaVersionTuple *self,
                                      guint* versions,
                                      int versions_length1);
void nuvola_version_tuple_init_parse (NuvolaVersionTuple *self,
                                      const gchar* version);
gboolean nuvola_version_tuple_empty (NuvolaVersionTuple *self);
gboolean nuvola_version_tuple_gt (NuvolaVersionTuple *self,
                                  NuvolaVersionTuple* other);
gint nuvola_version_tuple_compare (NuvolaVersionTuple *self,
                                   NuvolaVersionTuple* other);
gboolean nuvola_version_tuple_gte (NuvolaVersionTuple *self,
                                   NuvolaVersionTuple* other);
gboolean nuvola_version_tuple_lt (NuvolaVersionTuple *self,
                                  NuvolaVersionTuple* other);
gboolean nuvola_version_tuple_lte (NuvolaVersionTuple *self,
                                   NuvolaVersionTuple* other);
gchar* nuvola_version_tuple_to_string (NuvolaVersionTuple *self);
guint* nuvola_version_tuple_as_array (NuvolaVersionTuple *self,
                                      int* result_length1);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
     * Create new version tuple.
     *
     * @param major    The major version number.
     * @param minor    The minor version number.
     * @param micro    The micro version number.
     * @param patch    The micro version patch.
     */
void
nuvola_version_tuple_init (NuvolaVersionTuple *self,
                           guint major,
                           guint minor,
                           guint micro,
                           guint patch)
{
	memset (self, 0, sizeof (NuvolaVersionTuple));
	(*self).major = major;
	(*self).minor = minor;
	(*self).micro = micro;
	(*self).patch = patch;
}


/**
     * Create new version tuple from uint array.
     *
     * @param versions    Version numbers as an uint array.
     */
void
nuvola_version_tuple_init_uintv (NuvolaVersionTuple *self,
                                 guint* versions,
                                 int versions_length1)
{
	guint _tmp0_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp4_ = 0U;
	guint _tmp6_ = 0U;
	memset (self, 0, sizeof (NuvolaVersionTuple));
	if (versions_length1 > 0) {
		guint _tmp1_;
		_tmp1_ = versions[0];
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = (guint) 0;
	}
	(*self).major = _tmp0_;
	if (versions_length1 > 1) {
		guint _tmp3_;
		_tmp3_ = versions[1];
		_tmp2_ = _tmp3_;
	} else {
		_tmp2_ = (guint) 0;
	}
	(*self).minor = _tmp2_;
	if (versions_length1 > 2) {
		guint _tmp5_;
		_tmp5_ = versions[2];
		_tmp4_ = _tmp5_;
	} else {
		_tmp4_ = (guint) 0;
	}
	(*self).micro = _tmp4_;
	if (versions_length1 > 3) {
		guint _tmp7_;
		_tmp7_ = versions[3];
		_tmp6_ = _tmp7_;
	} else {
		_tmp6_ = (guint) 0;
	}
	(*self).patch = _tmp6_;
}


/**
     * Create new version tuple from version string.
     *
     * @param version    A dot-separated version string.
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


void
nuvola_version_tuple_init_parse (NuvolaVersionTuple *self,
                                 const gchar* version)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_if_fail (version != NULL);
	memset (self, 0, sizeof (NuvolaVersionTuple));
	_tmp1_ = _tmp0_ = g_strsplit (version, ".", 0);
	parts = _tmp1_;
	parts_length1 = _vala_array_length (_tmp0_);
	_parts_size_ = parts_length1;
	_tmp2_ = parts;
	_tmp2__length1 = parts_length1;
	if (_tmp2__length1 > 0) {
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		_tmp3_ = parts;
		_tmp3__length1 = parts_length1;
		_tmp4_ = _tmp3_[0];
		_tmp5_ = string_strip (_tmp4_);
		_tmp6_ = _tmp5_;
		(*self).major = (guint) atoi (_tmp6_);
		_g_free0 (_tmp6_);
		_tmp7_ = parts;
		_tmp7__length1 = parts_length1;
		if (_tmp7__length1 > 1) {
			gchar** _tmp8_;
			gint _tmp8__length1;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar** _tmp12_;
			gint _tmp12__length1;
			_tmp8_ = parts;
			_tmp8__length1 = parts_length1;
			_tmp9_ = _tmp8_[1];
			_tmp10_ = string_strip (_tmp9_);
			_tmp11_ = _tmp10_;
			(*self).minor = (guint) atoi (_tmp11_);
			_g_free0 (_tmp11_);
			_tmp12_ = parts;
			_tmp12__length1 = parts_length1;
			if (_tmp12__length1 > 2) {
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				_tmp13_ = parts;
				_tmp13__length1 = parts_length1;
				_tmp14_ = _tmp13_[2];
				_tmp15_ = string_strip (_tmp14_);
				_tmp16_ = _tmp15_;
				(*self).micro = (guint) atoi (_tmp16_);
				_g_free0 (_tmp16_);
				_tmp17_ = parts;
				_tmp17__length1 = parts_length1;
				if (_tmp17__length1 > 3) {
					gchar** _tmp18_;
					gint _tmp18__length1;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					_tmp18_ = parts;
					_tmp18__length1 = parts_length1;
					_tmp19_ = _tmp18_[3];
					_tmp20_ = string_strip (_tmp19_);
					_tmp21_ = _tmp20_;
					(*self).patch = (guint) atoi (_tmp21_);
					_g_free0 (_tmp21_);
				}
			}
		}
	}
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
}


/**
     * Whether this version tuple is empty.
     *
     * @return True is this version tuple is empty.
     */
gboolean
nuvola_version_tuple_empty (NuvolaVersionTuple *self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	guint _tmp3_;
	_tmp3_ = (*self).major;
	if (_tmp3_ == ((guint) 0)) {
		guint _tmp4_;
		_tmp4_ = (*self).minor;
		_tmp2_ = _tmp4_ == ((guint) 0);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		guint _tmp5_;
		_tmp5_ = (*self).micro;
		_tmp1_ = _tmp5_ == ((guint) 0);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		guint _tmp6_;
		_tmp6_ = (*self).patch;
		_tmp0_ = _tmp6_ == ((guint) 0);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


/**
     * Check whether this version is greater than the other.
     *
     * @param other    The other version.
     * @return The result of this > other.
     */
gboolean
nuvola_version_tuple_gt (NuvolaVersionTuple *self,
                         NuvolaVersionTuple* other)
{
	gboolean result = FALSE;
	NuvolaVersionTuple _tmp0_;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = *other;
	result = nuvola_version_tuple_compare (&(*self), &_tmp0_) > 0;
	return result;
}


/**
     * Check whether this version is greater than or equal to the other.
     *
     * @param other    The other version.
     * @return The result of this >= other.
     */
gboolean
nuvola_version_tuple_gte (NuvolaVersionTuple *self,
                          NuvolaVersionTuple* other)
{
	gboolean result = FALSE;
	NuvolaVersionTuple _tmp0_;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = *other;
	result = nuvola_version_tuple_compare (&(*self), &_tmp0_) >= 0;
	return result;
}


/**
     * Check whether this version is lesser than the other.
     *
     * @param other    The other version.
     * @return The result of this < other.
     */
gboolean
nuvola_version_tuple_lt (NuvolaVersionTuple *self,
                         NuvolaVersionTuple* other)
{
	gboolean result = FALSE;
	NuvolaVersionTuple _tmp0_;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = *other;
	result = nuvola_version_tuple_compare (&(*self), &_tmp0_) < 0;
	return result;
}


/**
     * Check whether this version is lesser than or equal to the other.
     *
     * @param other    The other version.
     * @return The result of this <= other.
     */
gboolean
nuvola_version_tuple_lte (NuvolaVersionTuple *self,
                          NuvolaVersionTuple* other)
{
	gboolean result = FALSE;
	NuvolaVersionTuple _tmp0_;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = *other;
	result = nuvola_version_tuple_compare (&(*self), &_tmp0_) <= 0;
	return result;
}


/**
     * Compare this version with the other.
     *
     * @param other    The other version.
     * @return Zero if this == other, a positive number if this > other, and a negative number if this < other.
     */
gint
nuvola_version_tuple_compare (NuvolaVersionTuple *self,
                              NuvolaVersionTuple* other)
{
	gint result = 0;
	NuvolaVersionTuple _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	NuvolaVersionTuple _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	NuvolaVersionTuple _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	NuvolaVersionTuple _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	NuvolaVersionTuple _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	NuvolaVersionTuple _tmp15_;
	guint _tmp16_;
	guint _tmp17_;
	NuvolaVersionTuple _tmp18_;
	guint _tmp19_;
	guint _tmp20_;
	NuvolaVersionTuple _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	g_return_val_if_fail (other != NULL, 0);
	_tmp0_ = *other;
	_tmp1_ = _tmp0_.major;
	_tmp2_ = (*self).major;
	if (_tmp1_ > _tmp2_) {
		result = -1;
		return result;
	}
	_tmp3_ = *other;
	_tmp4_ = _tmp3_.major;
	_tmp5_ = (*self).major;
	if (_tmp4_ < _tmp5_) {
		result = 1;
		return result;
	}
	_tmp6_ = *other;
	_tmp7_ = _tmp6_.minor;
	_tmp8_ = (*self).minor;
	if (_tmp7_ > _tmp8_) {
		result = -1;
		return result;
	}
	_tmp9_ = *other;
	_tmp10_ = _tmp9_.minor;
	_tmp11_ = (*self).minor;
	if (_tmp10_ < _tmp11_) {
		result = 1;
		return result;
	}
	_tmp12_ = *other;
	_tmp13_ = _tmp12_.micro;
	_tmp14_ = (*self).micro;
	if (_tmp13_ > _tmp14_) {
		result = -1;
		return result;
	}
	_tmp15_ = *other;
	_tmp16_ = _tmp15_.micro;
	_tmp17_ = (*self).micro;
	if (_tmp16_ < _tmp17_) {
		result = 1;
		return result;
	}
	_tmp18_ = *other;
	_tmp19_ = _tmp18_.patch;
	_tmp20_ = (*self).patch;
	if (_tmp19_ > _tmp20_) {
		result = -1;
		return result;
	}
	_tmp21_ = *other;
	_tmp22_ = _tmp21_.patch;
	_tmp23_ = (*self).patch;
	if (_tmp22_ < _tmp23_) {
		result = 1;
		return result;
	}
	result = 0;
	return result;
}


/**
     * Create version string.
     *
     * @return A dot-separated version string X.Y.Z or X.Y.Z.P.
     */
gchar*
nuvola_version_tuple_to_string (NuvolaVersionTuple *self)
{
	gchar* result = NULL;
	guint _tmp0_;
	_tmp0_ = (*self).patch;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		gchar* _tmp5_;
		_tmp1_ = (*self).major;
		_tmp2_ = (*self).minor;
		_tmp3_ = (*self).micro;
		_tmp4_ = (*self).patch;
		_tmp5_ = g_strdup_printf ("%u.%u.%u.%u", _tmp1_, _tmp2_, _tmp3_, _tmp4_);
		result = _tmp5_;
		return result;
	} else {
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = (*self).major;
		_tmp7_ = (*self).minor;
		_tmp8_ = (*self).micro;
		_tmp9_ = g_strdup_printf ("%u.%u.%u", _tmp6_, _tmp7_, _tmp8_);
		result = _tmp9_;
		return result;
	}
}


/**
     * Return version array.
     *
     * @return Version array.
     */
guint*
nuvola_version_tuple_as_array (NuvolaVersionTuple *self,
                               int* result_length1)
{
	guint* result = NULL;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint* _tmp4_;
	guint* _tmp5_;
	gint _tmp5__length1;
	_tmp0_ = (*self).major;
	_tmp1_ = (*self).minor;
	_tmp2_ = (*self).micro;
	_tmp3_ = (*self).patch;
	_tmp4_ = g_new0 (guint, 4);
	_tmp4_[0] = _tmp0_;
	_tmp4_[1] = _tmp1_;
	_tmp4_[2] = _tmp2_;
	_tmp4_[3] = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = 4;
	if (result_length1) {
		*result_length1 = _tmp5__length1;
	}
	result = _tmp5_;
	return result;
}


NuvolaVersionTuple*
nuvola_version_tuple_dup (const NuvolaVersionTuple* self)
{
	NuvolaVersionTuple* dup;
	dup = g_new0 (NuvolaVersionTuple, 1);
	memcpy (dup, self, sizeof (NuvolaVersionTuple));
	return dup;
}


void
nuvola_version_tuple_free (NuvolaVersionTuple* self)
{
	g_free (self);
}


GType
nuvola_version_tuple_get_type (void)
{
	static volatile gsize nuvola_version_tuple_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_version_tuple_type_id__volatile)) {
		GType nuvola_version_tuple_type_id;
		nuvola_version_tuple_type_id = g_boxed_type_register_static ("NuvolaVersionTuple", (GBoxedCopyFunc) nuvola_version_tuple_dup, (GBoxedFreeFunc) nuvola_version_tuple_free);
		g_once_init_leave (&nuvola_version_tuple_type_id__volatile, nuvola_version_tuple_type_id);
	}
	return nuvola_version_tuple_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



