/* jsenvironment.c generated by valac 0.40.6, the Vala compiler
 * generated from jsenvironment.vala, do not modify */

/*
 * Copyright 2011-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <JavaScriptCore/JavaScript.h>
#include <gio/gio.h>
#include <dioriteglib4.h>


#define NUVOLA_TYPE_VALUE_TYPE (nuvola_value_type_get_type ())

#define NUVOLA_TYPE_JS_EXECUTOR (nuvola_js_executor_get_type ())
#define NUVOLA_JS_EXECUTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_JS_EXECUTOR, NuvolaJSExecutor))
#define NUVOLA_IS_JS_EXECUTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_JS_EXECUTOR))
#define NUVOLA_JS_EXECUTOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_JS_EXECUTOR, NuvolaJSExecutorIface))

typedef struct _NuvolaJSExecutor NuvolaJSExecutor;
typedef struct _NuvolaJSExecutorIface NuvolaJSExecutorIface;

#define NUVOLA_TYPE_JS_ENVIRONMENT (nuvola_js_environment_get_type ())
#define NUVOLA_JS_ENVIRONMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment))
#define NUVOLA_JS_ENVIRONMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentClass))
#define NUVOLA_IS_JS_ENVIRONMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_JS_ENVIRONMENT))
#define NUVOLA_IS_JS_ENVIRONMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_JS_ENVIRONMENT))
#define NUVOLA_JS_ENVIRONMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentClass))

typedef struct _NuvolaJsEnvironment NuvolaJsEnvironment;
typedef struct _NuvolaJsEnvironmentClass NuvolaJsEnvironmentClass;
typedef struct _NuvolaJsEnvironmentPrivate NuvolaJsEnvironmentPrivate;
enum  {
	NUVOLA_JS_ENVIRONMENT_0_PROPERTY,
	NUVOLA_JS_ENVIRONMENT_CONTEXT_PROPERTY,
	NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT_PROPERTY,
	NUVOLA_JS_ENVIRONMENT_NUM_PROPERTIES
};
static GParamSpec* nuvola_js_environment_properties[NUVOLA_JS_ENVIRONMENT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	NUVOLA_VALUE_TYPE_STRING,
	NUVOLA_VALUE_TYPE_INT,
	NUVOLA_VALUE_TYPE_DOUBLE,
	NUVOLA_VALUE_TYPE_NULL,
	NUVOLA_VALUE_TYPE_JS_VALUE
} NuvolaValueType;

struct _NuvolaJSExecutorIface {
	GTypeInterface parent_iface;
	void (*call_function_sync) (NuvolaJSExecutor* self, const gchar* name, GVariant* * params, gboolean propagate_error, GError** error);
};

struct _NuvolaJsEnvironment {
	GObject parent_instance;
	NuvolaJsEnvironmentPrivate * priv;
};

struct _NuvolaJsEnvironmentClass {
	GObjectClass parent_class;
};

struct _NuvolaJsEnvironmentPrivate {
	struct OpaqueJSContext* _context;
	struct OpaqueJSValue* _main_object;
};

typedef enum  {
	NUVOLA_JS_ERROR_NOT_FOUND,
	NUVOLA_JS_ERROR_WRONG_TYPE,
	NUVOLA_JS_ERROR_FUNC_FAILED,
	NUVOLA_JS_ERROR_READ_ERROR,
	NUVOLA_JS_ERROR_NO_CONTEXT,
	NUVOLA_JS_ERROR_EXCEPTION,
	NUVOLA_JS_ERROR_INITIALIZATION_FAILED
} NuvolaJSError;
#define NUVOLA_JS_ERROR nuvola_js_error_quark ()

static gpointer nuvola_js_environment_parent_class = NULL;
static NuvolaJSExecutorIface * nuvola_js_environment_nuvola_js_executor_parent_iface = NULL;

#define NUVOLA_WEB_ENGINE_LOADING_URI "about:loading"
GType nuvola_value_type_get_type (void) G_GNUC_CONST;
GType nuvola_js_executor_get_type (void) G_GNUC_CONST;
GType nuvola_js_environment_get_type (void) G_GNUC_CONST;
#define NUVOLA_JS_ENVIRONMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentPrivate))
void nuvola_js_environment_set_main_object (NuvolaJsEnvironment* self,
                                            struct OpaqueJSValue* value);
NuvolaJsEnvironment* nuvola_js_environment_new (struct OpaqueJSContext* context,
                                                struct OpaqueJSValue* main_object);
NuvolaJsEnvironment* nuvola_js_environment_construct (GType object_type,
                                                      struct OpaqueJSContext* context,
                                                      struct OpaqueJSValue* main_object);
static void nuvola_js_environment_set_context (NuvolaJsEnvironment* self,
                                        struct OpaqueJSContext* value);
GQuark nuvola_js_error_quark (void);
void nuvola_js_environment_execute_script_from_file (NuvolaJsEnvironment* self,
                                                     GFile* file,
                                                     GValue* result,
                                                     GError** error);
void nuvola_js_environment_execute_script (NuvolaJsEnvironment* self,
                                           const gchar* script,
                                           const gchar* path,
                                           gint line,
                                           GValue* result,
                                           GError** error);
struct OpaqueJSContext* nuvola_js_environment_get_context (NuvolaJsEnvironment* self);
struct OpaqueJSValue* nuvola_js_environment_get_main_object (NuvolaJsEnvironment* self);
gchar* nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx,
                                            const struct OpaqueJSValue* value);
static void nuvola_js_environment_real_call_function_sync (NuvolaJSExecutor* base,
                                                    const gchar* name,
                                                    GVariant* * args,
                                                    gboolean propagate_error,
                                                    GError** error);
struct OpaqueJSValue* nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx,
                                                    struct OpaqueJSValue* obj,
                                                    const gchar* property);
const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx,
                                                                GVariant* variant,
                                                                GError** error);
GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx,
                                              const struct OpaqueJSValue* val,
                                              GError** error);
static void nuvola_js_environment_finalize (GObject * obj);
static void _vala_nuvola_js_environment_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_nuvola_js_environment_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType
nuvola_value_type_get_type (void)
{
	static volatile gsize nuvola_value_type_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_value_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NUVOLA_VALUE_TYPE_STRING, "NUVOLA_VALUE_TYPE_STRING", "string"}, {NUVOLA_VALUE_TYPE_INT, "NUVOLA_VALUE_TYPE_INT", "int"}, {NUVOLA_VALUE_TYPE_DOUBLE, "NUVOLA_VALUE_TYPE_DOUBLE", "double"}, {NUVOLA_VALUE_TYPE_NULL, "NUVOLA_VALUE_TYPE_NULL", "null"}, {NUVOLA_VALUE_TYPE_JS_VALUE, "NUVOLA_VALUE_TYPE_JS_VALUE", "js-value"}, {0, NULL, NULL}};
		GType nuvola_value_type_type_id;
		nuvola_value_type_type_id = g_enum_register_static ("NuvolaValueType", values);
		g_once_init_leave (&nuvola_value_type_type_id__volatile, nuvola_value_type_type_id);
	}
	return nuvola_value_type_type_id__volatile;
}


NuvolaJsEnvironment*
nuvola_js_environment_construct (GType object_type,
                                 struct OpaqueJSContext* context,
                                 struct OpaqueJSValue* main_object)
{
	NuvolaJsEnvironment * self = NULL;
	g_return_val_if_fail (context != NULL, NULL);
	self = (NuvolaJsEnvironment*) g_object_new (object_type, NULL);
	nuvola_js_environment_set_context (self, context);
	nuvola_js_environment_set_main_object (self, main_object);
	return self;
}


NuvolaJsEnvironment*
nuvola_js_environment_new (struct OpaqueJSContext* context,
                           struct OpaqueJSValue* main_object)
{
	return nuvola_js_environment_construct (NUVOLA_TYPE_JS_ENVIRONMENT, context, main_object);
}


/**
     * Executes script from file.
     *
     * The script will be executed in a context returned by {@link get_context().
     * The "this" keyword will refer to {@link object_this} if provided.
     *
     * @param file    script to execute
     * @return        return value of the script
     * @throw         JSError on failure
     */
void
nuvola_js_environment_execute_script_from_file (NuvolaJsEnvironment* self,
                                                GFile* file,
                                                GValue* result,
                                                GError** error)
{
	gchar* code = NULL;
	GValue _tmp9_ = {0};
	gchar* _tmp10_;
	gchar* _tmp11_;
	GValue _tmp12_ = {0};
	GValue _tmp13_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = drt_system_read_file (file, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch19_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (code);
		code = _tmp2_;
		_g_free0 (_tmp0_);
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = g_file_get_path (file);
		_tmp4_ = _tmp3_;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		_tmp7_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_READ_ERROR, "Unable to read script %s: %s", _tmp4_, _tmp6_);
		_tmp8_ = _tmp7_;
		_g_free0 (_tmp4_);
		_inner_error_ = _tmp8_;
		_g_error_free0 (e);
		goto __finally19;
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (code);
			return;
		} else {
			_g_free0 (code);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp10_ = g_file_get_uri (file);
	_tmp11_ = _tmp10_;
	nuvola_js_environment_execute_script (self, code, _tmp11_, 1, &_tmp12_, &_inner_error_);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	_tmp9_ = _tmp13_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (code);
			return;
		} else {
			_g_free0 (code);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	*result = _tmp9_;
	_g_free0 (code);
	return;
}


/**
     * Executes script.
     *
     * The script will be executed in a context returned by {@link get_context()}.
     * The "this" keyword will refer to {@link object_this} if provided.
     *
     * @param script    script to execute
     * @return          return value of the script
     * @throw           JSError on failure
     */
void
nuvola_js_environment_execute_script (NuvolaJsEnvironment* self,
                                      const gchar* script,
                                      const gchar* path,
                                      gint line,
                                      GValue* result,
                                      GError** error)
{
	const struct OpaqueJSValue* exception = NULL;
	GValue value = {0};
	struct OpaqueJSContext* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	struct OpaqueJSString* _tmp2_;
	struct OpaqueJSValue* _tmp3_;
	struct OpaqueJSValue* _tmp4_;
	struct OpaqueJSString* _tmp5_;
	struct OpaqueJSString* _tmp6_;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSValue* _tmp8_;
	GValue _tmp9_ = {0};
	GValue _tmp10_;
	const struct OpaqueJSValue* _tmp11_;
	GValue _tmp18_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (script != NULL);
	g_return_if_fail (path != NULL);
	exception = NULL;
	_tmp0_ = self->priv->_context;
	_tmp1_ = JSStringCreateWithUTF8CString (script);
	_tmp2_ = _tmp1_;
	_tmp3_ = nuvola_js_environment_get_main_object (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = JSStringCreateWithUTF8CString (path);
	_tmp6_ = _tmp5_;
	_tmp8_ = JSEvaluateScript ((const struct OpaqueJSContext*) _tmp0_, _tmp2_, _tmp4_, _tmp6_, line, &_tmp7_);
	_0 (exception);
	exception = _tmp7_;
	g_value_init (&_tmp9_, G_TYPE_POINTER);
	g_value_set_pointer (&_tmp9_, _tmp8_);
	_tmp10_ = _tmp9_;
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
	_JSStringRelease0 (_tmp6_);
	_JSStringRelease0 (_tmp2_);
	value = _tmp10_;
	_tmp11_ = exception;
	if (_tmp11_ != NULL) {
		struct OpaqueJSContext* _tmp12_;
		const struct OpaqueJSValue* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		GError* _tmp17_;
		_tmp12_ = self->priv->_context;
		_tmp13_ = exception;
		_tmp14_ = nuvola_js_tools_exception_to_string ((const struct OpaqueJSContext*) _tmp12_, _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_error_new_literal (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_EXCEPTION, _tmp15_);
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp15_);
		_inner_error_ = _tmp17_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_0 (exception);
			return;
		} else {
			_0 (exception);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp18_ = value;
	*result = _tmp18_;
	_0 (exception);
	return;
}


static void
nuvola_js_environment_real_call_function_sync (NuvolaJSExecutor* base,
                                               const gchar* name,
                                               GVariant* * args,
                                               gboolean propagate_error,
                                               GError** error)
{
	NuvolaJsEnvironment * self;
	const struct OpaqueJSContext* ctx = NULL;
	struct OpaqueJSContext* _tmp0_;
	gchar** names = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint names_length1;
	gint _names_size_;
	struct OpaqueJSValue* object = NULL;
	struct OpaqueJSValue* _tmp3_;
	struct OpaqueJSValue* _tmp4_;
	struct OpaqueJSValue* _tmp5_;
	struct OpaqueJSValue* func = NULL;
	const struct OpaqueJSContext* _tmp22_;
	struct OpaqueJSValue* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar** _tmp25_;
	gint _tmp25__length1;
	const gchar* _tmp26_;
	struct OpaqueJSValue* _tmp27_;
	struct OpaqueJSValue* _tmp28_;
	struct OpaqueJSValue* _tmp33_;
	const struct OpaqueJSContext* _tmp34_;
	const struct OpaqueJSValue** params = NULL;
	gint params_length1 = 0;
	gint _params_size_ = 0;
	gint size = 0;
	const struct OpaqueJSValue* exception = NULL;
	struct OpaqueJSValue* _tmp50_;
	const struct OpaqueJSContext* _tmp51_;
	struct OpaqueJSValue* _tmp52_;
	const struct OpaqueJSValue** _tmp53_;
	gint _tmp53__length1;
	const struct OpaqueJSValue* _tmp54_ = NULL;
	const struct OpaqueJSValue* _tmp55_;
	GError * _inner_error_ = NULL;
	self = (NuvolaJsEnvironment*) base;
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->_context;
	ctx = (const struct OpaqueJSContext*) _tmp0_;
	_tmp2_ = _tmp1_ = g_strsplit (name, ".", 0);
	names = _tmp2_;
	names_length1 = _vala_array_length (_tmp1_);
	_names_size_ = names_length1;
	_tmp3_ = nuvola_js_environment_get_main_object (self);
	_tmp4_ = _tmp3_;
	object = _tmp4_;
	_tmp5_ = object;
	if (_tmp5_ == NULL) {
		GError* _tmp6_;
		_tmp6_ = g_error_new_literal (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_NOT_FOUND, "Main object not found.'");
		_inner_error_ = _tmp6_;
		g_propagate_error (error, _inner_error_);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				gint _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const struct OpaqueJSContext* _tmp11_;
				struct OpaqueJSValue* _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				gint _tmp14_;
				const gchar* _tmp15_;
				struct OpaqueJSValue* _tmp16_;
				struct OpaqueJSValue* _tmp17_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = i;
					i = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				_tmp9_ = i;
				_tmp10_ = names;
				_tmp10__length1 = names_length1;
				if (!(_tmp9_ < (_tmp10__length1 - 1))) {
					break;
				}
				_tmp11_ = ctx;
				_tmp12_ = object;
				_tmp13_ = names;
				_tmp13__length1 = names_length1;
				_tmp14_ = i;
				_tmp15_ = _tmp13_[_tmp14_];
				_tmp16_ = nuvola_js_tools_o_get_object (_tmp11_, _tmp12_, _tmp15_);
				object = _tmp16_;
				_tmp17_ = object;
				if (_tmp17_ == NULL) {
					gchar** _tmp18_;
					gint _tmp18__length1;
					gint _tmp19_;
					const gchar* _tmp20_;
					GError* _tmp21_;
					_tmp18_ = names;
					_tmp18__length1 = names_length1;
					_tmp19_ = i;
					_tmp20_ = _tmp18_[_tmp19_];
					_tmp21_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_NOT_FOUND, "Attribute '%s' not found.'", _tmp20_);
					_inner_error_ = _tmp21_;
					g_propagate_error (error, _inner_error_);
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
					return;
				}
			}
		}
	}
	_tmp22_ = ctx;
	_tmp23_ = object;
	_tmp24_ = names;
	_tmp24__length1 = names_length1;
	_tmp25_ = names;
	_tmp25__length1 = names_length1;
	_tmp26_ = _tmp24_[_tmp25__length1 - 1];
	_tmp27_ = nuvola_js_tools_o_get_object (_tmp22_, _tmp23_, _tmp26_);
	func = _tmp27_;
	_tmp28_ = func;
	if (_tmp28_ == NULL) {
		gchar** _tmp29_;
		gint _tmp29__length1;
		gchar** _tmp30_;
		gint _tmp30__length1;
		const gchar* _tmp31_;
		GError* _tmp32_;
		_tmp29_ = names;
		_tmp29__length1 = names_length1;
		_tmp30_ = names;
		_tmp30__length1 = names_length1;
		_tmp31_ = _tmp29_[_tmp30__length1 - 1];
		_tmp32_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_NOT_FOUND, "Attribute '%s' not found.'", _tmp31_);
		_inner_error_ = _tmp32_;
		g_propagate_error (error, _inner_error_);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp33_ = func;
	_tmp34_ = ctx;
	if (!JSObjectIsFunction (_tmp34_, _tmp33_)) {
		GError* _tmp35_;
		_tmp35_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "'%s' is not a function.'", name);
		_inner_error_ = _tmp35_;
		g_propagate_error (error, _inner_error_);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	size = 0;
	if ((*args) != NULL) {
		gint _tmp36_;
		const struct OpaqueJSValue** _tmp37_;
		gint i = 0;
		_vala_assert (g_variant_is_container (*args), "args.is_container()");
		size = (gint) g_variant_n_children (*args);
		_tmp36_ = size;
		_tmp37_ = g_new0 (const struct OpaqueJSValue*, _tmp36_ + 1);
		params = (g_free (params), NULL);
		params = _tmp37_;
		params_length1 = _tmp36_;
		_params_size_ = params_length1;
		i = 0;
		{
			GVariantIter* _item_it = NULL;
			GVariantIter* _tmp38_;
			GVariant* item = NULL;
			_tmp38_ = g_variant_iter_new (*args);
			_item_it = _tmp38_;
			while (TRUE) {
				GVariantIter* _tmp39_;
				GVariant* _tmp40_;
				GVariant* _tmp41_;
				const struct OpaqueJSValue* _tmp42_ = NULL;
				const struct OpaqueJSContext* _tmp43_;
				GVariant* _tmp44_;
				const struct OpaqueJSValue* _tmp45_;
				const struct OpaqueJSValue** _tmp46_;
				gint _tmp46__length1;
				gint _tmp47_;
				const struct OpaqueJSValue* _tmp48_;
				_tmp39_ = _item_it;
				_tmp40_ = g_variant_iter_next_value (_tmp39_);
				_g_variant_unref0 (item);
				item = _tmp40_;
				_tmp41_ = item;
				if (!(_tmp41_ != NULL)) {
					break;
				}
				_tmp43_ = ctx;
				_tmp44_ = item;
				_tmp45_ = nuvola_js_tools_value_from_variant (_tmp43_, _tmp44_, &_inner_error_);
				_tmp42_ = _tmp45_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_variant_unref0 (item);
					_g_variant_iter_free0 (_item_it);
					params = (g_free (params), NULL);
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
					return;
				}
				_tmp46_ = params;
				_tmp46__length1 = params_length1;
				_tmp47_ = i;
				i = _tmp47_ + 1;
				_tmp46_[_tmp47_] = _tmp42_;
				_tmp48_ = _tmp46_[_tmp47_];
			}
			_g_variant_unref0 (item);
			_g_variant_iter_free0 (_item_it);
		}
	} else {
		const struct OpaqueJSValue** _tmp49_;
		_tmp49_ = g_new0 (const struct OpaqueJSValue*, 0 + 1);
		params = (g_free (params), NULL);
		params = _tmp49_;
		params_length1 = 0;
		_params_size_ = params_length1;
	}
	_tmp50_ = func;
	_tmp51_ = ctx;
	_tmp52_ = object;
	_tmp53_ = params;
	_tmp53__length1 = params_length1;
	JSObjectCallAsFunction (_tmp51_, _tmp50_, _tmp52_, (size_t) _tmp53__length1, _tmp53_, &_tmp54_);
	_0 (exception);
	exception = _tmp54_;
	_tmp55_ = exception;
	if (_tmp55_ != NULL) {
		gchar* _tmp56_ = NULL;
		const struct OpaqueJSContext* _tmp57_;
		const struct OpaqueJSValue* _tmp58_;
		gchar* _tmp59_;
		GError* _tmp61_;
		_tmp57_ = ctx;
		_tmp58_ = exception;
		_tmp59_ = nuvola_js_tools_exception_to_string (_tmp57_, _tmp58_);
		_tmp56_ = _tmp59_;
		if (_tmp56_ == NULL) {
			gchar* _tmp60_;
			_tmp60_ = g_strdup ("(null)");
			_g_free0 (_tmp56_);
			_tmp56_ = _tmp60_;
		}
		_tmp61_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_FUNC_FAILED, "Function '%s' failed. %s", name, _tmp56_);
		_inner_error_ = _tmp61_;
		g_propagate_error (error, _inner_error_);
		_g_free0 (_tmp56_);
		_0 (exception);
		params = (g_free (params), NULL);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	if ((*args) != NULL) {
		GVariant** items = NULL;
		gint _tmp62_;
		GVariant** _tmp63_;
		gint items_length1;
		gint _items_size_;
		GVariant** _tmp78_;
		gint _tmp78__length1;
		GVariant* _tmp79_;
		_tmp62_ = size;
		_tmp63_ = g_new0 (GVariant*, _tmp62_ + 1);
		items = _tmp63_;
		items_length1 = _tmp62_;
		_items_size_ = items_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp64_ = FALSE;
				_tmp64_ = TRUE;
				while (TRUE) {
					gint _tmp66_;
					gint _tmp67_;
					GVariant* _tmp68_ = NULL;
					const struct OpaqueJSContext* _tmp69_;
					const struct OpaqueJSValue** _tmp70_;
					gint _tmp70__length1;
					gint _tmp71_;
					const struct OpaqueJSValue* _tmp72_;
					GVariant* _tmp73_;
					GVariant** _tmp74_;
					gint _tmp74__length1;
					gint _tmp75_;
					GVariant* _tmp76_;
					GVariant* _tmp77_;
					if (!_tmp64_) {
						gint _tmp65_;
						_tmp65_ = i;
						i = _tmp65_ + 1;
					}
					_tmp64_ = FALSE;
					_tmp66_ = i;
					_tmp67_ = size;
					if (!(_tmp66_ < _tmp67_)) {
						break;
					}
					_tmp69_ = ctx;
					_tmp70_ = params;
					_tmp70__length1 = params_length1;
					_tmp71_ = i;
					_tmp72_ = _tmp70_[_tmp71_];
					_tmp73_ = nuvola_js_tools_variant_from_value (_tmp69_, (const struct OpaqueJSValue*) _tmp72_, &_inner_error_);
					_tmp68_ = _tmp73_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						g_propagate_error (error, _inner_error_);
						items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_variant_unref), NULL);
						_0 (exception);
						params = (g_free (params), NULL);
						names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
						return;
					}
					_tmp74_ = items;
					_tmp74__length1 = items_length1;
					_tmp75_ = i;
					_tmp76_ = _tmp68_;
					_tmp68_ = NULL;
					_g_variant_unref0 (_tmp74_[_tmp75_]);
					_tmp74_[_tmp75_] = _tmp76_;
					_tmp77_ = _tmp74_[_tmp75_];
					_g_variant_unref0 (_tmp68_);
				}
			}
		}
		_tmp78_ = items;
		_tmp78__length1 = items_length1;
		_tmp79_ = g_variant_new_tuple (_tmp78_, _tmp78__length1);
		g_variant_ref_sink (_tmp79_);
		_g_variant_unref0 (*args);
		*args = _tmp79_;
		items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_variant_unref), NULL);
	}
	_0 (exception);
	params = (g_free (params), NULL);
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
}


struct OpaqueJSContext*
nuvola_js_environment_get_context (NuvolaJsEnvironment* self)
{
	struct OpaqueJSContext* result;
	struct OpaqueJSContext* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_context;
	result = _tmp0_;
	return result;
}


static void
nuvola_js_environment_set_context (NuvolaJsEnvironment* self,
                                   struct OpaqueJSContext* value)
{
	g_return_if_fail (self != NULL);
	if (nuvola_js_environment_get_context (self) != value) {
		self->priv->_context = value;
		g_object_notify_by_pspec ((GObject *) self, nuvola_js_environment_properties[NUVOLA_JS_ENVIRONMENT_CONTEXT_PROPERTY]);
	}
}


struct OpaqueJSValue*
nuvola_js_environment_get_main_object (NuvolaJsEnvironment* self)
{
	struct OpaqueJSValue* result;
	struct OpaqueJSValue* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_main_object;
	result = _tmp0_;
	return result;
}


void
nuvola_js_environment_set_main_object (NuvolaJsEnvironment* self,
                                       struct OpaqueJSValue* value)
{
	struct OpaqueJSValue* _tmp0_;
	struct OpaqueJSValue* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_main_object;
	if (_tmp0_ != NULL) {
		struct OpaqueJSValue* _tmp1_;
		struct OpaqueJSContext* _tmp2_;
		_tmp1_ = self->priv->_main_object;
		_tmp2_ = self->priv->_context;
		JSValueUnprotect ((const struct OpaqueJSContext*) _tmp2_, (const struct OpaqueJSValue*) _tmp1_);
	}
	self->priv->_main_object = value;
	_tmp3_ = self->priv->_main_object;
	if (_tmp3_ != NULL) {
		struct OpaqueJSValue* _tmp4_;
		struct OpaqueJSContext* _tmp5_;
		_tmp4_ = self->priv->_main_object;
		_tmp5_ = self->priv->_context;
		JSValueProtect ((const struct OpaqueJSContext*) _tmp5_, (const struct OpaqueJSValue*) _tmp4_);
	}
	g_object_notify_by_pspec ((GObject *) self, nuvola_js_environment_properties[NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT_PROPERTY]);
}


static void
nuvola_js_environment_class_init (NuvolaJsEnvironmentClass * klass)
{
	nuvola_js_environment_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaJsEnvironmentPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_js_environment_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_js_environment_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_js_environment_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_JS_ENVIRONMENT_CONTEXT_PROPERTY, nuvola_js_environment_properties[NUVOLA_JS_ENVIRONMENT_CONTEXT_PROPERTY] = g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT_PROPERTY, nuvola_js_environment_properties[NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT_PROPERTY] = g_param_spec_pointer ("main-object", "main-object", "main-object", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
nuvola_js_environment_nuvola_js_executor_interface_init (NuvolaJSExecutorIface * iface)
{
	nuvola_js_environment_nuvola_js_executor_parent_iface = g_type_interface_peek_parent (iface);
	iface->call_function_sync = (void (*) (NuvolaJSExecutor *, const gchar*, GVariant* *, gboolean, GError**)) nuvola_js_environment_real_call_function_sync;
}


static void
nuvola_js_environment_instance_init (NuvolaJsEnvironment * self)
{
	self->priv = NUVOLA_JS_ENVIRONMENT_GET_PRIVATE (self);
	self->priv->_main_object = NULL;
}


static void
nuvola_js_environment_finalize (GObject * obj)
{
	NuvolaJsEnvironment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment);
	nuvola_js_environment_set_main_object (self, NULL);
	g_debug ("jsenvironment.vala:61: ~JsEnvironment %p", self);
	G_OBJECT_CLASS (nuvola_js_environment_parent_class)->finalize (obj);
}


GType
nuvola_js_environment_get_type (void)
{
	static volatile gsize nuvola_js_environment_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_js_environment_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaJsEnvironmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_js_environment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaJsEnvironment), 0, (GInstanceInitFunc) nuvola_js_environment_instance_init, NULL };
		static const GInterfaceInfo nuvola_js_executor_info = { (GInterfaceInitFunc) nuvola_js_environment_nuvola_js_executor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType nuvola_js_environment_type_id;
		nuvola_js_environment_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaJsEnvironment", &g_define_type_info, 0);
		g_type_add_interface_static (nuvola_js_environment_type_id, NUVOLA_TYPE_JS_EXECUTOR, &nuvola_js_executor_info);
		g_once_init_leave (&nuvola_js_environment_type_id__volatile, nuvola_js_environment_type_id);
	}
	return nuvola_js_environment_type_id__volatile;
}


static void
_vala_nuvola_js_environment_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NuvolaJsEnvironment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment);
	switch (property_id) {
		case NUVOLA_JS_ENVIRONMENT_CONTEXT_PROPERTY:
		g_value_set_pointer (value, nuvola_js_environment_get_context (self));
		break;
		case NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT_PROPERTY:
		g_value_set_pointer (value, nuvola_js_environment_get_main_object (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_nuvola_js_environment_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NuvolaJsEnvironment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment);
	switch (property_id) {
		case NUVOLA_JS_ENVIRONMENT_CONTEXT_PROPERTY:
		nuvola_js_environment_set_context (self, g_value_get_pointer (value));
		break;
		case NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT_PROPERTY:
		nuvola_js_environment_set_main_object (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



