/* jstools.c generated by valac 0.40.6, the Vala compiler
 * generated from jstools.vala, do not modify */

/*
 * Copyright 2011-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _JSPropertyNameArrayRelease0(var) ((var == NULL) ? NULL : (var = (JSPropertyNameArrayRelease (var), NULL)))

typedef enum  {
	NUVOLA_JS_ERROR_NOT_FOUND,
	NUVOLA_JS_ERROR_WRONG_TYPE,
	NUVOLA_JS_ERROR_FUNC_FAILED,
	NUVOLA_JS_ERROR_READ_ERROR,
	NUVOLA_JS_ERROR_NO_CONTEXT,
	NUVOLA_JS_ERROR_EXCEPTION,
	NUVOLA_JS_ERROR_INITIALIZATION_FAILED
} NuvolaJSError;
#define NUVOLA_JS_ERROR nuvola_js_error_quark ()


gchar* nuvola_js_tools_utf8_string (struct OpaqueJSString* jsstring);
const struct OpaqueJSValue* nuvola_js_tools_object_from_JSON (const struct OpaqueJSContext* ctx,
                                                              const gchar* json);
const struct OpaqueJSValue* nuvola_js_tools_create_exception (const struct OpaqueJSContext* ctx,
                                                              const gchar* message);
gchar* nuvola_js_tools_o_get_string (const struct OpaqueJSContext* ctx,
                                     struct OpaqueJSValue* obj,
                                     const gchar* property);
gdouble nuvola_js_tools_o_get_number (const struct OpaqueJSContext* ctx,
                                      struct OpaqueJSValue* obj,
                                      const gchar* property);
void nuvola_js_tools_o_set_string (const struct OpaqueJSContext* ctx,
                                   struct OpaqueJSValue* obj,
                                   const gchar* property,
                                   const gchar* value);
void nuvola_js_tools_o_set_number (const struct OpaqueJSContext* ctx,
                                   struct OpaqueJSValue* obj,
                                   const gchar* property,
                                   gdouble value);
void nuvola_js_tools_o_set_null (const struct OpaqueJSContext* ctx,
                                 struct OpaqueJSValue* obj,
                                 const gchar* property);
void nuvola_js_tools_o_set_bool (const struct OpaqueJSContext* ctx,
                                 struct OpaqueJSValue* obj,
                                 const gchar* property,
                                 gboolean value);
struct OpaqueJSValue* nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx,
                                                    struct OpaqueJSValue* obj,
                                                    const gchar* property);
gchar* nuvola_js_tools_string_or_null (const struct OpaqueJSContext* ctx,
                                       const struct OpaqueJSValue* val,
                                       gboolean allow_empty);
gchar* nuvola_js_tools_value_to_string (const struct OpaqueJSContext* ctx,
                                        const struct OpaqueJSValue* value);
gchar* nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx,
                                            const struct OpaqueJSValue* value);
const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property_named (const struct OpaqueJSContext* ctx,
                                                                        GObject* o,
                                                                        const gchar* name);
const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property (const struct OpaqueJSContext* ctx,
                                                                  GObject* o,
                                                                  GParamSpec* p);
GQuark nuvola_js_error_quark (void);
const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx,
                                                                GVariant* variant,
                                                                GError** error);
GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx,
                                              const struct OpaqueJSValue* val,
                                              GError** error);


/**
 * Converts JavaScriptCore string to Vala UTF-8 string
 *
 * @param jsstring JavaScriptCore string
 * @return Vala UTF-8 string
 */
gchar*
nuvola_js_tools_utf8_string (struct OpaqueJSString* jsstring)
{
	gchar* result = NULL;
	gsize max_size = 0UL;
	guint8* buffer = NULL;
	guint8* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	g_return_val_if_fail (jsstring != NULL, NULL);
	max_size = JSStringGetMaximumUTF8CStringSize (jsstring);
	_tmp0_ = g_new0 (guint8, max_size);
	buffer = _tmp0_;
	buffer_length1 = max_size;
	_buffer_size_ = buffer_length1;
	JSStringGetUTF8CString (jsstring, buffer, buffer_length1);
	_tmp1_ = g_strdup ((const gchar*) buffer);
	result = _tmp1_;
	buffer = (g_free (buffer), NULL);
	return result;
}


/**
 * Creates JavaScript object from JSON.
 *
 * @param ctx   JavaScript context
 * @param json  object in JSON notation
 * @return  JavaScript object
 */
const struct OpaqueJSValue*
nuvola_js_tools_object_from_JSON (const struct OpaqueJSContext* ctx,
                                  const gchar* json)
{
	const struct OpaqueJSValue* result = NULL;
	const gchar* _tmp0_ = NULL;
	const struct OpaqueJSValue* _result_ = NULL;
	struct OpaqueJSString* _tmp1_;
	struct OpaqueJSString* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const struct OpaqueJSValue* _tmp6_;
	const struct OpaqueJSValue* _tmp9_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (json != NULL, NULL);
	if (g_strcmp0 (json, "") == 0) {
		_tmp0_ = "{}";
	} else {
		_tmp0_ = json;
	}
	_tmp1_ = JSStringCreateWithUTF8CString (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = JSValueMakeFromJSONString (ctx, _tmp2_);
	_tmp4_ = _tmp3_;
	_JSStringRelease0 (_tmp2_);
	_result_ = _tmp4_;
	_tmp6_ = _result_;
	if (_tmp6_ == NULL) {
		_tmp5_ = TRUE;
	} else {
		const struct OpaqueJSValue* _tmp7_;
		_tmp7_ = _result_;
		_tmp5_ = !JSValueIsObject (ctx, _tmp7_);
	}
	if (_tmp5_) {
		struct OpaqueJSValue* _tmp8_;
		_tmp8_ = JSObjectMake (ctx, NULL, NULL);
		_result_ = (const struct OpaqueJSValue*) _tmp8_;
	}
	_tmp9_ = _result_;
	result = _tmp9_;
	return result;
}


/**
 * Creates JavaScript Exception object.
 *
 * @param ctx   JavaScript context
 * @param message   Error message (single line);
 * @return  JavaScript object
 */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch20_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch20_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally20;
	__catch20_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


const struct OpaqueJSValue*
nuvola_js_tools_create_exception (const struct OpaqueJSContext* ctx,
                                  const gchar* message)
{
	const struct OpaqueJSValue* result = NULL;
	gchar* exception = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (message != NULL, NULL);
	_tmp0_ = string_replace (message, "\"", "\\\"");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("{\"type\":\"NuvolaError\", \"message\":\"%s\"}", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	exception = _tmp3_;
	g_debug ("jstools.vala:64: %s", exception);
	_tmp4_ = nuvola_js_tools_object_from_JSON (ctx, exception);
	result = _tmp4_;
	_g_free0 (exception);
	return result;
}


/**
 * Obtains string property of JavaScript object
 *
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return string value or null if property is not a string
 */
gchar*
nuvola_js_tools_o_get_string (const struct OpaqueJSContext* ctx,
                              struct OpaqueJSValue* obj,
                              const gchar* property)
{
	gchar* result = NULL;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	g_return_val_if_fail (property != NULL, NULL);
	_tmp0_ = JSStringCreateWithUTF8CString (property);
	_tmp1_ = _tmp0_;
	_tmp2_ = JSObjectGetProperty (ctx, obj, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_JSStringRelease0 (_tmp1_);
	value = _tmp3_;
	_tmp4_ = value;
	if (JSValueIsString (ctx, _tmp4_)) {
		const struct OpaqueJSValue* _tmp5_;
		struct OpaqueJSString* _tmp6_;
		struct OpaqueJSString* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp5_ = value;
		_tmp6_ = JSValueToStringCopy (ctx, _tmp5_, NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = nuvola_js_tools_utf8_string (_tmp7_);
		_tmp9_ = _tmp8_;
		_JSStringRelease0 (_tmp7_);
		result = _tmp9_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Obtains number property of JavaScript object
 *
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return double value or 0.0 if property is not a number
 */
gdouble
nuvola_js_tools_o_get_number (const struct OpaqueJSContext* ctx,
                              struct OpaqueJSValue* obj,
                              const gchar* property)
{
	gdouble result = 0.0;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	g_return_val_if_fail (ctx != NULL, 0.0);
	g_return_val_if_fail (obj != NULL, 0.0);
	g_return_val_if_fail (property != NULL, 0.0);
	_tmp0_ = JSStringCreateWithUTF8CString (property);
	_tmp1_ = _tmp0_;
	_tmp2_ = JSObjectGetProperty (ctx, obj, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_JSStringRelease0 (_tmp1_);
	value = _tmp3_;
	_tmp4_ = value;
	if (JSValueIsNumber (ctx, _tmp4_)) {
		const struct OpaqueJSValue* _tmp5_;
		_tmp5_ = value;
		result = JSValueToNumber (ctx, _tmp5_, NULL);
		return result;
	}
	result = 0.0;
	return result;
}


/**
 * Sets string property of JavaScript object
 *
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void
nuvola_js_tools_o_set_string (const struct OpaqueJSContext* ctx,
                              struct OpaqueJSValue* obj,
                              const gchar* property,
                              const gchar* value)
{
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	struct OpaqueJSString* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = JSStringCreateWithUTF8CString (property);
	_tmp1_ = _tmp0_;
	_tmp2_ = JSStringCreateWithUTF8CString (value);
	_tmp3_ = _tmp2_;
	_tmp4_ = JSValueMakeString (ctx, _tmp3_);
	JSObjectSetProperty (ctx, obj, _tmp1_, _tmp4_, 0, NULL);
	_JSStringRelease0 (_tmp3_);
	_JSStringRelease0 (_tmp1_);
}


/**
 * Sets string property of JavaScript object
 *
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void
nuvola_js_tools_o_set_number (const struct OpaqueJSContext* ctx,
                              struct OpaqueJSValue* obj,
                              const gchar* property,
                              gdouble value)
{
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = JSStringCreateWithUTF8CString (property);
	_tmp1_ = _tmp0_;
	_tmp2_ = JSValueMakeNumber (ctx, value);
	JSObjectSetProperty (ctx, obj, _tmp1_, _tmp2_, 0, NULL);
	_JSStringRelease0 (_tmp1_);
}


/**
 * Sets null property of JavaScript object
 *
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 */
void
nuvola_js_tools_o_set_null (const struct OpaqueJSContext* ctx,
                            struct OpaqueJSValue* obj,
                            const gchar* property)
{
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = JSStringCreateWithUTF8CString (property);
	_tmp1_ = _tmp0_;
	_tmp2_ = JSValueMakeNull (ctx);
	JSObjectSetProperty (ctx, obj, _tmp1_, _tmp2_, 0, NULL);
	_JSStringRelease0 (_tmp1_);
}


/**
 * Sets boolean property of JavaScript object
 *
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void
nuvola_js_tools_o_set_bool (const struct OpaqueJSContext* ctx,
                            struct OpaqueJSValue* obj,
                            const gchar* property,
                            gboolean value)
{
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = JSStringCreateWithUTF8CString (property);
	_tmp1_ = _tmp0_;
	_tmp2_ = JSValueMakeBoolean (ctx, value);
	JSObjectSetProperty (ctx, obj, _tmp1_, _tmp2_, 0, NULL);
	_JSStringRelease0 (_tmp1_);
}


/**
 * Obtains object property of JavaScript object
 *
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return object or null if property is not a object
 */
struct OpaqueJSValue*
nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx,
                              struct OpaqueJSValue* obj,
                              const gchar* property)
{
	struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	g_return_val_if_fail (property != NULL, NULL);
	_tmp0_ = JSStringCreateWithUTF8CString (property);
	_tmp1_ = _tmp0_;
	_tmp2_ = JSObjectGetProperty (ctx, obj, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_JSStringRelease0 (_tmp1_);
	value = _tmp3_;
	_tmp4_ = value;
	if (JSValueIsObject (ctx, _tmp4_)) {
		const struct OpaqueJSValue* _tmp5_;
		struct OpaqueJSValue* _tmp6_;
		_tmp5_ = value;
		_tmp6_ = JSValueToObject (ctx, _tmp5_, NULL);
		result = _tmp6_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Converts JavaScript value to string
 *
 * @param ctx            JavaScript context
 * @param val            JavaScript value
 * @param allow_empty    if false null will be returned for empty string
 * @return string value or null if value is not a string
 */
gchar*
nuvola_js_tools_string_or_null (const struct OpaqueJSContext* ctx,
                                const struct OpaqueJSValue* val,
                                gboolean allow_empty)
{
	gchar* result = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	if (JSValueIsString (ctx, val)) {
		gchar* str = NULL;
		struct OpaqueJSString* _tmp0_;
		struct OpaqueJSString* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		gchar* _tmp8_;
		_tmp0_ = JSValueToStringCopy (ctx, val, NULL);
		_tmp1_ = _tmp0_;
		_tmp2_ = nuvola_js_tools_utf8_string (_tmp1_);
		_tmp3_ = _tmp2_;
		_JSStringRelease0 (_tmp1_);
		str = _tmp3_;
		_tmp6_ = str;
		if (g_strcmp0 (_tmp6_, "") == 0) {
			_tmp5_ = !allow_empty;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			_tmp4_ = NULL;
		} else {
			const gchar* _tmp7_;
			_tmp7_ = str;
			_tmp4_ = _tmp7_;
		}
		_tmp8_ = g_strdup (_tmp4_);
		result = _tmp8_;
		_g_free0 (str);
		return result;
	}
	result = NULL;
	return result;
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gchar*
nuvola_js_tools_value_to_string (const struct OpaqueJSContext* ctx,
                                 const struct OpaqueJSValue* value)
{
	gchar* result = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	if (JSValueIsString (ctx, value)) {
		struct OpaqueJSString* _tmp0_;
		struct OpaqueJSString* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = JSValueToStringCopy (ctx, value, NULL);
		_tmp1_ = _tmp0_;
		_tmp2_ = nuvola_js_tools_utf8_string (_tmp1_);
		_tmp3_ = _tmp2_;
		_JSStringRelease0 (_tmp1_);
		result = _tmp3_;
		return result;
	}
	if (JSValueIsNumber (ctx, value)) {
		gchar* _tmp4_;
		_tmp4_ = double_to_string (JSValueToNumber (ctx, value, NULL));
		result = _tmp4_;
		return result;
	}
	if (JSValueIsObject (ctx, value)) {
		struct OpaqueJSValue* _tmp5_;
		struct OpaqueJSString* _tmp6_;
		struct OpaqueJSString* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp5_ = JSValueToObject (ctx, value, NULL);
		_tmp6_ = JSValueCreateJSONString (ctx, (const struct OpaqueJSValue*) _tmp5_, (guint) 0, NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = nuvola_js_tools_utf8_string (_tmp7_);
		_tmp9_ = _tmp8_;
		_JSStringRelease0 (_tmp7_);
		result = _tmp9_;
		return result;
	}
	result = NULL;
	return result;
}


gchar*
nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx,
                                     const struct OpaqueJSValue* value)
{
	gchar* result = NULL;
	gchar* _tmp23_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	if (JSValueIsObject (ctx, value)) {
		struct OpaqueJSValue* obj = NULL;
		struct OpaqueJSValue* _tmp0_;
		gchar* message = NULL;
		struct OpaqueJSValue* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp0_ = JSValueToObject (ctx, value, NULL);
		obj = _tmp0_;
		_tmp1_ = obj;
		_tmp2_ = nuvola_js_tools_o_get_string (ctx, _tmp1_, "message");
		message = _tmp2_;
		_tmp3_ = message;
		if (_tmp3_ != NULL) {
			gchar* name = NULL;
			struct OpaqueJSValue* _tmp4_;
			gchar* _tmp5_;
			gint line = 0;
			struct OpaqueJSValue* _tmp6_;
			gchar* file = NULL;
			struct OpaqueJSValue* _tmp7_;
			gchar* _tmp8_;
			gboolean _tmp9_ = FALSE;
			gint _tmp10_;
			const gchar* _tmp16_ = NULL;
			const gchar* _tmp17_;
			const gchar* _tmp18_ = NULL;
			const gchar* _tmp19_;
			gint _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp4_ = obj;
			_tmp5_ = nuvola_js_tools_o_get_string (ctx, _tmp4_, "name");
			name = _tmp5_;
			_tmp6_ = obj;
			line = (gint) nuvola_js_tools_o_get_number (ctx, _tmp6_, "line");
			_tmp7_ = obj;
			_tmp8_ = nuvola_js_tools_o_get_string (ctx, _tmp7_, "sourceURL");
			file = _tmp8_;
			_tmp10_ = line;
			if (_tmp10_ == 0) {
				const gchar* _tmp11_;
				_tmp11_ = file;
				_tmp9_ = _tmp11_ == NULL;
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				const gchar* _tmp12_ = NULL;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp13_ = name;
				_tmp12_ = _tmp13_;
				if (_tmp12_ == NULL) {
					_tmp12_ = "null";
				}
				_tmp14_ = message;
				_tmp15_ = g_strdup_printf ("%s: %s. Enable JS debugging for more details.", _tmp12_, _tmp14_);
				result = _tmp15_;
				_g_free0 (file);
				_g_free0 (name);
				_g_free0 (message);
				return result;
			}
			_tmp17_ = file;
			_tmp16_ = _tmp17_;
			if (_tmp16_ == NULL) {
				_tmp16_ = "(null)";
			}
			_tmp19_ = name;
			_tmp18_ = _tmp19_;
			if (_tmp18_ == NULL) {
				_tmp18_ = "null";
			}
			_tmp20_ = line;
			_tmp21_ = message;
			_tmp22_ = g_strdup_printf ("%s:%d: %s: %s", _tmp16_, _tmp20_, _tmp18_, _tmp21_);
			result = _tmp22_;
			_g_free0 (file);
			_g_free0 (name);
			_g_free0 (message);
			return result;
		}
		_g_free0 (message);
	}
	_tmp23_ = nuvola_js_tools_value_to_string (ctx, value);
	result = _tmp23_;
	return result;
}


const struct OpaqueJSValue*
nuvola_js_tools_get_gobject_property_named (const struct OpaqueJSContext* ctx,
                                            GObject* o,
                                            const gchar* name)
{
	const struct OpaqueJSValue* result = NULL;
	GObjectClass* klass = NULL;
	GTypeClass* _tmp0_;
	GParamSpec* p = NULL;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp5_;
	const struct OpaqueJSValue* _tmp6_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (o != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = g_type_class_ref (G_TYPE_FROM_INSTANCE (o));
	klass = (GObjectClass*) _tmp0_;
	_tmp1_ = klass;
	_tmp2_ = g_object_class_find_property (_tmp1_, name);
	p = _tmp2_;
	_tmp3_ = p;
	if (_tmp3_ == NULL) {
		const struct OpaqueJSValue* _tmp4_;
		_tmp4_ = JSValueMakeUndefined (ctx);
		result = _tmp4_;
		_g_type_class_unref0 (klass);
		return result;
	}
	_tmp5_ = p;
	_tmp6_ = nuvola_js_tools_get_gobject_property (ctx, o, _tmp5_);
	result = _tmp6_;
	_g_type_class_unref0 (klass);
	return result;
}


const struct OpaqueJSValue*
nuvola_js_tools_get_gobject_property (const struct OpaqueJSContext* ctx,
                                      GObject* o,
                                      GParamSpec* p)
{
	const struct OpaqueJSValue* result = NULL;
	GType type = 0UL;
	GType _tmp0_;
	GType _tmp1_;
	GType _tmp8_;
	GType _tmp12_;
	GType _tmp16_;
	GType _tmp20_;
	const struct OpaqueJSValue* _tmp24_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (o != NULL, NULL);
	g_return_val_if_fail (p != NULL, NULL);
	_tmp0_ = p->value_type;
	type = _tmp0_;
	_tmp1_ = type;
	if (_tmp1_ == G_TYPE_STRING) {
		gchar* str_val = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		struct OpaqueJSString* _tmp4_;
		struct OpaqueJSString* _tmp5_;
		const struct OpaqueJSValue* _tmp6_;
		const struct OpaqueJSValue* _tmp7_;
		_tmp2_ = p->name;
		g_object_get (o, _tmp2_, &str_val, NULL);
		_tmp3_ = str_val;
		_tmp4_ = JSStringCreateWithUTF8CString (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = JSValueMakeString (ctx, _tmp5_);
		_tmp7_ = _tmp6_;
		_JSStringRelease0 (_tmp5_);
		result = _tmp7_;
		_g_free0 (str_val);
		return result;
	}
	_tmp8_ = type;
	if (_tmp8_ == G_TYPE_INT) {
		gint int_val = 0;
		const gchar* _tmp9_;
		gint _tmp10_;
		const struct OpaqueJSValue* _tmp11_;
		_tmp9_ = p->name;
		g_object_get (o, _tmp9_, &int_val, NULL);
		_tmp10_ = int_val;
		_tmp11_ = JSValueMakeNumber (ctx, (gdouble) _tmp10_);
		result = _tmp11_;
		return result;
	}
	_tmp12_ = type;
	if (_tmp12_ == G_TYPE_FLOAT) {
		gfloat float_val = 0.0F;
		const gchar* _tmp13_;
		gfloat _tmp14_;
		const struct OpaqueJSValue* _tmp15_;
		_tmp13_ = p->name;
		g_object_get (o, _tmp13_, &float_val, NULL);
		_tmp14_ = float_val;
		_tmp15_ = JSValueMakeNumber (ctx, (gdouble) _tmp14_);
		result = _tmp15_;
		return result;
	}
	_tmp16_ = type;
	if (_tmp16_ == G_TYPE_DOUBLE) {
		gdouble double_val = 0.0;
		const gchar* _tmp17_;
		gdouble _tmp18_;
		const struct OpaqueJSValue* _tmp19_;
		_tmp17_ = p->name;
		g_object_get (o, _tmp17_, &double_val, NULL);
		_tmp18_ = double_val;
		_tmp19_ = JSValueMakeNumber (ctx, (gdouble) _tmp18_);
		result = _tmp19_;
		return result;
	}
	_tmp20_ = type;
	if (_tmp20_ == G_TYPE_BOOLEAN) {
		gboolean bool_val = FALSE;
		const gchar* _tmp21_;
		gboolean _tmp22_;
		const struct OpaqueJSValue* _tmp23_;
		_tmp21_ = p->name;
		g_object_get (o, _tmp21_, &bool_val, NULL);
		_tmp22_ = bool_val;
		_tmp23_ = JSValueMakeBoolean (ctx, _tmp22_);
		result = _tmp23_;
		return result;
	}
	_tmp24_ = JSValueMakeUndefined (ctx);
	result = _tmp24_;
	return result;
}


static gpointer
_g_variant_type_copy0 (gpointer self)
{
	return self ? g_variant_type_copy (self) : NULL;
}


const struct OpaqueJSValue*
nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx,
                                    GVariant* variant,
                                    GError** error)
{
	const struct OpaqueJSValue* result = NULL;
	GVariantType* type = NULL;
	const GVariantType* _tmp1_;
	GVariantType* _tmp2_;
	const GVariantType* _tmp3_;
	const GVariantType* _tmp9_;
	const GVariantType* _tmp10_;
	GVariantType* object_type = NULL;
	GVariantType* _tmp16_;
	const GVariantType* _tmp17_;
	const GVariantType* _tmp18_;
	const GVariantType* _tmp29_;
	const GVariantType* _tmp35_;
	const GVariantType* _tmp37_;
	const GVariantType* _tmp39_;
	const GVariantType* _tmp41_;
	const GVariantType* _tmp43_;
	const GVariantType* _tmp45_;
	const gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	GError* _tmp67_;
	GError* _tmp68_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	if (variant == NULL) {
		const struct OpaqueJSValue* _tmp0_;
		_tmp0_ = JSValueMakeNull (ctx);
		result = _tmp0_;
		return result;
	}
	_tmp1_ = g_variant_get_type (variant);
	_tmp2_ = _g_variant_type_copy0 (_tmp1_);
	type = _tmp2_;
	_tmp3_ = G_VARIANT_TYPE_VARIANT;
	if (g_variant_is_of_type (variant, _tmp3_)) {
		const struct OpaqueJSValue* _tmp4_ = NULL;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		const struct OpaqueJSValue* _tmp7_;
		const struct OpaqueJSValue* _tmp8_;
		_tmp5_ = g_variant_get_variant (variant);
		_tmp6_ = _tmp5_;
		_tmp7_ = nuvola_js_tools_value_from_variant (ctx, _tmp6_, &_inner_error_);
		_tmp8_ = _tmp7_;
		_g_variant_unref0 (_tmp6_);
		_tmp4_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_variant_type_free0 (type);
				return NULL;
			} else {
				_g_variant_type_free0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		result = _tmp4_;
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp9_ = type;
	_tmp10_ = G_VARIANT_TYPE_MAYBE;
	if (g_variant_type_is_subtype_of (_tmp9_, _tmp10_)) {
		GVariant* maybe_variant = NULL;
		GVariant* _tmp11_;
		const struct OpaqueJSValue* _tmp13_ = NULL;
		GVariant* _tmp14_;
		const struct OpaqueJSValue* _tmp15_;
		maybe_variant = NULL;
		g_variant_get (variant, "m*", &maybe_variant, NULL);
		_tmp11_ = maybe_variant;
		if (_tmp11_ == NULL) {
			const struct OpaqueJSValue* _tmp12_;
			_tmp12_ = JSValueMakeNull (ctx);
			result = _tmp12_;
			_g_variant_unref0 (maybe_variant);
			_g_variant_type_free0 (type);
			return result;
		}
		_tmp14_ = maybe_variant;
		_tmp15_ = nuvola_js_tools_value_from_variant (ctx, _tmp14_, &_inner_error_);
		_tmp13_ = _tmp15_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_variant_unref0 (maybe_variant);
				_g_variant_type_free0 (type);
				return NULL;
			} else {
				_g_variant_unref0 (maybe_variant);
				_g_variant_type_free0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		result = _tmp13_;
		_g_variant_unref0 (maybe_variant);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp16_ = g_variant_type_new ("a{s*}");
	object_type = _tmp16_;
	_tmp17_ = type;
	_tmp18_ = object_type;
	if (g_variant_type_is_subtype_of (_tmp17_, _tmp18_)) {
		struct OpaqueJSValue* object = NULL;
		struct OpaqueJSValue* _tmp19_;
		GVariantIter* iter = NULL;
		gchar* key = NULL;
		GVariant* value = NULL;
		struct OpaqueJSValue* _tmp28_;
		_tmp19_ = JSObjectMake (ctx, NULL, NULL);
		object = _tmp19_;
		iter = NULL;
		g_variant_get (variant, "a{s*}", &iter, NULL);
		key = NULL;
		value = NULL;
		while (TRUE) {
			GVariantIter* _tmp20_;
			const struct OpaqueJSValue* _tmp21_ = NULL;
			GVariant* _tmp22_;
			const struct OpaqueJSValue* _tmp23_;
			struct OpaqueJSValue* _tmp24_;
			const gchar* _tmp25_;
			struct OpaqueJSString* _tmp26_;
			struct OpaqueJSString* _tmp27_;
			_tmp20_ = iter;
			if (!g_variant_iter_next (_tmp20_, "{s*}", &key, &value, NULL)) {
				break;
			}
			_tmp22_ = value;
			_tmp23_ = nuvola_js_tools_value_from_variant (ctx, _tmp22_, &_inner_error_);
			_tmp21_ = _tmp23_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == NUVOLA_JS_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_variant_unref0 (value);
					_g_free0 (key);
					_g_variant_iter_free0 (iter);
					_g_variant_type_free0 (object_type);
					_g_variant_type_free0 (type);
					return NULL;
				} else {
					_g_variant_unref0 (value);
					_g_free0 (key);
					_g_variant_iter_free0 (iter);
					_g_variant_type_free0 (object_type);
					_g_variant_type_free0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp24_ = object;
			_tmp25_ = key;
			_tmp26_ = JSStringCreateWithUTF8CString (_tmp25_);
			_tmp27_ = _tmp26_;
			JSObjectSetProperty (ctx, _tmp24_, _tmp27_, _tmp21_, 0, NULL);
			_JSStringRelease0 (_tmp27_);
		}
		_tmp28_ = object;
		result = (const struct OpaqueJSValue*) _tmp28_;
		_g_variant_unref0 (value);
		_g_free0 (key);
		_g_variant_iter_free0 (iter);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp29_ = G_VARIANT_TYPE_STRING;
	if (g_variant_is_of_type (variant, _tmp29_)) {
		const gchar* _tmp30_;
		struct OpaqueJSString* _tmp31_;
		struct OpaqueJSString* _tmp32_;
		const struct OpaqueJSValue* _tmp33_;
		const struct OpaqueJSValue* _tmp34_;
		_tmp30_ = g_variant_get_string (variant, NULL);
		_tmp31_ = JSStringCreateWithUTF8CString (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = JSValueMakeString (ctx, _tmp32_);
		_tmp34_ = _tmp33_;
		_JSStringRelease0 (_tmp32_);
		result = _tmp34_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp35_ = G_VARIANT_TYPE_BOOLEAN;
	if (g_variant_is_of_type (variant, _tmp35_)) {
		const struct OpaqueJSValue* _tmp36_;
		_tmp36_ = JSValueMakeBoolean (ctx, g_variant_get_boolean (variant));
		result = _tmp36_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp37_ = G_VARIANT_TYPE_DOUBLE;
	if (g_variant_is_of_type (variant, _tmp37_)) {
		const struct OpaqueJSValue* _tmp38_;
		_tmp38_ = JSValueMakeNumber (ctx, g_variant_get_double (variant));
		result = _tmp38_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp39_ = G_VARIANT_TYPE_INT32;
	if (g_variant_is_of_type (variant, _tmp39_)) {
		const struct OpaqueJSValue* _tmp40_;
		_tmp40_ = JSValueMakeNumber (ctx, (gdouble) g_variant_get_int32 (variant));
		result = _tmp40_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp41_ = G_VARIANT_TYPE_UINT32;
	if (g_variant_is_of_type (variant, _tmp41_)) {
		const struct OpaqueJSValue* _tmp42_;
		_tmp42_ = JSValueMakeNumber (ctx, (gdouble) g_variant_get_uint32 (variant));
		result = _tmp42_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp43_ = G_VARIANT_TYPE_INT64;
	if (g_variant_is_of_type (variant, _tmp43_)) {
		const struct OpaqueJSValue* _tmp44_;
		_tmp44_ = JSValueMakeNumber (ctx, (gdouble) g_variant_get_int64 (variant));
		result = _tmp44_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp45_ = G_VARIANT_TYPE_UINT64;
	if (g_variant_is_of_type (variant, _tmp45_)) {
		const struct OpaqueJSValue* _tmp46_;
		_tmp46_ = JSValueMakeNumber (ctx, (gdouble) g_variant_get_uint64 (variant));
		result = _tmp46_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	if (g_variant_is_container (variant)) {
		gsize size = 0UL;
		void** args = NULL;
		gsize _tmp47_;
		void** _tmp48_;
		gint args_length1;
		gint _args_size_;
		void** _tmp62_;
		gint _tmp62__length1;
		struct OpaqueJSValue* _tmp63_;
		size = g_variant_n_children (variant);
		_tmp47_ = size;
		_tmp48_ = g_new0 (void*, _tmp47_);
		args = _tmp48_;
		args_length1 = _tmp47_;
		_args_size_ = args_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp49_ = FALSE;
				_tmp49_ = TRUE;
				while (TRUE) {
					gint _tmp51_;
					gsize _tmp52_;
					const struct OpaqueJSValue* _tmp53_ = NULL;
					gint _tmp54_;
					GVariant* _tmp55_;
					GVariant* _tmp56_;
					const struct OpaqueJSValue* _tmp57_;
					const struct OpaqueJSValue* _tmp58_;
					void** _tmp59_;
					gint _tmp59__length1;
					gint _tmp60_;
					void* _tmp61_;
					if (!_tmp49_) {
						gint _tmp50_;
						_tmp50_ = i;
						i = _tmp50_ + 1;
					}
					_tmp49_ = FALSE;
					_tmp51_ = i;
					_tmp52_ = size;
					if (!(((gsize) _tmp51_) < _tmp52_)) {
						break;
					}
					_tmp54_ = i;
					_tmp55_ = g_variant_get_child_value (variant, (gsize) _tmp54_);
					_tmp56_ = _tmp55_;
					_tmp57_ = nuvola_js_tools_value_from_variant (ctx, _tmp56_, &_inner_error_);
					_tmp58_ = _tmp57_;
					_g_variant_unref0 (_tmp56_);
					_tmp53_ = _tmp58_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							args = (g_free (args), NULL);
							_g_variant_type_free0 (object_type);
							_g_variant_type_free0 (type);
							return NULL;
						} else {
							args = (g_free (args), NULL);
							_g_variant_type_free0 (object_type);
							_g_variant_type_free0 (type);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp59_ = args;
					_tmp59__length1 = args_length1;
					_tmp60_ = i;
					_tmp59_[_tmp60_] = (void*) _tmp53_;
					_tmp61_ = _tmp59_[_tmp60_];
				}
			}
		}
		_tmp62_ = args;
		_tmp62__length1 = args_length1;
		_tmp63_ = JSObjectMakeArray (ctx, (size_t) ((_tmp62__length1 * sizeof (void*)) / sizeof (const struct OpaqueJSValue*)), (const struct OpaqueJSValue**) _tmp62_, NULL);
		result = (const struct OpaqueJSValue*) _tmp63_;
		args = (g_free (args), NULL);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp64_ = g_variant_get_type_string (variant);
	_tmp65_ = g_variant_print (variant, TRUE);
	_tmp66_ = _tmp65_;
	_tmp67_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "Unsupported type '%s'. Content: %s", _tmp64_, _tmp66_);
	_tmp68_ = _tmp67_;
	_g_free0 (_tmp66_);
	_inner_error_ = _tmp68_;
	if (_inner_error_->domain == NUVOLA_JS_ERROR) {
		g_propagate_error (error, _inner_error_);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return NULL;
	} else {
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_variant_type_free0 (object_type);
	_g_variant_type_free0 (type);
}


GVariant*
nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx,
                                    const struct OpaqueJSValue* val,
                                    GError** error)
{
	GVariant* result = NULL;
	struct OpaqueJSValue* glob_object = NULL;
	struct OpaqueJSValue* _tmp9_;
	struct OpaqueJSValue* object = NULL;
	struct OpaqueJSValue* _tmp10_;
	struct OpaqueJSValue* _tmp11_;
	struct OpaqueJSValue* _tmp12_;
	struct OpaqueJSValue* _tmp13_;
	void** params = NULL;
	void** _tmp14_;
	gint params_length1;
	gint _params_size_;
	void** _tmp15_;
	gint _tmp15__length1;
	void* _tmp16_;
	const struct OpaqueJSValue* exception = NULL;
	const struct OpaqueJSValue* _result_ = NULL;
	struct OpaqueJSValue* _tmp17_;
	struct OpaqueJSValue* _tmp18_;
	void** _tmp19_;
	gint _tmp19__length1;
	const struct OpaqueJSValue* _tmp20_ = NULL;
	const struct OpaqueJSValue* _tmp21_;
	const struct OpaqueJSValue* _tmp22_;
	const struct OpaqueJSValue* _tmp28_;
	GVariant* _tmp71_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	if (JSValueIsNull (ctx, val)) {
		GVariant* _tmp0_;
		_tmp0_ = g_variant_new ("mv", NULL, NULL);
		g_variant_ref_sink (_tmp0_);
		result = _tmp0_;
		return result;
	}
	if (JSValueIsString (ctx, val)) {
		struct OpaqueJSString* _tmp1_;
		struct OpaqueJSString* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		_tmp1_ = JSValueToStringCopy (ctx, val, NULL);
		_tmp2_ = _tmp1_;
		_tmp3_ = nuvola_js_tools_utf8_string (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_variant_new_string (_tmp4_);
		g_variant_ref_sink (_tmp5_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_JSStringRelease0 (_tmp2_);
		result = _tmp6_;
		return result;
	}
	if (JSValueIsNumber (ctx, val)) {
		GVariant* _tmp7_;
		_tmp7_ = g_variant_new_double (JSValueToNumber (ctx, val, NULL));
		g_variant_ref_sink (_tmp7_);
		result = _tmp7_;
		return result;
	}
	if (JSValueIsBoolean (ctx, val)) {
		GVariant* _tmp8_;
		_tmp8_ = g_variant_new_boolean (JSValueToBoolean (ctx, val));
		g_variant_ref_sink (_tmp8_);
		result = _tmp8_;
		return result;
	}
	_tmp9_ = JSContextGetGlobalObject (ctx);
	glob_object = _tmp9_;
	_tmp10_ = glob_object;
	_tmp11_ = nuvola_js_tools_o_get_object (ctx, _tmp10_, "Array");
	object = _tmp11_;
	_tmp12_ = object;
	_tmp13_ = nuvola_js_tools_o_get_object (ctx, _tmp12_, "isArray");
	object = _tmp13_;
	_tmp14_ = g_new0 (void*, 1);
	params = _tmp14_;
	params_length1 = 1;
	_params_size_ = params_length1;
	_tmp15_ = params;
	_tmp15__length1 = params_length1;
	_tmp15_[0] = (void*) val;
	_tmp16_ = _tmp15_[0];
	_tmp17_ = object;
	_tmp18_ = glob_object;
	_tmp19_ = params;
	_tmp19__length1 = params_length1;
	_tmp21_ = JSObjectCallAsFunction (ctx, _tmp17_, _tmp18_, (size_t) ((_tmp19__length1 * sizeof (void*)) / sizeof (const struct OpaqueJSValue*)), (const struct OpaqueJSValue**) _tmp19_, &_tmp20_);
	_0 (exception);
	exception = _tmp20_;
	_result_ = _tmp21_;
	_tmp22_ = exception;
	if (_tmp22_ != NULL) {
		gchar* _tmp23_ = NULL;
		const struct OpaqueJSValue* _tmp24_;
		gchar* _tmp25_;
		GError* _tmp27_;
		_tmp24_ = exception;
		_tmp25_ = nuvola_js_tools_exception_to_string (ctx, _tmp24_);
		_tmp23_ = _tmp25_;
		if (_tmp23_ == NULL) {
			gchar* _tmp26_;
			_tmp26_ = g_strdup ("(null)");
			_g_free0 (_tmp23_);
			_tmp23_ = _tmp26_;
		}
		_tmp27_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "Unsupported type. %s", _tmp23_);
		_inner_error_ = _tmp27_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (_tmp23_);
			_0 (exception);
			params = (g_free (params), NULL);
			return NULL;
		} else {
			_g_free0 (_tmp23_);
			_0 (exception);
			params = (g_free (params), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (_tmp23_);
	}
	_tmp28_ = _result_;
	if (JSValueToBoolean (ctx, _tmp28_)) {
		GVariantBuilder* builder = NULL;
		GVariantType* _tmp29_;
		GVariantType* _tmp30_;
		GVariantBuilder* _tmp31_;
		GVariantBuilder* _tmp32_;
		gint size = 0;
		struct OpaqueJSValue* _tmp33_;
		GVariantBuilder* _tmp44_;
		GVariant* _tmp45_;
		_tmp29_ = g_variant_type_new ("av");
		_tmp30_ = _tmp29_;
		_tmp31_ = g_variant_builder_new (_tmp30_);
		_tmp32_ = _tmp31_;
		_g_variant_type_free0 (_tmp30_);
		builder = _tmp32_;
		object = (struct OpaqueJSValue*) val;
		_tmp33_ = object;
		size = (gint) nuvola_js_tools_o_get_number (ctx, _tmp33_, "length");
		{
			guint i = 0U;
			i = (guint) 0;
			{
				gboolean _tmp34_ = FALSE;
				_tmp34_ = TRUE;
				while (TRUE) {
					guint _tmp36_;
					gint _tmp37_;
					GVariant* _tmp38_ = NULL;
					struct OpaqueJSValue* _tmp39_;
					guint _tmp40_;
					const struct OpaqueJSValue* _tmp41_;
					GVariant* _tmp42_;
					GVariantBuilder* _tmp43_;
					if (!_tmp34_) {
						guint _tmp35_;
						_tmp35_ = i;
						i = _tmp35_ + 1;
					}
					_tmp34_ = FALSE;
					_tmp36_ = i;
					_tmp37_ = size;
					if (!(_tmp36_ < ((guint) _tmp37_))) {
						break;
					}
					_tmp39_ = object;
					_tmp40_ = i;
					_tmp41_ = JSObjectGetPropertyAtIndex (ctx, _tmp39_, _tmp40_, NULL);
					_tmp42_ = nuvola_js_tools_variant_from_value (ctx, _tmp41_, &_inner_error_);
					_tmp38_ = _tmp42_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_variant_builder_unref0 (builder);
							_0 (exception);
							params = (g_free (params), NULL);
							return NULL;
						} else {
							_g_variant_builder_unref0 (builder);
							_0 (exception);
							params = (g_free (params), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp43_ = builder;
					g_variant_builder_add (_tmp43_, "v", _tmp38_, NULL);
					_g_variant_unref0 (_tmp38_);
				}
			}
		}
		_tmp44_ = builder;
		_tmp45_ = g_variant_builder_end (_tmp44_);
		g_variant_ref_sink (_tmp45_);
		result = _tmp45_;
		_g_variant_builder_unref0 (builder);
		_0 (exception);
		params = (g_free (params), NULL);
		return result;
	}
	if (JSValueIsObject (ctx, val)) {
		struct OpaqueJSPropertyNameArray* properties = NULL;
		struct OpaqueJSValue* _tmp46_;
		struct OpaqueJSPropertyNameArray* _tmp47_;
		gsize size = 0UL;
		struct OpaqueJSPropertyNameArray* _tmp48_;
		GVariantBuilder* builder = NULL;
		GVariantType* _tmp49_;
		GVariantType* _tmp50_;
		GVariantBuilder* _tmp51_;
		GVariantBuilder* _tmp52_;
		GVariantBuilder* _tmp69_;
		GVariant* _tmp70_;
		object = (struct OpaqueJSValue*) val;
		_tmp46_ = object;
		_tmp47_ = JSObjectCopyPropertyNames (ctx, _tmp46_);
		properties = _tmp47_;
		_tmp48_ = properties;
		size = JSPropertyNameArrayGetCount (_tmp48_);
		_tmp49_ = g_variant_type_new ("a{smv}");
		_tmp50_ = _tmp49_;
		_tmp51_ = g_variant_builder_new (_tmp50_);
		_tmp52_ = _tmp51_;
		_g_variant_type_free0 (_tmp50_);
		builder = _tmp52_;
		{
			gsize i = 0UL;
			i = (gsize) 0;
			{
				gboolean _tmp53_ = FALSE;
				_tmp53_ = TRUE;
				while (TRUE) {
					gsize _tmp55_;
					gsize _tmp56_;
					struct OpaqueJSString* js_property = NULL;
					struct OpaqueJSPropertyNameArray* _tmp57_;
					gsize _tmp58_;
					struct OpaqueJSString* _tmp59_;
					GVariant* value = NULL;
					struct OpaqueJSValue* _tmp60_;
					struct OpaqueJSString* _tmp61_;
					const struct OpaqueJSValue* _tmp62_;
					GVariant* _tmp63_;
					GVariantBuilder* _tmp64_;
					struct OpaqueJSString* _tmp65_;
					gchar* _tmp66_;
					gchar* _tmp67_;
					GVariant* _tmp68_;
					if (!_tmp53_) {
						gsize _tmp54_;
						_tmp54_ = i;
						i = _tmp54_ + 1;
					}
					_tmp53_ = FALSE;
					_tmp55_ = i;
					_tmp56_ = size;
					if (!(_tmp55_ < _tmp56_)) {
						break;
					}
					_tmp57_ = properties;
					_tmp58_ = i;
					_tmp59_ = JSPropertyNameArrayGetNameAtIndex (_tmp57_, _tmp58_);
					js_property = _tmp59_;
					_tmp60_ = object;
					_tmp61_ = js_property;
					_tmp62_ = JSObjectGetProperty (ctx, _tmp60_, _tmp61_, NULL);
					_tmp63_ = nuvola_js_tools_variant_from_value (ctx, _tmp62_, &_inner_error_);
					value = _tmp63_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_variant_builder_unref0 (builder);
							_JSPropertyNameArrayRelease0 (properties);
							_0 (exception);
							params = (g_free (params), NULL);
							return NULL;
						} else {
							_g_variant_builder_unref0 (builder);
							_JSPropertyNameArrayRelease0 (properties);
							_0 (exception);
							params = (g_free (params), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp64_ = builder;
					_tmp65_ = js_property;
					_tmp66_ = nuvola_js_tools_utf8_string (_tmp65_);
					_tmp67_ = _tmp66_;
					_tmp68_ = value;
					g_variant_builder_add (_tmp64_, "{smv}", _tmp67_, _tmp68_, NULL);
					_g_free0 (_tmp67_);
					_g_variant_unref0 (value);
				}
			}
		}
		_tmp69_ = builder;
		_tmp70_ = g_variant_builder_end (_tmp69_);
		g_variant_ref_sink (_tmp70_);
		result = _tmp70_;
		_g_variant_builder_unref0 (builder);
		_JSPropertyNameArrayRelease0 (properties);
		_0 (exception);
		params = (g_free (params), NULL);
		return result;
	}
	g_warning ("jstools.vala:377: Attempt to convert `undefined` JavaScript type. This" \
" might be a programmer error!");
	_tmp71_ = g_variant_new_string ("<ERROR: UNDEFINED VALUE TYPE>");
	g_variant_ref_sink (_tmp71_);
	result = _tmp71_;
	_0 (exception);
	params = (g_free (params), NULL);
	return result;
}



