/* ArchiveReader.c generated by valac 0.40.6, the Vala compiler
 * generated from ArchiveReader.vala, do not modify */

/*
 * Copyright 2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <archive_entry.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <unistd.h>
#include <gobject/gvaluecollector.h>


#define NUVOLA_TYPE_ARCHIVE_READER (nuvola_archive_reader_get_type ())
#define NUVOLA_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_ARCHIVE_READER, NuvolaArchiveReader))
#define NUVOLA_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_ARCHIVE_READER, NuvolaArchiveReaderClass))
#define NUVOLA_IS_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_ARCHIVE_READER))
#define NUVOLA_IS_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_ARCHIVE_READER))
#define NUVOLA_ARCHIVE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_ARCHIVE_READER, NuvolaArchiveReaderClass))

typedef struct _NuvolaArchiveReader NuvolaArchiveReader;
typedef struct _NuvolaArchiveReaderClass NuvolaArchiveReaderClass;
typedef struct _NuvolaArchiveReaderPrivate NuvolaArchiveReaderPrivate;
#define _archive_read_finish0(var) ((var == NULL) ? NULL : (var = (archive_read_finish (var), NULL)))
#define _nuvola_archive_reader_unref0(var) ((var == NULL) ? NULL : (var = (nuvola_archive_reader_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _NuvolaParamSpecArchiveReader NuvolaParamSpecArchiveReader;

struct _NuvolaArchiveReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NuvolaArchiveReaderPrivate * priv;
};

struct _NuvolaArchiveReaderClass {
	GTypeClass parent_class;
	void (*finalize) (NuvolaArchiveReader *self);
};

struct _NuvolaArchiveReaderPrivate {
	struct archive* reader;
	struct archive_entry* entry;
};

typedef enum  {
	NUVOLA_ARCHIVE_READER_ERROR_OPEN,
	NUVOLA_ARCHIVE_READER_ERROR_RENAME,
	NUVOLA_ARCHIVE_READER_ERROR_READ
} NuvolaArchiveReaderError;
#define NUVOLA_ARCHIVE_READER_ERROR nuvola_archive_reader_error_quark ()
struct _NuvolaParamSpecArchiveReader {
	GParamSpec parent_instance;
};


static gpointer nuvola_archive_reader_parent_class = NULL;

gpointer nuvola_archive_reader_ref (gpointer instance);
void nuvola_archive_reader_unref (gpointer instance);
GParamSpec* nuvola_param_spec_archive_reader (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
void nuvola_value_set_archive_reader (GValue* value,
                                      gpointer v_object);
void nuvola_value_take_archive_reader (GValue* value,
                                       gpointer v_object);
gpointer nuvola_value_get_archive_reader (const GValue* value);
GType nuvola_archive_reader_get_type (void) G_GNUC_CONST;
#define NUVOLA_ARCHIVE_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_ARCHIVE_READER, NuvolaArchiveReaderPrivate))
GQuark nuvola_archive_reader_error_quark (void);
NuvolaArchiveReader* nuvola_archive_reader_new (const gchar* path,
                                                gint block_size,
                                                GError** error);
NuvolaArchiveReader* nuvola_archive_reader_construct (GType object_type,
                                                      const gchar* path,
                                                      gint block_size,
                                                      GError** error);
static gboolean nuvola_archive_reader_not_ok (int _result_);
static NuvolaArchiveReader* nuvola_archive_reader_new_inner (gpointer open_cb,
                                                      void* open_cb_target,
                                                      gpointer read_cb,
                                                      void* read_cb_target,
                                                      gpointer close_cb,
                                                      void* close_cb_target,
                                                      GError** error);
static NuvolaArchiveReader* nuvola_archive_reader_construct_inner (GType object_type,
                                                            gpointer open_cb,
                                                            void* open_cb_target,
                                                            gpointer read_cb,
                                                            void* read_cb_target,
                                                            gpointer close_cb,
                                                            void* close_cb_target,
                                                            GError** error);
gboolean nuvola_archive_reader_next (NuvolaArchiveReader* self,
                                     struct archive_entry* * entry);
static gboolean nuvola_archive_reader_is_ok (int _result_);
NuvolaArchiveReader* nuvola_archive_reader_read_archive (NuvolaArchiveReader* self,
                                                         GError** error);
static gint nuvola_archive_reader_noop_cb (NuvolaArchiveReader* self,
                                    struct archive* archive);
static gint _nuvola_archive_reader_noop_cb_gpointer (struct archive* archive,
                                              gpointer self);
static gssize nuvola_archive_reader_read_callback (NuvolaArchiveReader* self,
                                            struct archive* archive,
                                            void** buffer);
static gssize _nuvola_archive_reader_read_callback_gpointer (struct archive* archive,
                                                      gpointer self,
                                                      void** buffer);
void nuvola_archive_reader_read_data_to_file (NuvolaArchiveReader* self,
                                              const gchar* path,
                                              GError** error);
static void nuvola_archive_reader_finalize (NuvolaArchiveReader * obj);


NuvolaArchiveReader*
nuvola_archive_reader_construct (GType object_type,
                                 const gchar* path,
                                 gint block_size,
                                 GError** error)
{
	NuvolaArchiveReader* self = NULL;
	struct archive* _tmp0_;
	struct archive* _tmp1_;
	struct archive* _tmp2_;
	struct archive* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	self = (NuvolaArchiveReader*) g_type_create_instance (object_type);
	_tmp0_ = archive_read_new ();
	_archive_read_finish0 (self->priv->reader);
	self->priv->reader = _tmp0_;
	_tmp1_ = self->priv->reader;
	archive_read_support_format_all (_tmp1_);
	_tmp2_ = self->priv->reader;
	archive_read_support_filter_all (_tmp2_);
	_tmp3_ = self->priv->reader;
	if (nuvola_archive_reader_not_ok (archive_read_open_filename (_tmp3_, path, (gsize) block_size))) {
		struct archive* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
		_tmp4_ = self->priv->reader;
		_tmp5_ = archive_error_string (_tmp4_);
		_tmp6_ = g_error_new (NUVOLA_ARCHIVE_READER_ERROR, NUVOLA_ARCHIVE_READER_ERROR_OPEN, "Cannot open archive '%s'. %s", path, _tmp5_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == NUVOLA_ARCHIVE_READER_ERROR) {
			g_propagate_error (error, _inner_error_);
			_nuvola_archive_reader_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


NuvolaArchiveReader*
nuvola_archive_reader_new (const gchar* path,
                           gint block_size,
                           GError** error)
{
	return nuvola_archive_reader_construct (NUVOLA_TYPE_ARCHIVE_READER, path, block_size, error);
}


static NuvolaArchiveReader*
nuvola_archive_reader_construct_inner (GType object_type,
                                       gpointer open_cb,
                                       void* open_cb_target,
                                       gpointer read_cb,
                                       void* read_cb_target,
                                       gpointer close_cb,
                                       void* close_cb_target,
                                       GError** error)
{
	NuvolaArchiveReader* self = NULL;
	struct archive* _tmp0_;
	struct archive* _tmp1_;
	struct archive* _tmp2_;
	struct archive* _tmp3_;
	GError * _inner_error_ = NULL;
	self = (NuvolaArchiveReader*) g_type_create_instance (object_type);
	_tmp0_ = archive_read_new ();
	_archive_read_finish0 (self->priv->reader);
	self->priv->reader = _tmp0_;
	_tmp1_ = self->priv->reader;
	archive_read_support_format_all (_tmp1_);
	_tmp2_ = self->priv->reader;
	archive_read_support_filter_all (_tmp2_);
	_tmp3_ = self->priv->reader;
	if (nuvola_archive_reader_not_ok (archive_read_open (_tmp3_, close_cb_target, open_cb, read_cb, close_cb))) {
		struct archive* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
		_tmp4_ = self->priv->reader;
		_tmp5_ = archive_error_string (_tmp4_);
		_tmp6_ = g_error_new (NUVOLA_ARCHIVE_READER_ERROR, NUVOLA_ARCHIVE_READER_ERROR_OPEN, "Cannot open inner archive. %s", _tmp5_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == NUVOLA_ARCHIVE_READER_ERROR) {
			g_propagate_error (error, _inner_error_);
			_nuvola_archive_reader_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


static NuvolaArchiveReader*
nuvola_archive_reader_new_inner (gpointer open_cb,
                                 void* open_cb_target,
                                 gpointer read_cb,
                                 void* read_cb_target,
                                 gpointer close_cb,
                                 void* close_cb_target,
                                 GError** error)
{
	return nuvola_archive_reader_construct_inner (NUVOLA_TYPE_ARCHIVE_READER, open_cb, open_cb_target, read_cb, read_cb_target, close_cb, close_cb_target, error);
}


gboolean
nuvola_archive_reader_next (NuvolaArchiveReader* self,
                            struct archive_entry* * entry)
{
	struct archive_entry* _vala_entry = NULL;
	gboolean result = FALSE;
	struct archive* _tmp0_;
	struct archive_entry* _tmp1_ = NULL;
	int _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->reader;
	_tmp2_ = archive_read_next_header (_tmp0_, &_tmp1_);
	self->priv->entry = _tmp1_;
	if (nuvola_archive_reader_is_ok (_tmp2_)) {
		struct archive_entry* _tmp3_;
		_tmp3_ = self->priv->entry;
		_vala_entry = _tmp3_;
		result = TRUE;
		if (entry) {
			*entry = _vala_entry;
		}
		return result;
	}
	_vala_entry = NULL;
	result = FALSE;
	if (entry) {
		*entry = _vala_entry;
	}
	return result;
}


static gint
_nuvola_archive_reader_noop_cb_gpointer (struct archive* archive,
                                         gpointer self)
{
	gint result;
	result = nuvola_archive_reader_noop_cb ((NuvolaArchiveReader*) self, archive);
	return result;
}


static gssize
_nuvola_archive_reader_read_callback_gpointer (struct archive* archive,
                                               gpointer self,
                                               void** buffer)
{
	gssize result;
	result = nuvola_archive_reader_read_callback ((NuvolaArchiveReader*) self, archive, buffer);
	return result;
}


NuvolaArchiveReader*
nuvola_archive_reader_read_archive (NuvolaArchiveReader* self,
                                    GError** error)
{
	NuvolaArchiveReader* result = NULL;
	NuvolaArchiveReader* _tmp0_ = NULL;
	NuvolaArchiveReader* _tmp1_;
	NuvolaArchiveReader* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = nuvola_archive_reader_new_inner (_nuvola_archive_reader_noop_cb_gpointer, self, _nuvola_archive_reader_read_callback_gpointer, self, _nuvola_archive_reader_noop_cb_gpointer, self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_ARCHIVE_READER_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_nuvola_archive_reader_unref0 (_tmp0_);
	return result;
}


void
nuvola_archive_reader_read_data_to_file (NuvolaArchiveReader* self,
                                         const gchar* path,
                                         GError** error)
{
	gchar* tmp_path = NULL;
	gchar* _tmp0_;
	gint fd = 0;
	const gchar* _tmp1_;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = g_strconcat (path, ".tmpXXXXXX", NULL);
	tmp_path = _tmp0_;
	_tmp1_ = tmp_path;
	fd = g_mkstemp (_tmp1_);
	_tmp2_ = fd;
	if (_tmp2_ < 0) {
		const gchar* _tmp3_;
		GError* _tmp4_;
		_tmp3_ = tmp_path;
		_tmp4_ = g_error_new (NUVOLA_ARCHIVE_READER_ERROR, NUVOLA_ARCHIVE_READER_ERROR_OPEN, "Cannot open temporary file '%s'.", _tmp3_);
		_inner_error_ = _tmp4_;
		g_propagate_error (error, _inner_error_);
		_g_free0 (tmp_path);
		return;
	}
	{
		struct archive* _tmp5_;
		gint _tmp6_;
		const gchar* _tmp10_;
		_tmp5_ = self->priv->reader;
		_tmp6_ = fd;
		if (nuvola_archive_reader_not_ok (archive_read_data_into_fd (_tmp5_, _tmp6_))) {
			struct archive* _tmp7_;
			const gchar* _tmp8_;
			GError* _tmp9_;
			_tmp7_ = self->priv->reader;
			_tmp8_ = archive_error_string (_tmp7_);
			_tmp9_ = g_error_new (NUVOLA_ARCHIVE_READER_ERROR, NUVOLA_ARCHIVE_READER_ERROR_READ, "Failed to read archive data. %", _tmp8_);
			_inner_error_ = _tmp9_;
			goto __finally78;
		}
		_tmp10_ = tmp_path;
		if (g_rename (_tmp10_, path) != 0) {
			const gchar* _tmp11_;
			GError* _tmp12_;
			_tmp11_ = tmp_path;
			_tmp12_ = g_error_new (NUVOLA_ARCHIVE_READER_ERROR, NUVOLA_ARCHIVE_READER_ERROR_RENAME, "Cannot rename '%s' to '%s'.", _tmp11_, path);
			_inner_error_ = _tmp12_;
			goto __finally78;
		}
	}
	__finally78:
	{
		gint _tmp13_;
		const gchar* _tmp14_;
		_tmp13_ = fd;
		close (_tmp13_);
		_tmp14_ = tmp_path;
		g_unlink (_tmp14_);
	}
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (tmp_path);
		return;
	}
	_g_free0 (tmp_path);
}


static gssize
nuvola_archive_reader_read_callback (NuvolaArchiveReader* self,
                                     struct archive* archive,
                                     void** buffer)
{
	void* _vala_buffer = NULL;
	gssize result = 0L;
	static const gint BUFFER_SIZE = 4096;
	void* _tmp0_;
	struct archive* _tmp1_;
	g_return_val_if_fail (self != NULL, 0L);
	g_return_val_if_fail (archive != NULL, 0L);
	_tmp0_ = g_malloc ((gsize) BUFFER_SIZE);
	_vala_buffer = _tmp0_;
	_tmp1_ = self->priv->reader;
	result = archive_read_data (_tmp1_, _vala_buffer, (gsize) BUFFER_SIZE);
	if (buffer) {
		*buffer = _vala_buffer;
	}
	return result;
}


static gint
nuvola_archive_reader_noop_cb (NuvolaArchiveReader* self,
                               struct archive* archive)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (archive != NULL, 0);
	result = (gint) ARCHIVE_OK;
	return result;
}


static gboolean
nuvola_archive_reader_is_ok (int _result_)
{
	gboolean result = FALSE;
	result = _result_ == ARCHIVE_OK;
	return result;
}


static gboolean
nuvola_archive_reader_not_ok (int _result_)
{
	gboolean result = FALSE;
	result = _result_ != ARCHIVE_OK;
	return result;
}


static void
nuvola_value_archive_reader_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
nuvola_value_archive_reader_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		nuvola_archive_reader_unref (value->data[0].v_pointer);
	}
}


static void
nuvola_value_archive_reader_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = nuvola_archive_reader_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
nuvola_value_archive_reader_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
nuvola_value_archive_reader_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		NuvolaArchiveReader * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = nuvola_archive_reader_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
nuvola_value_archive_reader_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	NuvolaArchiveReader ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = nuvola_archive_reader_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
nuvola_param_spec_archive_reader (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	NuvolaParamSpecArchiveReader* spec;
	g_return_val_if_fail (g_type_is_a (object_type, NUVOLA_TYPE_ARCHIVE_READER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
nuvola_value_get_archive_reader (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_ARCHIVE_READER), NULL);
	return value->data[0].v_pointer;
}


void
nuvola_value_set_archive_reader (GValue* value,
                                 gpointer v_object)
{
	NuvolaArchiveReader * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_ARCHIVE_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_ARCHIVE_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		nuvola_archive_reader_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_archive_reader_unref (old);
	}
}


void
nuvola_value_take_archive_reader (GValue* value,
                                  gpointer v_object)
{
	NuvolaArchiveReader * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_ARCHIVE_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_ARCHIVE_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_archive_reader_unref (old);
	}
}


static void
nuvola_archive_reader_class_init (NuvolaArchiveReaderClass * klass)
{
	nuvola_archive_reader_parent_class = g_type_class_peek_parent (klass);
	((NuvolaArchiveReaderClass *) klass)->finalize = nuvola_archive_reader_finalize;
	g_type_class_add_private (klass, sizeof (NuvolaArchiveReaderPrivate));
}


static void
nuvola_archive_reader_instance_init (NuvolaArchiveReader * self)
{
	self->priv = NUVOLA_ARCHIVE_READER_GET_PRIVATE (self);
	self->priv->reader = NULL;
	self->priv->entry = NULL;
	self->ref_count = 1;
}


static void
nuvola_archive_reader_finalize (NuvolaArchiveReader * obj)
{
	NuvolaArchiveReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_ARCHIVE_READER, NuvolaArchiveReader);
	g_signal_handlers_destroy (self);
	_archive_read_finish0 (self->priv->reader);
}


GType
nuvola_archive_reader_get_type (void)
{
	static volatile gsize nuvola_archive_reader_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_archive_reader_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { nuvola_value_archive_reader_init, nuvola_value_archive_reader_free_value, nuvola_value_archive_reader_copy_value, nuvola_value_archive_reader_peek_pointer, "p", nuvola_value_archive_reader_collect_value, "p", nuvola_value_archive_reader_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaArchiveReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_archive_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaArchiveReader), 0, (GInstanceInitFunc) nuvola_archive_reader_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType nuvola_archive_reader_type_id;
		nuvola_archive_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NuvolaArchiveReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&nuvola_archive_reader_type_id__volatile, nuvola_archive_reader_type_id);
	}
	return nuvola_archive_reader_type_id__volatile;
}


gpointer
nuvola_archive_reader_ref (gpointer instance)
{
	NuvolaArchiveReader * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
nuvola_archive_reader_unref (gpointer instance)
{
	NuvolaArchiveReader * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		NUVOLA_ARCHIVE_READER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


GQuark
nuvola_archive_reader_error_quark (void)
{
	return g_quark_from_static_string ("nuvola_archive_reader_error-quark");
}



