/* AudioTypes.c generated by valac 0.40.6, the Vala compiler
 * generated from AudioTypes.vala, do not modify */

/*
 * Copyright 2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <pulse/pulseaudio.h>
#include <glib/gstdio.h>


#define NUVOLA_TYPE_AUDIO_CARD (nuvola_audio_card_get_type ())
typedef struct _NuvolaAudioCard NuvolaAudioCard;
#define _g_free0(var) (var = (g_free (var), NULL))

#define NUVOLA_TYPE_AUDIO_SINK (nuvola_audio_sink_get_type ())

#define NUVOLA_TYPE_AUDIO_SINK_PORT (nuvola_audio_sink_port_get_type ())

#define NUVOLA_TYPE_AUDIO_PORT_AVAILABLE (nuvola_audio_port_available_get_type ())
typedef struct _NuvolaAudioSinkPort NuvolaAudioSinkPort;
typedef struct _NuvolaAudioSink NuvolaAudioSink;

#define NUVOLA_TYPE_AUDIO_SINK_INPUT (nuvola_audio_sink_input_get_type ())
typedef struct _NuvolaAudioSinkInput NuvolaAudioSinkInput;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	NUVOLA_AUDIO_ERROR_GENERIC
} NuvolaAudioError;
#define NUVOLA_AUDIO_ERROR nuvola_audio_error_quark ()
struct _NuvolaAudioCard {
	gchar* name;
	guint32 index;
	gchar* driver;
};

typedef enum  {
	NUVOLA_AUDIO_PORT_AVAILABLE_UNKNOWN,
	NUVOLA_AUDIO_PORT_AVAILABLE_NO,
	NUVOLA_AUDIO_PORT_AVAILABLE_YES
} NuvolaAudioPortAvailable;

struct _NuvolaAudioSinkPort {
	gchar* name;
	gchar* description;
	guint32 priority;
	NuvolaAudioPortAvailable available;
};

struct _NuvolaAudioSink {
	gchar* name;
	gchar* description;
	guint32 index;
	NuvolaAudioSinkPort* ports;
	gint ports_length1;
};

struct _NuvolaAudioSinkInput {
	gchar* name;
	guint32 index;
	guint32 sink;
	guint32 client;
	gchar* app_process_binary;
	gint app_process_id;
};



GQuark nuvola_audio_error_quark (void);
GType nuvola_audio_card_get_type (void) G_GNUC_CONST;
NuvolaAudioCard* nuvola_audio_card_dup (const NuvolaAudioCard* self);
void nuvola_audio_card_free (NuvolaAudioCard* self);
void nuvola_audio_card_copy (const NuvolaAudioCard* self,
                             NuvolaAudioCard* dest);
void nuvola_audio_card_destroy (NuvolaAudioCard* self);
GType nuvola_audio_sink_get_type (void) G_GNUC_CONST;
GType nuvola_audio_sink_port_get_type (void) G_GNUC_CONST;
GType nuvola_audio_port_available_get_type (void) G_GNUC_CONST;
NuvolaAudioSinkPort* nuvola_audio_sink_port_dup (const NuvolaAudioSinkPort* self);
void nuvola_audio_sink_port_free (NuvolaAudioSinkPort* self);
void nuvola_audio_sink_port_copy (const NuvolaAudioSinkPort* self,
                                  NuvolaAudioSinkPort* dest);
void nuvola_audio_sink_port_destroy (NuvolaAudioSinkPort* self);
NuvolaAudioSink* nuvola_audio_sink_dup (const NuvolaAudioSink* self);
void nuvola_audio_sink_free (NuvolaAudioSink* self);
void nuvola_audio_sink_copy (const NuvolaAudioSink* self,
                             NuvolaAudioSink* dest);
void nuvola_audio_sink_destroy (NuvolaAudioSink* self);
static void _vala_NuvolaAudioSinkPort_array_free (NuvolaAudioSinkPort * array,
                                           gint array_length);
static NuvolaAudioSinkPort* _vala_array_dup5 (NuvolaAudioSinkPort* self,
                                       int length);
GType nuvola_audio_sink_input_get_type (void) G_GNUC_CONST;
NuvolaAudioSinkInput* nuvola_audio_sink_input_dup (const NuvolaAudioSinkInput* self);
void nuvola_audio_sink_input_free (NuvolaAudioSinkInput* self);
void nuvola_audio_sink_input_copy (const NuvolaAudioSinkInput* self,
                                   NuvolaAudioSinkInput* dest);
void nuvola_audio_sink_input_destroy (NuvolaAudioSinkInput* self);
gchar* nuvola_audio_sink_port_to_string (NuvolaAudioSinkPort *self);
gboolean nuvola_audio_sink_port_are_headphones (NuvolaAudioSinkPort *self);
gchar* nuvola_audio_port_available_to_string (NuvolaAudioPortAvailable self);
GError* nuvola_error_from_ctx (pa_context* context,
                               const gchar* msg);
gint nuvola_get_ppid (gint pid);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GQuark
nuvola_audio_error_quark (void)
{
	return g_quark_from_static_string ("nuvola_audio_error-quark");
}


void
nuvola_audio_card_copy (const NuvolaAudioCard* self,
                        NuvolaAudioCard* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	guint32 _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).index;
	(*dest).index = _tmp2_;
	_tmp3_ = (*self).driver;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 ((*dest).driver);
	(*dest).driver = _tmp4_;
}


void
nuvola_audio_card_destroy (NuvolaAudioCard* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).driver);
}


NuvolaAudioCard*
nuvola_audio_card_dup (const NuvolaAudioCard* self)
{
	NuvolaAudioCard* dup;
	dup = g_new0 (NuvolaAudioCard, 1);
	nuvola_audio_card_copy (self, dup);
	return dup;
}


void
nuvola_audio_card_free (NuvolaAudioCard* self)
{
	nuvola_audio_card_destroy (self);
	g_free (self);
}


GType
nuvola_audio_card_get_type (void)
{
	static volatile gsize nuvola_audio_card_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_audio_card_type_id__volatile)) {
		GType nuvola_audio_card_type_id;
		nuvola_audio_card_type_id = g_boxed_type_register_static ("NuvolaAudioCard", (GBoxedCopyFunc) nuvola_audio_card_dup, (GBoxedFreeFunc) nuvola_audio_card_free);
		g_once_init_leave (&nuvola_audio_card_type_id__volatile, nuvola_audio_card_type_id);
	}
	return nuvola_audio_card_type_id__volatile;
}


static void
_vala_NuvolaAudioSinkPort_array_free (NuvolaAudioSinkPort * array,
                                      gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			nuvola_audio_sink_port_destroy (&array[i]);
		}
	}
	g_free (array);
}


static NuvolaAudioSinkPort*
_vala_array_dup5 (NuvolaAudioSinkPort* self,
                  int length)
{
	NuvolaAudioSinkPort* result;
	int i;
	result = g_new0 (NuvolaAudioSinkPort, length);
	for (i = 0; i < length; i++) {
		NuvolaAudioSinkPort _tmp0_ = {0};
		nuvola_audio_sink_port_copy (&self[i], &_tmp0_);
		result[i] = _tmp0_;
	}
	return result;
}


void
nuvola_audio_sink_copy (const NuvolaAudioSink* self,
                        NuvolaAudioSink* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	guint32 _tmp4_;
	NuvolaAudioSinkPort* _tmp5_;
	gint _tmp5__length1;
	NuvolaAudioSinkPort* _tmp6_;
	gint _tmp6__length1;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).description;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).description);
	(*dest).description = _tmp3_;
	_tmp4_ = (*self).index;
	(*dest).index = _tmp4_;
	_tmp5_ = (*self).ports;
	_tmp5__length1 = (*self).ports_length1;
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup5 (_tmp5_, _tmp5__length1) : ((gpointer) _tmp5_);
	_tmp6__length1 = _tmp5__length1;
	(*dest).ports = (_vala_NuvolaAudioSinkPort_array_free ((*dest).ports, (*dest).ports_length1), NULL);
	(*dest).ports = _tmp6_;
	(*dest).ports_length1 = _tmp6__length1;
}


void
nuvola_audio_sink_destroy (NuvolaAudioSink* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).description);
	(*self).ports = (_vala_NuvolaAudioSinkPort_array_free ((*self).ports, (*self).ports_length1), NULL);
}


NuvolaAudioSink*
nuvola_audio_sink_dup (const NuvolaAudioSink* self)
{
	NuvolaAudioSink* dup;
	dup = g_new0 (NuvolaAudioSink, 1);
	nuvola_audio_sink_copy (self, dup);
	return dup;
}


void
nuvola_audio_sink_free (NuvolaAudioSink* self)
{
	nuvola_audio_sink_destroy (self);
	g_free (self);
}


GType
nuvola_audio_sink_get_type (void)
{
	static volatile gsize nuvola_audio_sink_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_audio_sink_type_id__volatile)) {
		GType nuvola_audio_sink_type_id;
		nuvola_audio_sink_type_id = g_boxed_type_register_static ("NuvolaAudioSink", (GBoxedCopyFunc) nuvola_audio_sink_dup, (GBoxedFreeFunc) nuvola_audio_sink_free);
		g_once_init_leave (&nuvola_audio_sink_type_id__volatile, nuvola_audio_sink_type_id);
	}
	return nuvola_audio_sink_type_id__volatile;
}


void
nuvola_audio_sink_input_copy (const NuvolaAudioSinkInput* self,
                              NuvolaAudioSinkInput* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
	guint32 _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).index;
	(*dest).index = _tmp2_;
	_tmp3_ = (*self).sink;
	(*dest).sink = _tmp3_;
	_tmp4_ = (*self).client;
	(*dest).client = _tmp4_;
	_tmp5_ = (*self).app_process_binary;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 ((*dest).app_process_binary);
	(*dest).app_process_binary = _tmp6_;
	_tmp7_ = (*self).app_process_id;
	(*dest).app_process_id = _tmp7_;
}


void
nuvola_audio_sink_input_destroy (NuvolaAudioSinkInput* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).app_process_binary);
}


NuvolaAudioSinkInput*
nuvola_audio_sink_input_dup (const NuvolaAudioSinkInput* self)
{
	NuvolaAudioSinkInput* dup;
	dup = g_new0 (NuvolaAudioSinkInput, 1);
	nuvola_audio_sink_input_copy (self, dup);
	return dup;
}


void
nuvola_audio_sink_input_free (NuvolaAudioSinkInput* self)
{
	nuvola_audio_sink_input_destroy (self);
	g_free (self);
}


GType
nuvola_audio_sink_input_get_type (void)
{
	static volatile gsize nuvola_audio_sink_input_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_audio_sink_input_type_id__volatile)) {
		GType nuvola_audio_sink_input_type_id;
		nuvola_audio_sink_input_type_id = g_boxed_type_register_static ("NuvolaAudioSinkInput", (GBoxedCopyFunc) nuvola_audio_sink_input_dup, (GBoxedFreeFunc) nuvola_audio_sink_input_free);
		g_once_init_leave (&nuvola_audio_sink_input_type_id__volatile, nuvola_audio_sink_input_type_id);
	}
	return nuvola_audio_sink_input_type_id__volatile;
}


gchar*
nuvola_audio_sink_port_to_string (NuvolaAudioSinkPort *self)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	guint32 _tmp3_;
	NuvolaAudioPortAvailable _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	if (nuvola_audio_sink_port_are_headphones (&(*self))) {
		_tmp0_ = "yes";
	} else {
		_tmp0_ = "no";
	}
	_tmp1_ = (*self).name;
	_tmp2_ = (*self).description;
	_tmp3_ = (*self).priority;
	_tmp4_ = (*self).available;
	_tmp5_ = nuvola_audio_port_available_to_string (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup_printf ("%s: %s (priority %u, available: %s, headphones: %s)", _tmp1_, _tmp2_, (guint) _tmp3_, _tmp6_, _tmp0_);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	result = _tmp8_;
	return result;
}


gboolean
nuvola_audio_sink_port_are_headphones (NuvolaAudioSinkPort *self)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
	_tmp0_ = (*self).name;
	result = g_str_has_suffix (_tmp0_, "headphones");
	return result;
}


void
nuvola_audio_sink_port_copy (const NuvolaAudioSinkPort* self,
                             NuvolaAudioSinkPort* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	guint32 _tmp4_;
	NuvolaAudioPortAvailable _tmp5_;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).description;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).description);
	(*dest).description = _tmp3_;
	_tmp4_ = (*self).priority;
	(*dest).priority = _tmp4_;
	_tmp5_ = (*self).available;
	(*dest).available = _tmp5_;
}


void
nuvola_audio_sink_port_destroy (NuvolaAudioSinkPort* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).description);
}


NuvolaAudioSinkPort*
nuvola_audio_sink_port_dup (const NuvolaAudioSinkPort* self)
{
	NuvolaAudioSinkPort* dup;
	dup = g_new0 (NuvolaAudioSinkPort, 1);
	nuvola_audio_sink_port_copy (self, dup);
	return dup;
}


void
nuvola_audio_sink_port_free (NuvolaAudioSinkPort* self)
{
	nuvola_audio_sink_port_destroy (self);
	g_free (self);
}


GType
nuvola_audio_sink_port_get_type (void)
{
	static volatile gsize nuvola_audio_sink_port_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_audio_sink_port_type_id__volatile)) {
		GType nuvola_audio_sink_port_type_id;
		nuvola_audio_sink_port_type_id = g_boxed_type_register_static ("NuvolaAudioSinkPort", (GBoxedCopyFunc) nuvola_audio_sink_port_dup, (GBoxedFreeFunc) nuvola_audio_sink_port_free);
		g_once_init_leave (&nuvola_audio_sink_port_type_id__volatile, nuvola_audio_sink_port_type_id);
	}
	return nuvola_audio_sink_port_type_id__volatile;
}


gchar*
nuvola_audio_port_available_to_string (NuvolaAudioPortAvailable self)
{
	gchar* result = NULL;
	switch (self) {
		case NUVOLA_AUDIO_PORT_AVAILABLE_YES:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("yes");
			result = _tmp0_;
			return result;
		}
		case NUVOLA_AUDIO_PORT_AVAILABLE_NO:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("no");
			result = _tmp1_;
			return result;
		}
		case NUVOLA_AUDIO_PORT_AVAILABLE_UNKNOWN:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("unknown");
			result = _tmp2_;
			return result;
		}
		default:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("invalid value");
			result = _tmp3_;
			return result;
		}
	}
}


GType
nuvola_audio_port_available_get_type (void)
{
	static volatile gsize nuvola_audio_port_available_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_audio_port_available_type_id__volatile)) {
		static const GEnumValue values[] = {{NUVOLA_AUDIO_PORT_AVAILABLE_UNKNOWN, "NUVOLA_AUDIO_PORT_AVAILABLE_UNKNOWN", "unknown"}, {NUVOLA_AUDIO_PORT_AVAILABLE_NO, "NUVOLA_AUDIO_PORT_AVAILABLE_NO", "no"}, {NUVOLA_AUDIO_PORT_AVAILABLE_YES, "NUVOLA_AUDIO_PORT_AVAILABLE_YES", "yes"}, {0, NULL, NULL}};
		GType nuvola_audio_port_available_type_id;
		nuvola_audio_port_available_type_id = g_enum_register_static ("NuvolaAudioPortAvailable", values);
		g_once_init_leave (&nuvola_audio_port_available_type_id__volatile, nuvola_audio_port_available_type_id);
	}
	return nuvola_audio_port_available_type_id__volatile;
}


GError*
nuvola_error_from_ctx (pa_context* context,
                       const gchar* msg)
{
	GError* result = NULL;
	const gchar* _tmp0_;
	GError* _tmp1_;
	g_return_val_if_fail (context != NULL, NULL);
	_tmp0_ = pa_strerror (pa_context_errno (context));
	_tmp1_ = g_error_new (NUVOLA_AUDIO_ERROR, NUVOLA_AUDIO_ERROR_GENERIC, "%d: %s %s", (gint) pa_context_errno (context), _tmp0_, msg);
	result = _tmp1_;
	return result;
}


gint
nuvola_get_ppid (gint pid)
{
	gint result = 0;
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* contents = NULL;
	gsize size = 0UL;
	gsize _tmp6_;
	gchar** parts = NULL;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GError * _inner_error_ = NULL;
	_tmp0_ = g_strdup_printf ("/proc/%d/stat", pid);
	path = _tmp0_;
	contents = NULL;
	{
		const gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
		gsize _tmp3_ = 0UL;
		_tmp1_ = path;
		g_file_get_contents (_tmp1_, &_tmp2_, &_tmp3_, &_inner_error_);
		_g_free0 (contents);
		contents = _tmp2_;
		size = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp4_ = 0;
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch79_g_file_error;
			}
			_g_free0 (contents);
			_g_free0 (path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp4_;
		}
	}
	goto __finally79;
	__catch79_g_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = -1;
		_g_error_free0 (e);
		_g_free0 (contents);
		_g_free0 (path);
		return result;
	}
	__finally79:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp5_ = 0;
		_g_free0 (contents);
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp5_;
	}
	_tmp6_ = size;
	if (_tmp6_ <= ((gsize) 0)) {
		result = -2;
		_g_free0 (contents);
		_g_free0 (path);
		return result;
	}
	_tmp7_ = contents;
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 5);
	parts = _tmp9_;
	parts_length1 = _vala_array_length (_tmp8_);
	_parts_size_ = parts_length1;
	_tmp10_ = parts;
	_tmp10__length1 = parts_length1;
	if (_tmp10__length1 >= 3) {
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		_tmp11_ = parts;
		_tmp11__length1 = parts_length1;
		_tmp12_ = _tmp11_[3];
		result = atoi (_tmp12_);
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (contents);
		_g_free0 (path);
		return result;
	}
	result = -3;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (contents);
	_g_free0 (path);
	return result;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



