/* NetworkSettings.c generated by valac 0.40.6, the Vala compiler
 * generated from NetworkSettings.vala, do not modify */

/*
 * Copyright 2015-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define NUVOLA_TYPE_NETWORK_SETTINGS (nuvola_network_settings_get_type ())
#define NUVOLA_NETWORK_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettings))
#define NUVOLA_NETWORK_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettingsClass))
#define NUVOLA_IS_NETWORK_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_NETWORK_SETTINGS))
#define NUVOLA_IS_NETWORK_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_NETWORK_SETTINGS))
#define NUVOLA_NETWORK_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettingsClass))

typedef struct _NuvolaNetworkSettings NuvolaNetworkSettings;
typedef struct _NuvolaNetworkSettingsClass NuvolaNetworkSettingsClass;
typedef struct _NuvolaNetworkSettingsPrivate NuvolaNetworkSettingsPrivate;

#define NUVOLA_TYPE_CONNECTION (nuvola_connection_get_type ())
#define NUVOLA_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_CONNECTION, NuvolaConnection))
#define NUVOLA_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_CONNECTION, NuvolaConnectionClass))
#define NUVOLA_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_CONNECTION))
#define NUVOLA_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_CONNECTION))
#define NUVOLA_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_CONNECTION, NuvolaConnectionClass))

typedef struct _NuvolaConnection NuvolaConnection;
typedef struct _NuvolaConnectionClass NuvolaConnectionClass;

#define NUVOLA_TYPE_NETWORK_PROXY_TYPE (nuvola_network_proxy_type_get_type ())
enum  {
	NUVOLA_NETWORK_SETTINGS_0_PROPERTY,
	NUVOLA_NETWORK_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* nuvola_network_settings_properties[NUVOLA_NETWORK_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NuvolaNetworkSettings {
	GtkGrid parent_instance;
	NuvolaNetworkSettingsPrivate * priv;
};

struct _NuvolaNetworkSettingsClass {
	GtkGridClass parent_class;
};

typedef enum  {
	NUVOLA_NETWORK_PROXY_TYPE_SYSTEM,
	NUVOLA_NETWORK_PROXY_TYPE_DIRECT,
	NUVOLA_NETWORK_PROXY_TYPE_HTTP,
	NUVOLA_NETWORK_PROXY_TYPE_SOCKS
} NuvolaNetworkProxyType;

struct _NuvolaNetworkSettingsPrivate {
	NuvolaConnection* connection;
	GtkRadioButton** proxy_types;
	gint proxy_types_length1;
	gint _proxy_types_size_;
	GtkEntry* proxy_server;
	GtkSpinButton* proxy_port;
	NuvolaNetworkProxyType original_type;
	gchar* original_host;
	gint original_port;
};


static gpointer nuvola_network_settings_parent_class = NULL;

GType nuvola_network_settings_get_type (void) G_GNUC_CONST;
GType nuvola_connection_get_type (void) G_GNUC_CONST;
GType nuvola_network_proxy_type_get_type (void) G_GNUC_CONST;
#define NUVOLA_NETWORK_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettingsPrivate))
NuvolaNetworkSettings* nuvola_network_settings_new (NuvolaConnection* connection);
NuvolaNetworkSettings* nuvola_network_settings_construct (GType object_type,
                                                          NuvolaConnection* connection);
NuvolaNetworkProxyType nuvola_connection_get_network_proxy (NuvolaConnection* self,
                                                            gchar* * host,
                                                            gint* port);
static void nuvola_network_settings_on_proxy_type_toggled (NuvolaNetworkSettings* self,
                                                    GtkToggleButton* button);
static void _nuvola_network_settings_on_proxy_type_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                               gpointer self);
static void nuvola_network_settings_on_proxy_server_changed (NuvolaNetworkSettings* self);
static void _nuvola_network_settings_on_proxy_server_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                            gpointer self);
static void nuvola_network_settings_on_proxy_port_changed (NuvolaNetworkSettings* self);
static void _nuvola_network_settings_on_proxy_port_changed_gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                                   gpointer self);
static void nuvola_network_settings_on_change (NuvolaNetworkSettings* self);
static inline gboolean nuvola_network_settings_is_manual_settings (NuvolaNetworkSettings* self,
                                                     NuvolaNetworkProxyType type);
static NuvolaNetworkProxyType nuvola_network_settings_get_proxy_type (NuvolaNetworkSettings* self);
gboolean nuvola_network_settings_get_proxy_settings (NuvolaNetworkSettings* self,
                                                     NuvolaNetworkProxyType* type,
                                                     gchar* * host,
                                                     gint* port);
static void nuvola_network_settings_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_nuvola_network_settings_on_proxy_type_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                          gpointer self)
{
	nuvola_network_settings_on_proxy_type_toggled ((NuvolaNetworkSettings*) self, _sender);
}


static void
_nuvola_network_settings_on_proxy_server_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                       gpointer self)
{
	nuvola_network_settings_on_proxy_server_changed ((NuvolaNetworkSettings*) self);
}


static void
_nuvola_network_settings_on_proxy_port_changed_gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                              gpointer self)
{
	nuvola_network_settings_on_proxy_port_changed ((NuvolaNetworkSettings*) self);
}


NuvolaNetworkSettings*
nuvola_network_settings_construct (GType object_type,
                                   NuvolaConnection* connection)
{
	NuvolaNetworkSettings * self = NULL;
	NuvolaConnection* _tmp0_;
	gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	NuvolaNetworkProxyType _tmp3_;
	gint row = 0;
	GtkRadioButton** _tmp4_;
	GtkRadioButton** _tmp5_;
	gint _tmp5__length1;
	GtkRadioButton* _tmp6_;
	GtkRadioButton* _tmp7_;
	GtkRadioButton** _tmp8_;
	gint _tmp8__length1;
	GtkRadioButton* _tmp9_;
	NuvolaNetworkProxyType _tmp10_;
	GtkRadioButton** _tmp13_;
	gint _tmp13__length1;
	GtkRadioButton* _tmp14_;
	gint _tmp15_;
	GtkRadioButton** _tmp16_;
	gint _tmp16__length1;
	GtkRadioButton** _tmp17_;
	gint _tmp17__length1;
	GtkRadioButton* _tmp18_;
	GSList* _tmp19_;
	GtkRadioButton* _tmp20_;
	GtkRadioButton* _tmp21_;
	GtkRadioButton** _tmp22_;
	gint _tmp22__length1;
	GtkRadioButton* _tmp23_;
	NuvolaNetworkProxyType _tmp24_;
	GtkRadioButton** _tmp27_;
	gint _tmp27__length1;
	GtkRadioButton* _tmp28_;
	gint _tmp29_;
	GtkRadioButton** _tmp30_;
	gint _tmp30__length1;
	GtkRadioButton** _tmp31_;
	gint _tmp31__length1;
	GtkRadioButton* _tmp32_;
	GSList* _tmp33_;
	GtkRadioButton* _tmp34_;
	GtkRadioButton* _tmp35_;
	GtkRadioButton** _tmp36_;
	gint _tmp36__length1;
	GtkRadioButton* _tmp37_;
	NuvolaNetworkProxyType _tmp38_;
	GtkRadioButton** _tmp41_;
	gint _tmp41__length1;
	GtkRadioButton* _tmp42_;
	gint _tmp43_;
	GtkRadioButton** _tmp44_;
	gint _tmp44__length1;
	GtkRadioButton** _tmp45_;
	gint _tmp45__length1;
	GtkRadioButton* _tmp46_;
	GSList* _tmp47_;
	GtkRadioButton* _tmp48_;
	GtkRadioButton* _tmp49_;
	GtkRadioButton** _tmp50_;
	gint _tmp50__length1;
	GtkRadioButton* _tmp51_;
	NuvolaNetworkProxyType _tmp52_;
	GtkRadioButton** _tmp55_;
	gint _tmp55__length1;
	GtkRadioButton* _tmp56_;
	gint _tmp57_;
	gboolean _tmp58_ = FALSE;
	NuvolaNetworkProxyType _tmp59_;
	gboolean manual_settings = FALSE;
	GtkLabel* label = NULL;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	gint _tmp63_;
	GtkEntry* _tmp64_;
	const gchar* _tmp65_ = NULL;
	const gchar* _tmp66_;
	GtkEntry* _tmp67_;
	GtkEntry* _tmp68_;
	gboolean _tmp69_;
	GtkEntry* _tmp70_;
	GtkEntry* _tmp71_;
	gint _tmp72_;
	GtkLabel* _tmp73_;
	GtkLabel* _tmp74_;
	gint _tmp75_;
	GtkSpinButton* _tmp76_;
	GtkSpinButton* _tmp77_;
	GtkSpinButton* _tmp78_;
	GtkSpinButton* _tmp79_;
	gint _tmp80_;
	GtkSpinButton* _tmp81_;
	gboolean _tmp82_;
	GtkSpinButton* _tmp83_;
	GtkSpinButton* _tmp84_;
	gint _tmp85_;
	GtkRadioButton** _tmp86_;
	gint _tmp86__length1;
	GtkEntry* _tmp89_;
	GtkSpinButton* _tmp90_;
	g_return_val_if_fail (connection != NULL, NULL);
	self = (NuvolaNetworkSettings*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp0_;
	_tmp3_ = nuvola_connection_get_network_proxy (connection, &_tmp1_, &_tmp2_);
	_g_free0 (self->priv->original_host);
	self->priv->original_host = _tmp1_;
	self->priv->original_port = _tmp2_;
	self->priv->original_type = _tmp3_;
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	g_object_set ((GtkWidget*) self, "margin", 18, NULL);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 8);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 18);
	row = 0;
	_tmp4_ = g_new0 (GtkRadioButton*, 4 + 1);
	self->priv->proxy_types = (_vala_array_free (self->priv->proxy_types, self->priv->proxy_types_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->proxy_types = _tmp4_;
	self->priv->proxy_types_length1 = 4;
	self->priv->_proxy_types_size_ = self->priv->proxy_types_length1;
	_tmp5_ = self->priv->proxy_types;
	_tmp5__length1 = self->priv->proxy_types_length1;
	_tmp6_ = (GtkRadioButton*) gtk_radio_button_new_with_label (NULL, _ ("Use system network proxy settings"));
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (_tmp5_[0]);
	_tmp5_[0] = _tmp6_;
	_tmp7_ = _tmp5_[0];
	_tmp8_ = self->priv->proxy_types;
	_tmp8__length1 = self->priv->proxy_types_length1;
	_tmp9_ = _tmp8_[0];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
	_tmp10_ = self->priv->original_type;
	if (_tmp10_ == NUVOLA_NETWORK_PROXY_TYPE_SYSTEM) {
		GtkRadioButton** _tmp11_;
		gint _tmp11__length1;
		GtkRadioButton* _tmp12_;
		_tmp11_ = self->priv->proxy_types;
		_tmp11__length1 = self->priv->proxy_types_length1;
		_tmp12_ = _tmp11_[0];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp12_, TRUE);
	}
	_tmp13_ = self->priv->proxy_types;
	_tmp13__length1 = self->priv->proxy_types_length1;
	_tmp14_ = _tmp13_[0];
	_tmp15_ = row;
	row = _tmp15_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp14_, 0, _tmp15_, 3, 1);
	_tmp16_ = self->priv->proxy_types;
	_tmp16__length1 = self->priv->proxy_types_length1;
	_tmp17_ = self->priv->proxy_types;
	_tmp17__length1 = self->priv->proxy_types_length1;
	_tmp18_ = _tmp17_[0];
	_tmp19_ = gtk_radio_button_get_group (_tmp18_);
	_tmp20_ = (GtkRadioButton*) gtk_radio_button_new_with_label (_tmp19_, _ ("Use direct connection without a proxy server"));
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (_tmp16_[1]);
	_tmp16_[1] = _tmp20_;
	_tmp21_ = _tmp16_[1];
	_tmp22_ = self->priv->proxy_types;
	_tmp22__length1 = self->priv->proxy_types_length1;
	_tmp23_ = _tmp22_[1];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp23_, TRUE);
	_tmp24_ = self->priv->original_type;
	if (_tmp24_ == NUVOLA_NETWORK_PROXY_TYPE_DIRECT) {
		GtkRadioButton** _tmp25_;
		gint _tmp25__length1;
		GtkRadioButton* _tmp26_;
		_tmp25_ = self->priv->proxy_types;
		_tmp25__length1 = self->priv->proxy_types_length1;
		_tmp26_ = _tmp25_[1];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp26_, TRUE);
	}
	_tmp27_ = self->priv->proxy_types;
	_tmp27__length1 = self->priv->proxy_types_length1;
	_tmp28_ = _tmp27_[1];
	_tmp29_ = row;
	row = _tmp29_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp28_, 0, _tmp29_, 3, 1);
	_tmp30_ = self->priv->proxy_types;
	_tmp30__length1 = self->priv->proxy_types_length1;
	_tmp31_ = self->priv->proxy_types;
	_tmp31__length1 = self->priv->proxy_types_length1;
	_tmp32_ = _tmp31_[0];
	_tmp33_ = gtk_radio_button_get_group (_tmp32_);
	_tmp34_ = (GtkRadioButton*) gtk_radio_button_new_with_label (_tmp33_, _ ("Use manual HTTP proxy settings"));
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (_tmp30_[2]);
	_tmp30_[2] = _tmp34_;
	_tmp35_ = _tmp30_[2];
	_tmp36_ = self->priv->proxy_types;
	_tmp36__length1 = self->priv->proxy_types_length1;
	_tmp37_ = _tmp36_[2];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp37_, TRUE);
	_tmp38_ = self->priv->original_type;
	if (_tmp38_ == NUVOLA_NETWORK_PROXY_TYPE_HTTP) {
		GtkRadioButton** _tmp39_;
		gint _tmp39__length1;
		GtkRadioButton* _tmp40_;
		_tmp39_ = self->priv->proxy_types;
		_tmp39__length1 = self->priv->proxy_types_length1;
		_tmp40_ = _tmp39_[2];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp40_, TRUE);
	}
	_tmp41_ = self->priv->proxy_types;
	_tmp41__length1 = self->priv->proxy_types_length1;
	_tmp42_ = _tmp41_[2];
	_tmp43_ = row;
	row = _tmp43_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp42_, 0, _tmp43_, 3, 1);
	_tmp44_ = self->priv->proxy_types;
	_tmp44__length1 = self->priv->proxy_types_length1;
	_tmp45_ = self->priv->proxy_types;
	_tmp45__length1 = self->priv->proxy_types_length1;
	_tmp46_ = _tmp45_[0];
	_tmp47_ = gtk_radio_button_get_group (_tmp46_);
	_tmp48_ = (GtkRadioButton*) gtk_radio_button_new_with_label (_tmp47_, _ ("Use manual SOCKS proxy settings"));
	g_object_ref_sink (_tmp48_);
	_g_object_unref0 (_tmp44_[3]);
	_tmp44_[3] = _tmp48_;
	_tmp49_ = _tmp44_[3];
	_tmp50_ = self->priv->proxy_types;
	_tmp50__length1 = self->priv->proxy_types_length1;
	_tmp51_ = _tmp50_[3];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp51_, TRUE);
	_tmp52_ = self->priv->original_type;
	if (_tmp52_ == NUVOLA_NETWORK_PROXY_TYPE_SOCKS) {
		GtkRadioButton** _tmp53_;
		gint _tmp53__length1;
		GtkRadioButton* _tmp54_;
		_tmp53_ = self->priv->proxy_types;
		_tmp53__length1 = self->priv->proxy_types_length1;
		_tmp54_ = _tmp53_[3];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp54_, TRUE);
	}
	_tmp55_ = self->priv->proxy_types;
	_tmp55__length1 = self->priv->proxy_types_length1;
	_tmp56_ = _tmp55_[3];
	_tmp57_ = row;
	row = _tmp57_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp56_, 0, _tmp57_, 3, 1);
	_tmp59_ = self->priv->original_type;
	if (_tmp59_ == NUVOLA_NETWORK_PROXY_TYPE_HTTP) {
		_tmp58_ = TRUE;
	} else {
		NuvolaNetworkProxyType _tmp60_;
		_tmp60_ = self->priv->original_type;
		_tmp58_ = _tmp60_ == NUVOLA_NETWORK_PROXY_TYPE_SOCKS;
	}
	manual_settings = _tmp58_;
	_tmp61_ = (GtkLabel*) gtk_label_new (_ ("Proxy Server"));
	g_object_ref_sink (_tmp61_);
	label = _tmp61_;
	_tmp62_ = label;
	_tmp63_ = row;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp62_, 0, _tmp63_, 1, 1);
	_tmp64_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp64_);
	_g_object_unref0 (self->priv->proxy_server);
	self->priv->proxy_server = _tmp64_;
	_tmp66_ = self->priv->original_host;
	_tmp65_ = _tmp66_;
	if (_tmp65_ == NULL) {
		_tmp65_ = "";
	}
	_tmp67_ = self->priv->proxy_server;
	gtk_entry_set_text (_tmp67_, _tmp65_);
	_tmp68_ = self->priv->proxy_server;
	_tmp69_ = manual_settings;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp68_, _tmp69_);
	_tmp70_ = self->priv->proxy_server;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp70_, TRUE);
	_tmp71_ = self->priv->proxy_server;
	_tmp72_ = row;
	row = _tmp72_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp71_, 1, _tmp72_, 2, 1);
	_tmp73_ = (GtkLabel*) gtk_label_new (_ ("Proxy Server Port"));
	g_object_ref_sink (_tmp73_);
	_g_object_unref0 (label);
	label = _tmp73_;
	_tmp74_ = label;
	_tmp75_ = row;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp74_, 0, _tmp75_, 1, 1);
	_tmp76_ = (GtkSpinButton*) gtk_spin_button_new_with_range (0.0, (gdouble) G_MAXINT32, 1.0);
	g_object_ref_sink (_tmp76_);
	_g_object_unref0 (self->priv->proxy_port);
	self->priv->proxy_port = _tmp76_;
	_tmp77_ = self->priv->proxy_port;
	gtk_spin_button_set_digits (_tmp77_, (guint) 0);
	_tmp78_ = self->priv->proxy_port;
	gtk_spin_button_set_snap_to_ticks (_tmp78_, TRUE);
	_tmp79_ = self->priv->proxy_port;
	_tmp80_ = self->priv->original_port;
	gtk_spin_button_set_value (_tmp79_, (gdouble) _tmp80_);
	_tmp81_ = self->priv->proxy_port;
	_tmp82_ = manual_settings;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp81_, _tmp82_);
	_tmp83_ = self->priv->proxy_port;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp83_, TRUE);
	_tmp84_ = self->priv->proxy_port;
	_tmp85_ = row;
	row = _tmp85_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp84_, 1, _tmp85_, 2, 1);
	_tmp86_ = self->priv->proxy_types;
	_tmp86__length1 = self->priv->proxy_types_length1;
	{
		GtkRadioButton** t_collection = NULL;
		gint t_collection_length1 = 0;
		gint _t_collection_size_ = 0;
		gint t_it = 0;
		t_collection = _tmp86_;
		t_collection_length1 = _tmp86__length1;
		for (t_it = 0; t_it < _tmp86__length1; t_it = t_it + 1) {
			GtkRadioButton* _tmp87_;
			GtkRadioButton* t = NULL;
			_tmp87_ = _g_object_ref0 (t_collection[t_it]);
			t = _tmp87_;
			{
				GtkRadioButton* _tmp88_;
				_tmp88_ = t;
				g_signal_connect_object ((GtkToggleButton*) _tmp88_, "toggled", (GCallback) _nuvola_network_settings_on_proxy_type_toggled_gtk_toggle_button_toggled, self, 0);
				_g_object_unref0 (t);
			}
		}
	}
	_tmp89_ = self->priv->proxy_server;
	g_signal_connect_object ((GtkEditable*) _tmp89_, "changed", (GCallback) _nuvola_network_settings_on_proxy_server_changed_gtk_editable_changed, self, 0);
	_tmp90_ = self->priv->proxy_port;
	g_signal_connect_object (_tmp90_, "value-changed", (GCallback) _nuvola_network_settings_on_proxy_port_changed_gtk_spin_button_value_changed, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (label);
	return self;
}


NuvolaNetworkSettings*
nuvola_network_settings_new (NuvolaConnection* connection)
{
	return nuvola_network_settings_construct (NUVOLA_TYPE_NETWORK_SETTINGS, connection);
}


static void
nuvola_network_settings_on_change (NuvolaNetworkSettings* self)
{
	GtkEntry* _tmp0_;
	GtkSpinButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->proxy_server;
	_tmp1_ = self->priv->proxy_port;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, nuvola_network_settings_is_manual_settings (self, nuvola_network_settings_get_proxy_type (self)));
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, nuvola_network_settings_is_manual_settings (self, nuvola_network_settings_get_proxy_type (self)));
}


static inline gboolean
nuvola_network_settings_is_manual_settings (NuvolaNetworkSettings* self,
                                            NuvolaNetworkProxyType type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (type == NUVOLA_NETWORK_PROXY_TYPE_HTTP) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = type == NUVOLA_NETWORK_PROXY_TYPE_SOCKS;
	}
	result = _tmp0_;
	return result;
}


static NuvolaNetworkProxyType
nuvola_network_settings_get_proxy_type (NuvolaNetworkSettings* self)
{
	NuvolaNetworkProxyType result = 0;
	NuvolaNetworkProxyType type = 0;
	GtkRadioButton** _tmp0_;
	gint _tmp0__length1;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	type = NUVOLA_NETWORK_PROXY_TYPE_SYSTEM;
	_tmp0_ = self->priv->proxy_types;
	_tmp0__length1 = self->priv->proxy_types_length1;
	_tmp1_ = _tmp0_[0];
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		type = NUVOLA_NETWORK_PROXY_TYPE_SYSTEM;
	} else {
		GtkRadioButton** _tmp4_;
		gint _tmp4__length1;
		GtkRadioButton* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp4_ = self->priv->proxy_types;
		_tmp4__length1 = self->priv->proxy_types_length1;
		_tmp5_ = _tmp4_[1];
		_tmp6_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_) {
			type = NUVOLA_NETWORK_PROXY_TYPE_DIRECT;
		} else {
			GtkRadioButton** _tmp8_;
			gint _tmp8__length1;
			GtkRadioButton* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			_tmp8_ = self->priv->proxy_types;
			_tmp8__length1 = self->priv->proxy_types_length1;
			_tmp9_ = _tmp8_[2];
			_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
			_tmp11_ = _tmp10_;
			if (_tmp11_) {
				type = NUVOLA_NETWORK_PROXY_TYPE_HTTP;
			} else {
				GtkRadioButton** _tmp12_;
				gint _tmp12__length1;
				GtkRadioButton* _tmp13_;
				gboolean _tmp14_;
				gboolean _tmp15_;
				_tmp12_ = self->priv->proxy_types;
				_tmp12__length1 = self->priv->proxy_types_length1;
				_tmp13_ = _tmp12_[3];
				_tmp14_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp13_);
				_tmp15_ = _tmp14_;
				if (_tmp15_) {
					type = NUVOLA_NETWORK_PROXY_TYPE_SOCKS;
				}
			}
		}
	}
	result = type;
	return result;
}


gboolean
nuvola_network_settings_get_proxy_settings (NuvolaNetworkSettings* self,
                                            NuvolaNetworkProxyType* type,
                                            gchar* * host,
                                            gint* port)
{
	NuvolaNetworkProxyType _vala_type = 0;
	gchar* _vala_host = NULL;
	gint _vala_port = 0;
	gboolean result = FALSE;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkSpinButton* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gboolean changed = FALSE;
	NuvolaNetworkProxyType _tmp8_;
	NuvolaNetworkProxyType _tmp9_;
	gboolean _tmp10_ = FALSE;
	NuvolaNetworkProxyType _tmp11_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->proxy_server;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (_vala_host);
	_vala_host = _tmp3_;
	_tmp4_ = _vala_host;
	if (g_strcmp0 (_tmp4_, "") == 0) {
		_g_free0 (_vala_host);
		_vala_host = NULL;
	}
	_tmp5_ = self->priv->proxy_port;
	_tmp6_ = gtk_spin_button_get_value (_tmp5_);
	_tmp7_ = _tmp6_;
	_vala_port = (gint) _tmp7_;
	_vala_type = nuvola_network_settings_get_proxy_type (self);
	_tmp8_ = _vala_type;
	_tmp9_ = self->priv->original_type;
	changed = _tmp8_ != _tmp9_;
	_tmp11_ = _vala_type;
	if (nuvola_network_settings_is_manual_settings (self, _tmp11_)) {
		gboolean _tmp12_;
		_tmp12_ = changed;
		_tmp10_ = !_tmp12_;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		_tmp14_ = _vala_host;
		_tmp15_ = self->priv->original_host;
		if (g_strcmp0 (_tmp14_, _tmp15_) != 0) {
			_tmp13_ = TRUE;
		} else {
			gint _tmp16_;
			gint _tmp17_;
			_tmp16_ = _vala_port;
			_tmp17_ = self->priv->original_port;
			_tmp13_ = _tmp16_ != _tmp17_;
		}
		changed = _tmp13_;
	}
	result = changed;
	if (type) {
		*type = _vala_type;
	}
	if (host) {
		*host = _vala_host;
	} else {
		_g_free0 (_vala_host);
	}
	if (port) {
		*port = _vala_port;
	}
	return result;
}


static void
nuvola_network_settings_on_proxy_type_toggled (NuvolaNetworkSettings* self,
                                               GtkToggleButton* button)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		nuvola_network_settings_on_change (self);
	}
}


static void
nuvola_network_settings_on_proxy_server_changed (NuvolaNetworkSettings* self)
{
	g_return_if_fail (self != NULL);
	nuvola_network_settings_on_change (self);
}


static void
nuvola_network_settings_on_proxy_port_changed (NuvolaNetworkSettings* self)
{
	g_return_if_fail (self != NULL);
	nuvola_network_settings_on_change (self);
}


static void
nuvola_network_settings_class_init (NuvolaNetworkSettingsClass * klass)
{
	nuvola_network_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaNetworkSettingsPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_network_settings_finalize;
}


static void
nuvola_network_settings_instance_init (NuvolaNetworkSettings * self)
{
	self->priv = NUVOLA_NETWORK_SETTINGS_GET_PRIVATE (self);
}


static void
nuvola_network_settings_finalize (GObject * obj)
{
	NuvolaNetworkSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettings);
	_g_object_unref0 (self->priv->connection);
	self->priv->proxy_types = (_vala_array_free (self->priv->proxy_types, self->priv->proxy_types_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->proxy_server);
	_g_object_unref0 (self->priv->proxy_port);
	_g_free0 (self->priv->original_host);
	G_OBJECT_CLASS (nuvola_network_settings_parent_class)->finalize (obj);
}


GType
nuvola_network_settings_get_type (void)
{
	static volatile gsize nuvola_network_settings_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_network_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaNetworkSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_network_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaNetworkSettings), 0, (GInstanceInitFunc) nuvola_network_settings_instance_init, NULL };
		GType nuvola_network_settings_type_id;
		nuvola_network_settings_type_id = g_type_register_static (gtk_grid_get_type (), "NuvolaNetworkSettings", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_network_settings_type_id__volatile, nuvola_network_settings_type_id);
	}
	return nuvola_network_settings_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



