/* Notifications.c generated by valac 0.40.6, the Vala compiler
 * generated from Notifications.vala, do not modify */

/*
 * Copyright 2011-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* https://people.gnome.org/~mccann/docs/notification-spec/notification-spec-latest.html*/


#include <glib.h>
#include <glib-object.h>
#include <libnotify/notify.h>
#include <stdlib.h>
#include <string.h>
#include <dioritegtk4.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>


#define NUVOLA_TYPE_NOTIFICATION (nuvola_notification_get_type ())
#define NUVOLA_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_NOTIFICATION, NuvolaNotification))
#define NUVOLA_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_NOTIFICATION, NuvolaNotificationClass))
#define NUVOLA_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_NOTIFICATION))
#define NUVOLA_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_NOTIFICATION))
#define NUVOLA_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_NOTIFICATION, NuvolaNotificationClass))

typedef struct _NuvolaNotification NuvolaNotification;
typedef struct _NuvolaNotificationClass NuvolaNotificationClass;
typedef struct _NuvolaNotificationPrivate NuvolaNotificationPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _nuvola_notification_unref0(var) ((var == NULL) ? NULL : (var = (nuvola_notification_unref (var), NULL)))
typedef struct _NuvolaParamSpecNotification NuvolaParamSpecNotification;

#define NUVOLA_TYPE_NOTIFICATIONS_INTERFACE (nuvola_notifications_interface_get_type ())
#define NUVOLA_NOTIFICATIONS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_NOTIFICATIONS_INTERFACE, NuvolaNotificationsInterface))
#define NUVOLA_IS_NOTIFICATIONS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_NOTIFICATIONS_INTERFACE))
#define NUVOLA_NOTIFICATIONS_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_NOTIFICATIONS_INTERFACE, NuvolaNotificationsInterfaceIface))

typedef struct _NuvolaNotificationsInterface NuvolaNotificationsInterface;
typedef struct _NuvolaNotificationsInterfaceIface NuvolaNotificationsInterfaceIface;

#define NUVOLA_TYPE_NOTIFICATION_INTERFACE (nuvola_notification_interface_get_type ())
#define NUVOLA_NOTIFICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_NOTIFICATION_INTERFACE, NuvolaNotificationInterface))
#define NUVOLA_IS_NOTIFICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_NOTIFICATION_INTERFACE))
#define NUVOLA_NOTIFICATION_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_NOTIFICATION_INTERFACE, NuvolaNotificationInterfaceIface))

typedef struct _NuvolaNotificationInterface NuvolaNotificationInterface;
typedef struct _NuvolaNotificationInterfaceIface NuvolaNotificationInterfaceIface;

#define NUVOLA_TYPE_NOTIFICATIONS (nuvola_notifications_get_type ())
#define NUVOLA_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_NOTIFICATIONS, NuvolaNotifications))
#define NUVOLA_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_NOTIFICATIONS, NuvolaNotificationsClass))
#define NUVOLA_IS_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_NOTIFICATIONS))
#define NUVOLA_IS_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_NOTIFICATIONS))
#define NUVOLA_NOTIFICATIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_NOTIFICATIONS, NuvolaNotificationsClass))

typedef struct _NuvolaNotifications NuvolaNotifications;
typedef struct _NuvolaNotificationsClass NuvolaNotificationsClass;
typedef struct _NuvolaNotificationsPrivate NuvolaNotificationsPrivate;

#define NUVOLA_TYPE_APP_RUNNER_CONTROLLER (nuvola_app_runner_controller_get_type ())
#define NUVOLA_APP_RUNNER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_APP_RUNNER_CONTROLLER, NuvolaAppRunnerController))
#define NUVOLA_APP_RUNNER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_APP_RUNNER_CONTROLLER, NuvolaAppRunnerControllerClass))
#define NUVOLA_IS_APP_RUNNER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_APP_RUNNER_CONTROLLER))
#define NUVOLA_IS_APP_RUNNER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_APP_RUNNER_CONTROLLER))
#define NUVOLA_APP_RUNNER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_APP_RUNNER_CONTROLLER, NuvolaAppRunnerControllerClass))

typedef struct _NuvolaAppRunnerController NuvolaAppRunnerController;
typedef struct _NuvolaAppRunnerControllerClass NuvolaAppRunnerControllerClass;

#define NUVOLA_TYPE_ACTIONS_HELPER (nuvola_actions_helper_get_type ())
#define NUVOLA_ACTIONS_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_ACTIONS_HELPER, NuvolaActionsHelper))
#define NUVOLA_ACTIONS_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_ACTIONS_HELPER, NuvolaActionsHelperClass))
#define NUVOLA_IS_ACTIONS_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_ACTIONS_HELPER))
#define NUVOLA_IS_ACTIONS_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_ACTIONS_HELPER))
#define NUVOLA_ACTIONS_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_ACTIONS_HELPER, NuvolaActionsHelperClass))

typedef struct _NuvolaActionsHelper NuvolaActionsHelper;
typedef struct _NuvolaActionsHelperClass NuvolaActionsHelperClass;
enum  {
	NUVOLA_NOTIFICATIONS_0_PROPERTY,
	NUVOLA_NOTIFICATIONS_RUNNING_PROPERTY,
	NUVOLA_NOTIFICATIONS_NUM_PROPERTIES
};
static GParamSpec* nuvola_notifications_properties[NUVOLA_NOTIFICATIONS_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))

#define NUVOLA_TYPE_WEB_APP_WINDOW (nuvola_web_app_window_get_type ())
#define NUVOLA_WEB_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_APP_WINDOW, NuvolaWebAppWindow))
#define NUVOLA_WEB_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_APP_WINDOW, NuvolaWebAppWindowClass))
#define NUVOLA_IS_WEB_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_APP_WINDOW))
#define NUVOLA_IS_WEB_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_APP_WINDOW))
#define NUVOLA_WEB_APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_APP_WINDOW, NuvolaWebAppWindowClass))

typedef struct _NuvolaWebAppWindow NuvolaWebAppWindow;
typedef struct _NuvolaWebAppWindowClass NuvolaWebAppWindowClass;

struct _NuvolaNotification {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NuvolaNotificationPrivate * priv;
};

struct _NuvolaNotificationClass {
	GTypeClass parent_class;
	void (*finalize) (NuvolaNotification *self);
};

struct _NuvolaNotificationPrivate {
	gboolean _resident;
	NotifyNotification* notification;
	gchar* icon_path;
	DrtgtkAction** actions;
	gint actions_length1;
	gint _actions_size_;
	gchar* desktop_entry;
	gchar* category;
	guint timeout_id;
};

struct _Block5Data {
	int _ref_count_;
	NuvolaNotification* self;
	DrtgtkAction* action;
};

struct _NuvolaParamSpecNotification {
	GParamSpec parent_instance;
};

struct _NuvolaNotificationsInterfaceIface {
	GTypeInterface parent_iface;
	gboolean (*show_anonymous) (NuvolaNotificationsInterface* self, const gchar* summary, const gchar* body, const gchar* icon_name, const gchar* icon_path, gboolean force, const gchar* category);
	gboolean (*is_persistence_supported) (NuvolaNotificationsInterface* self, gboolean* supported);
};

struct _NuvolaNotificationInterfaceIface {
	GTypeInterface parent_iface;
	gboolean (*update) (NuvolaNotificationInterface* self, const gchar* name, const gchar* summary, const gchar* body, const gchar* icon_name, const gchar* icon_path, gboolean resident, const gchar* category);
	gboolean (*set_actions) (NuvolaNotificationInterface* self, const gchar* name, gchar** actions, int actions_length1);
	gboolean (*remove_actions) (NuvolaNotificationInterface* self, const gchar* name);
	gboolean (*show) (NuvolaNotificationInterface* self, const gchar* name, gboolean force);
};

struct _NuvolaNotifications {
	GObject parent_instance;
	NuvolaNotificationsPrivate * priv;
};

struct _NuvolaNotificationsClass {
	GObjectClass parent_class;
};

struct _NuvolaNotificationsPrivate {
	gboolean _running;
	NuvolaAppRunnerController* app;
	NuvolaActionsHelper* actions_helper;
	GHashTable* notifications;
	gboolean actions_supported;
	gboolean persistence_supported;
	gboolean icons_supported;
};


static gpointer nuvola_notification_parent_class = NULL;
static gpointer nuvola_notifications_parent_class = NULL;
static NuvolaNotificationsInterfaceIface * nuvola_notifications_nuvola_notifications_interface_parent_iface = NULL;
static NuvolaNotificationInterfaceIface * nuvola_notifications_nuvola_notification_interface_parent_iface = NULL;

gpointer nuvola_notification_ref (gpointer instance);
void nuvola_notification_unref (gpointer instance);
GParamSpec* nuvola_param_spec_notification (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void nuvola_value_set_notification (GValue* value,
                                    gpointer v_object);
void nuvola_value_take_notification (GValue* value,
                                     gpointer v_object);
gpointer nuvola_value_get_notification (const GValue* value);
GType nuvola_notification_get_type (void) G_GNUC_CONST;
#define NUVOLA_NOTIFICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_NOTIFICATION, NuvolaNotificationPrivate))
NuvolaNotification* nuvola_notification_new (const gchar* desktop_entry);
NuvolaNotification* nuvola_notification_construct (GType object_type,
                                                   const gchar* desktop_entry);
void nuvola_notification_update (NuvolaNotification* self,
                                 const gchar* summary,
                                 const gchar* body,
                                 const gchar* icon_name,
                                 const gchar* icon_path,
                                 gboolean resident,
                                 const gchar* category);
static void nuvola_notification_set_resident (NuvolaNotification* self,
                                       gboolean value);
void nuvola_notification_set_actions (NuvolaNotification* self,
                                      DrtgtkAction** actions,
                                      int actions_length1);
static DrtgtkAction** _vala_array_dup3 (DrtgtkAction** self,
                                 int length);
void nuvola_notification_remove_actions (NuvolaNotification* self);
void nuvola_notification_show (NuvolaNotification* self,
                               gboolean add_actions);
gboolean nuvola_notification_get_resident (NuvolaNotification* self);
static GVariant* _variant_new44 (gboolean value);
static GVariant* _variant_new45 (gboolean value);
static GVariant* _variant_new46 (const gchar* value);
static GVariant* _variant_new47 (gboolean value);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ______lambda33_ (Block5Data* _data5_);
static void _______lambda33__notify_action_callback (NotifyNotification* notification,
                                              const gchar* action,
                                              gpointer self);
static gboolean nuvola_notification_show_cb (NuvolaNotification* self);
static gboolean _nuvola_notification_show_cb_gsource_func (gpointer self);
gboolean nuvola_notification_close (NuvolaNotification* self);
static void nuvola_notification_finalize (NuvolaNotification * obj);
GType nuvola_notifications_interface_get_type (void) G_GNUC_CONST;
GType nuvola_notification_interface_get_type (void) G_GNUC_CONST;
GType nuvola_notifications_get_type (void) G_GNUC_CONST;
GType nuvola_app_runner_controller_get_type (void) G_GNUC_CONST;
GType nuvola_actions_helper_get_type (void) G_GNUC_CONST;
#define NUVOLA_NOTIFICATIONS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_NOTIFICATIONS, NuvolaNotificationsPrivate))
NuvolaNotifications* nuvola_notifications_new (NuvolaAppRunnerController* app,
                                               NuvolaActionsHelper* actions_helper);
NuvolaNotifications* nuvola_notifications_construct (GType object_type,
                                                     NuvolaAppRunnerController* app,
                                                     NuvolaActionsHelper* actions_helper);
static void _g_free0_ (gpointer var);
static void _nuvola_notification_unref0_ (gpointer var);
void nuvola_notifications_start (NuvolaNotifications* self);
gboolean nuvola_notifications_get_running (NuvolaNotifications* self);
static void nuvola_notifications_set_running (NuvolaNotifications* self,
                                       gboolean value);
static inline void _g_list_free__g_free0_ (GList* self);
void nuvola_notifications_stop (NuvolaNotifications* self);
static gboolean __lambda34_ (NuvolaNotifications* self,
                      const gchar* key,
                      NuvolaNotification* notification);
static gboolean ___lambda34__ghr_func (gconstpointer key,
                                gconstpointer value,
                                gpointer self);
NuvolaNotification* nuvola_notifications_get_or_create (NuvolaNotifications* self,
                                                        const gchar* name);
static gboolean nuvola_notifications_real_update (NuvolaNotificationInterface* base,
                                           const gchar* name,
                                           const gchar* summary,
                                           const gchar* body,
                                           const gchar* icon_name,
                                           const gchar* icon_path,
                                           gboolean resident,
                                           const gchar* category);
#define NUVOLA_BINDING_CONTINUE FALSE
static gboolean nuvola_notifications_real_set_actions (NuvolaNotificationInterface* base,
                                                const gchar* name,
                                                gchar** actions,
                                                int actions_length1);
static void _vala_array_add1 (DrtgtkAction** * array,
                       int* length,
                       int* size,
                       DrtgtkAction* value);
static gboolean nuvola_notifications_real_remove_actions (NuvolaNotificationInterface* base,
                                                   const gchar* name);
static gboolean nuvola_notifications_real_show (NuvolaNotificationInterface* base,
                                         const gchar* name,
                                         gboolean force);
GType nuvola_web_app_window_get_type (void) G_GNUC_CONST;
NuvolaWebAppWindow* nuvola_app_runner_controller_get_main_window (NuvolaAppRunnerController* self);
static gboolean nuvola_notifications_real_show_anonymous (NuvolaNotificationsInterface* base,
                                                   const gchar* summary,
                                                   const gchar* body,
                                                   const gchar* icon_name,
                                                   const gchar* icon_path,
                                                   gboolean force,
                                                   const gchar* category);
static gboolean nuvola_notifications_real_is_persistence_supported (NuvolaNotificationsInterface* base,
                                                             gboolean* supported);
static void nuvola_notifications_finalize (GObject * obj);
static void _vala_nuvola_notifications_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_nuvola_notifications_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


NuvolaNotification*
nuvola_notification_construct (GType object_type,
                               const gchar* desktop_entry)
{
	NuvolaNotification* self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (desktop_entry != NULL, NULL);
	self = (NuvolaNotification*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (desktop_entry);
	_g_free0 (self->priv->desktop_entry);
	self->priv->desktop_entry = _tmp0_;
	return self;
}


NuvolaNotification*
nuvola_notification_new (const gchar* desktop_entry)
{
	return nuvola_notification_construct (NUVOLA_TYPE_NOTIFICATION, desktop_entry);
}


void
nuvola_notification_update (NuvolaNotification* self,
                            const gchar* summary,
                            const gchar* body,
                            const gchar* icon_name,
                            const gchar* icon_path,
                            gboolean resident,
                            const gchar* category)
{
	NotifyNotification* _tmp0_;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (category != NULL);
	_tmp0_ = self->priv->notification;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		NotifyNotification* _tmp4_;
		_tmp1_ = summary;
		if (_tmp1_ == NULL) {
			_tmp1_ = "";
		}
		_tmp2_ = body;
		if (_tmp2_ == NULL) {
			_tmp2_ = "";
		}
		_tmp3_ = icon_name;
		if (_tmp3_ == NULL) {
			_tmp3_ = "";
		}
		_tmp4_ = notify_notification_new (_tmp1_, _tmp2_, _tmp3_);
		_g_object_unref0 (self->priv->notification);
		self->priv->notification = _tmp4_;
	} else {
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		NotifyNotification* _tmp8_;
		_tmp5_ = summary;
		if (_tmp5_ == NULL) {
			_tmp5_ = "";
		}
		_tmp6_ = body;
		if (_tmp6_ == NULL) {
			_tmp6_ = "";
		}
		_tmp7_ = icon_name;
		if (_tmp7_ == NULL) {
			_tmp7_ = "";
		}
		_tmp8_ = self->priv->notification;
		notify_notification_update (_tmp8_, _tmp5_, _tmp6_, _tmp7_);
	}
	_tmp9_ = icon_path;
	if (_tmp9_ == NULL) {
		_tmp9_ = "";
	}
	_tmp10_ = g_strdup (_tmp9_);
	_g_free0 (self->priv->icon_path);
	self->priv->icon_path = _tmp10_;
	nuvola_notification_set_resident (self, resident);
	_tmp11_ = g_strdup (category);
	_g_free0 (self->priv->category);
	self->priv->category = _tmp11_;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static DrtgtkAction**
_vala_array_dup3 (DrtgtkAction** self,
                  int length)
{
	DrtgtkAction** result;
	int i;
	result = g_new0 (DrtgtkAction*, length + 1);
	for (i = 0; i < length; i++) {
		DrtgtkAction* _tmp0_;
		_tmp0_ = _g_object_ref0 (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


void
nuvola_notification_set_actions (NuvolaNotification* self,
                                 DrtgtkAction** actions,
                                 int actions_length1)
{
	DrtgtkAction** _tmp0_;
	gint _tmp0__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = (actions != NULL) ? _vala_array_dup3 (actions, actions_length1) : ((gpointer) actions);
	_tmp0__length1 = actions_length1;
	self->priv->actions = (_vala_array_free (self->priv->actions, self->priv->actions_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->actions = _tmp0_;
	self->priv->actions_length1 = _tmp0__length1;
	self->priv->_actions_size_ = self->priv->actions_length1;
}


void
nuvola_notification_remove_actions (NuvolaNotification* self)
{
	DrtgtkAction** _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (DrtgtkAction*, 0 + 1);
	self->priv->actions = (_vala_array_free (self->priv->actions, self->priv->actions_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->actions = _tmp0_;
	self->priv->actions_length1 = 0;
	self->priv->_actions_size_ = self->priv->actions_length1;
}


static GVariant*
_variant_new44 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant*
_variant_new45 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant*
_variant_new46 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant*
_variant_new47 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		NuvolaNotification* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->action);
		_nuvola_notification_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void
______lambda33_ (Block5Data* _data5_)
{
	NuvolaNotification* self;
	DrtgtkAction* _tmp0_;
	self = _data5_->self;
	_tmp0_ = _data5_->action;
	drtgtk_action_activate (_tmp0_, NULL);
}


static void
_______lambda33__notify_action_callback (NotifyNotification* notification,
                                         const gchar* action,
                                         gpointer self)
{
	______lambda33_ (self);
}


static gboolean
_nuvola_notification_show_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = nuvola_notification_show_cb ((NuvolaNotification*) self);
	return result;
}


void
nuvola_notification_show (NuvolaNotification* self,
                          gboolean add_actions)
{
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp1_;
	NotifyNotification* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_;
	NotifyNotification* _tmp21_;
	const gchar* _tmp22_;
	GVariant* _tmp23_;
	guint _tmp38_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->notification;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->notification;
	notify_notification_clear_hints (_tmp1_);
	_tmp2_ = self->priv->notification;
	notify_notification_clear_actions (_tmp2_);
	_tmp3_ = self->priv->icon_path;
	if (g_strcmp0 (_tmp3_, "") != 0) {
		{
			GdkPixbuf* _tmp4_ = NULL;
			const gchar* _tmp5_;
			GdkPixbuf* _tmp6_;
			NotifyNotification* _tmp7_;
			_tmp5_ = self->priv->icon_path;
			_tmp6_ = gdk_pixbuf_new_from_file (_tmp5_, &_inner_error_);
			_tmp4_ = _tmp6_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch46_g_error;
			}
			_tmp7_ = self->priv->notification;
			notify_notification_set_image_from_pixbuf (_tmp7_, _tmp4_);
			_g_object_unref0 (_tmp4_);
		}
		goto __finally46;
		__catch46_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp8_;
			GError* _tmp9_;
			const gchar* _tmp10_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp8_ = self->priv->icon_path;
			_tmp9_ = e;
			_tmp10_ = _tmp9_->message;
			g_warning ("Notifications.vala:78: Failed to icon %s: %s", _tmp8_, _tmp10_);
			_g_error_free0 (e);
		}
		__finally46:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp11_ = self->priv->_resident;
	if (_tmp11_) {
		NotifyNotification* _tmp12_;
		GVariant* _tmp13_;
		_tmp12_ = self->priv->notification;
		_tmp13_ = _variant_new44 (TRUE);
		notify_notification_set_hint (_tmp12_, "resident", _tmp13_);
		_g_variant_unref0 (_tmp13_);
	} else {
		NotifyNotification* _tmp14_;
		GVariant* _tmp15_;
		_tmp14_ = self->priv->notification;
		_tmp15_ = _variant_new45 (TRUE);
		notify_notification_set_hint (_tmp14_, "transient", _tmp15_);
		_g_variant_unref0 (_tmp15_);
	}
	_tmp17_ = self->priv->category;
	if (_tmp17_ != NULL) {
		const gchar* _tmp18_;
		_tmp18_ = self->priv->category;
		_tmp16_ = g_strcmp0 (_tmp18_, "") != 0;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		NotifyNotification* _tmp19_;
		const gchar* _tmp20_;
		_tmp19_ = self->priv->notification;
		_tmp20_ = self->priv->category;
		notify_notification_set_category (_tmp19_, _tmp20_);
	}
	_tmp21_ = self->priv->notification;
	_tmp22_ = self->priv->desktop_entry;
	_tmp23_ = _variant_new46 (_tmp22_);
	notify_notification_set_hint (_tmp21_, "desktop-entry", _tmp23_);
	_g_variant_unref0 (_tmp23_);
	if (add_actions) {
		NotifyNotification* _tmp24_;
		GVariant* _tmp25_;
		DrtgtkAction** _tmp26_;
		gint _tmp26__length1;
		_tmp24_ = self->priv->notification;
		_tmp25_ = _variant_new47 (TRUE);
		notify_notification_set_hint (_tmp24_, "action-icons", _tmp25_);
		_g_variant_unref0 (_tmp25_);
		_tmp26_ = self->priv->actions;
		_tmp26__length1 = self->priv->actions_length1;
		{
			DrtgtkAction** action_collection = NULL;
			gint action_collection_length1 = 0;
			gint _action_collection_size_ = 0;
			gint action_it = 0;
			action_collection = _tmp26_;
			action_collection_length1 = _tmp26__length1;
			for (action_it = 0; action_it < _tmp26__length1; action_it = action_it + 1) {
				DrtgtkAction* _tmp27_;
				DrtgtkAction* action = NULL;
				_tmp27_ = _g_object_ref0 (action_collection[action_it]);
				action = _tmp27_;
				{
					Block5Data* _data5_;
					DrtgtkAction* _tmp28_;
					gboolean _tmp29_;
					gboolean _tmp30_;
					_data5_ = g_slice_new0 (Block5Data);
					_data5_->_ref_count_ = 1;
					_data5_->self = nuvola_notification_ref (self);
					_data5_->action = action;
					_tmp28_ = _data5_->action;
					_tmp29_ = drtgtk_action_get_enabled (_tmp28_);
					_tmp30_ = _tmp29_;
					if (_tmp30_) {
						NotifyNotification* _tmp31_;
						DrtgtkAction* _tmp32_;
						const gchar* _tmp33_;
						const gchar* _tmp34_;
						DrtgtkAction* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp37_;
						_tmp31_ = self->priv->notification;
						_tmp32_ = _data5_->action;
						_tmp33_ = drtgtk_action_get_icon (_tmp32_);
						_tmp34_ = _tmp33_;
						_tmp35_ = _data5_->action;
						_tmp36_ = drtgtk_action_get_label (_tmp35_);
						_tmp37_ = _tmp36_;
						notify_notification_add_action (_tmp31_, _tmp34_, _tmp37_, _______lambda33__notify_action_callback, block5_data_ref (_data5_), block5_data_unref);
					}
					block5_data_unref (_data5_);
					_data5_ = NULL;
				}
			}
		}
	}
	_tmp38_ = self->priv->timeout_id;
	if (_tmp38_ != ((guint) 0)) {
		guint _tmp39_;
		_tmp39_ = self->priv->timeout_id;
		g_source_remove (_tmp39_);
	}
	self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _nuvola_notification_show_cb_gsource_func, nuvola_notification_ref (self), nuvola_notification_unref);
}


gboolean
nuvola_notification_close (NuvolaNotification* self)
{
	gboolean result = FALSE;
	gboolean _tmp4_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		NotifyNotification* _tmp0_;
		_tmp0_ = self->priv->notification;
		if (_tmp0_ != NULL) {
			NotifyNotification* _tmp1_;
			_tmp1_ = self->priv->notification;
			notify_notification_close (_tmp1_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch47_g_error;
			}
		}
		result = TRUE;
		return result;
	}
	goto __finally47;
	__catch47_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("Notifications.vala:118: Failed to close notification: %s", _tmp3_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally47:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return _tmp4_;
}


static gboolean
nuvola_notification_show_cb (NuvolaNotification* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->timeout_id = (guint) 0;
	{
		NotifyNotification* _tmp0_;
		_tmp0_ = self->priv->notification;
		notify_notification_show (_tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch48_g_error;
		}
	}
	goto __finally48;
	__catch48_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("Notifications.vala:130: Unable to show notification: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally48:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp3_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp3_;
	}
	result = FALSE;
	return result;
}


gboolean
nuvola_notification_get_resident (NuvolaNotification* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_resident;
	result = _tmp0_;
	return result;
}


static void
nuvola_notification_set_resident (NuvolaNotification* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_resident = value;
}


static void
nuvola_value_notification_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
nuvola_value_notification_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		nuvola_notification_unref (value->data[0].v_pointer);
	}
}


static void
nuvola_value_notification_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = nuvola_notification_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
nuvola_value_notification_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
nuvola_value_notification_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		NuvolaNotification * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = nuvola_notification_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
nuvola_value_notification_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	NuvolaNotification ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = nuvola_notification_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
nuvola_param_spec_notification (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	NuvolaParamSpecNotification* spec;
	g_return_val_if_fail (g_type_is_a (object_type, NUVOLA_TYPE_NOTIFICATION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
nuvola_value_get_notification (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_NOTIFICATION), NULL);
	return value->data[0].v_pointer;
}


void
nuvola_value_set_notification (GValue* value,
                               gpointer v_object)
{
	NuvolaNotification * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_NOTIFICATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_NOTIFICATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		nuvola_notification_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_notification_unref (old);
	}
}


void
nuvola_value_take_notification (GValue* value,
                                gpointer v_object)
{
	NuvolaNotification * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_NOTIFICATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_NOTIFICATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_notification_unref (old);
	}
}


static void
nuvola_notification_class_init (NuvolaNotificationClass * klass)
{
	nuvola_notification_parent_class = g_type_class_peek_parent (klass);
	((NuvolaNotificationClass *) klass)->finalize = nuvola_notification_finalize;
	g_type_class_add_private (klass, sizeof (NuvolaNotificationPrivate));
}


static void
nuvola_notification_instance_init (NuvolaNotification * self)
{
	gchar* _tmp0_;
	DrtgtkAction** _tmp1_;
	gchar* _tmp2_;
	self->priv = NUVOLA_NOTIFICATION_GET_PRIVATE (self);
	self->priv->_resident = FALSE;
	self->priv->notification = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->icon_path = _tmp0_;
	_tmp1_ = g_new0 (DrtgtkAction*, 0 + 1);
	self->priv->actions = _tmp1_;
	self->priv->actions_length1 = 0;
	self->priv->_actions_size_ = self->priv->actions_length1;
	_tmp2_ = g_strdup ("");
	self->priv->category = _tmp2_;
	self->priv->timeout_id = (guint) 0;
	self->ref_count = 1;
}


static void
nuvola_notification_finalize (NuvolaNotification * obj)
{
	NuvolaNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_NOTIFICATION, NuvolaNotification);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->notification);
	_g_free0 (self->priv->icon_path);
	self->priv->actions = (_vala_array_free (self->priv->actions, self->priv->actions_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (self->priv->desktop_entry);
	_g_free0 (self->priv->category);
}


GType
nuvola_notification_get_type (void)
{
	static volatile gsize nuvola_notification_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_notification_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { nuvola_value_notification_init, nuvola_value_notification_free_value, nuvola_value_notification_copy_value, nuvola_value_notification_peek_pointer, "p", nuvola_value_notification_collect_value, "p", nuvola_value_notification_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaNotification), 0, (GInstanceInitFunc) nuvola_notification_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType nuvola_notification_type_id;
		nuvola_notification_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NuvolaNotification", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&nuvola_notification_type_id__volatile, nuvola_notification_type_id);
	}
	return nuvola_notification_type_id__volatile;
}


gpointer
nuvola_notification_ref (gpointer instance)
{
	NuvolaNotification * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
nuvola_notification_unref (gpointer instance)
{
	NuvolaNotification * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		NUVOLA_NOTIFICATION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static void
_nuvola_notification_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (nuvola_notification_unref (var), NULL));
}


NuvolaNotifications*
nuvola_notifications_construct (GType object_type,
                                NuvolaAppRunnerController* app,
                                NuvolaActionsHelper* actions_helper)
{
	NuvolaNotifications * self = NULL;
	NuvolaAppRunnerController* _tmp0_;
	NuvolaActionsHelper* _tmp1_;
	GHashFunc _tmp2_;
	GEqualFunc _tmp3_;
	GHashTable* _tmp4_;
	g_return_val_if_fail (app != NULL, NULL);
	g_return_val_if_fail (actions_helper != NULL, NULL);
	self = (NuvolaNotifications*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (app);
	_g_object_unref0 (self->priv->app);
	self->priv->app = _tmp0_;
	_tmp1_ = _g_object_ref0 (actions_helper);
	_g_object_unref0 (self->priv->actions_helper);
	self->priv->actions_helper = _tmp1_;
	_tmp2_ = g_str_hash;
	_tmp3_ = g_str_equal;
	_tmp4_ = g_hash_table_new_full (_tmp2_, _tmp3_, _g_free0_, _nuvola_notification_unref0_);
	_g_hash_table_unref0 (self->priv->notifications);
	self->priv->notifications = _tmp4_;
	return self;
}


NuvolaNotifications*
nuvola_notifications_new (NuvolaAppRunnerController* app,
                          NuvolaActionsHelper* actions_helper)
{
	return nuvola_notifications_construct (NUVOLA_TYPE_NOTIFICATIONS, app, actions_helper);
}


static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


static inline void
_g_list_free__g_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
}


void
nuvola_notifications_start (NuvolaNotifications* self)
{
	gboolean _tmp0_;
	NuvolaAppRunnerController* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GList* capabilities = NULL;
	GList* _tmp4_;
	GCompareFunc _tmp5_;
	GList* _tmp6_;
	GCompareFunc _tmp7_;
	GList* _tmp8_;
	GCompareFunc _tmp9_;
	GList* _tmp10_;
	gboolean _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gboolean _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_running;
	g_return_if_fail (!_tmp0_);
	nuvola_notifications_set_running (self, TRUE);
	_tmp1_ = self->priv->app;
	_tmp2_ = drtgtk_application_get_app_name ((DrtgtkApplication*) _tmp1_);
	_tmp3_ = _tmp2_;
	notify_init (_tmp3_);
	_tmp4_ = notify_get_server_caps ();
	capabilities = _tmp4_;
	_tmp5_ = g_strcmp0;
	_tmp6_ = g_list_find_custom (capabilities, "persistence", _tmp5_);
	self->priv->persistence_supported = _tmp6_ != NULL;
	_tmp7_ = g_strcmp0;
	_tmp8_ = g_list_find_custom (capabilities, "actions", _tmp7_);
	self->priv->actions_supported = _tmp8_ != NULL;
	_tmp9_ = g_strcmp0;
	_tmp10_ = g_list_find_custom (capabilities, "action-icons", _tmp9_);
	self->priv->icons_supported = _tmp10_ != NULL;
	_tmp11_ = self->priv->persistence_supported;
	_tmp12_ = bool_to_string (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = self->priv->actions_supported;
	_tmp15_ = bool_to_string (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = self->priv->icons_supported;
	_tmp18_ = bool_to_string (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strconcat ("Notifications: persistence ", _tmp13_, ", actions ", _tmp16_, ", icons ", _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	g_debug ("Notifications.vala:163: %s", _tmp21_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp13_);
	__g_list_free__g_free0_0 (capabilities);
}


static gboolean
__lambda34_ (NuvolaNotifications* self,
             const gchar* key,
             NuvolaNotification* notification)
{
	gboolean result = FALSE;
	g_return_val_if_fail (key != NULL, FALSE);
	g_return_val_if_fail (notification != NULL, FALSE);
	nuvola_notification_close (notification);
	result = TRUE;
	return result;
}


static gboolean
___lambda34__ghr_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
	gboolean result;
	result = __lambda34_ ((NuvolaNotifications*) self, (const gchar*) key, (NuvolaNotification*) value);
	return result;
}


void
nuvola_notifications_stop (NuvolaNotifications* self)
{
	gboolean _tmp0_;
	GHashTable* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_running;
	g_return_if_fail (_tmp0_);
	nuvola_notifications_set_running (self, FALSE);
	_tmp1_ = self->priv->notifications;
	g_hash_table_foreach_remove (_tmp1_, ___lambda34__ghr_func, self);
	notify_uninit ();
}


static gpointer
_nuvola_notification_ref0 (gpointer self)
{
	return self ? nuvola_notification_ref (self) : NULL;
}


NuvolaNotification*
nuvola_notifications_get_or_create (NuvolaNotifications* self,
                                    const gchar* name)
{
	NuvolaNotification* result = NULL;
	NuvolaNotification* notification = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	NuvolaNotification* _tmp2_;
	NuvolaNotification* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = self->priv->notifications;
	_tmp1_ = g_hash_table_lookup (_tmp0_, name);
	_tmp2_ = _nuvola_notification_ref0 ((NuvolaNotification*) _tmp1_);
	notification = _tmp2_;
	_tmp3_ = notification;
	if (_tmp3_ == NULL) {
		NuvolaAppRunnerController* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		NuvolaNotification* _tmp7_;
		GHashTable* _tmp8_;
		gchar* _tmp9_;
		NuvolaNotification* _tmp10_;
		NuvolaNotification* _tmp11_;
		_tmp4_ = self->priv->app;
		_tmp5_ = drtgtk_application_get_app_id ((DrtgtkApplication*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = nuvola_notification_new (_tmp6_);
		_nuvola_notification_unref0 (notification);
		notification = _tmp7_;
		_tmp8_ = self->priv->notifications;
		_tmp9_ = g_strdup (name);
		_tmp10_ = notification;
		_tmp11_ = _nuvola_notification_ref0 (_tmp10_);
		g_hash_table_insert (_tmp8_, _tmp9_, _tmp11_);
	}
	result = notification;
	return result;
}


static gboolean
nuvola_notifications_real_update (NuvolaNotificationInterface* base,
                                  const gchar* name,
                                  const gchar* summary,
                                  const gchar* body,
                                  const gchar* icon_name,
                                  const gchar* icon_path,
                                  gboolean resident,
                                  const gchar* category)
{
	NuvolaNotifications * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	NuvolaNotification* _tmp2_;
	NuvolaNotification* _tmp3_;
	self = (NuvolaNotifications*) base;
	g_return_val_if_fail (name != NULL, FALSE);
	g_return_val_if_fail (summary != NULL, FALSE);
	g_return_val_if_fail (body != NULL, FALSE);
	g_return_val_if_fail (category != NULL, FALSE);
	_tmp1_ = self->priv->persistence_supported;
	if (_tmp1_) {
		_tmp0_ = resident;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp2_ = nuvola_notifications_get_or_create (self, name);
	_tmp3_ = _tmp2_;
	nuvola_notification_update (_tmp3_, summary, body, icon_name, icon_path, _tmp0_, category);
	_nuvola_notification_unref0 (_tmp3_);
	result = NUVOLA_BINDING_CONTINUE;
	return result;
}


static void
_vala_array_add1 (DrtgtkAction** * array,
                  int* length,
                  int* size,
                  DrtgtkAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DrtgtkAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gboolean
nuvola_notifications_real_set_actions (NuvolaNotificationInterface* base,
                                       const gchar* name,
                                       gchar** actions,
                                       int actions_length1)
{
	NuvolaNotifications * self;
	gboolean result = FALSE;
	DrtgtkAction** actions_found = NULL;
	DrtgtkAction** _tmp0_;
	gint actions_found_length1;
	gint _actions_found_size_;
	NuvolaNotification* _tmp12_;
	NuvolaNotification* _tmp13_;
	DrtgtkAction** _tmp14_;
	gint _tmp14__length1;
	self = (NuvolaNotifications*) base;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = g_new0 (DrtgtkAction*, 0 + 1);
	actions_found = _tmp0_;
	actions_found_length1 = 0;
	_actions_found_size_ = actions_found_length1;
	{
		gchar** action_name_collection = NULL;
		gint action_name_collection_length1 = 0;
		gint _action_name_collection_size_ = 0;
		gint action_name_it = 0;
		action_name_collection = actions;
		action_name_collection_length1 = actions_length1;
		for (action_name_it = 0; action_name_it < actions_length1; action_name_it = action_name_it + 1) {
			gchar* _tmp1_;
			gchar* action_name = NULL;
			_tmp1_ = g_strdup (action_name_collection[action_name_it]);
			action_name = _tmp1_;
			{
				DrtgtkAction* action = NULL;
				NuvolaAppRunnerController* _tmp2_;
				DrtgtkActions* _tmp3_;
				DrtgtkActions* _tmp4_;
				const gchar* _tmp5_;
				DrtgtkAction* _tmp6_;
				DrtgtkAction* _tmp7_;
				_tmp2_ = self->priv->app;
				_tmp3_ = drtgtk_application_get_actions ((DrtgtkApplication*) _tmp2_);
				_tmp4_ = _tmp3_;
				_tmp5_ = action_name;
				_tmp6_ = drtgtk_actions_get_action (_tmp4_, _tmp5_);
				action = _tmp6_;
				_tmp7_ = action;
				if (_tmp7_ != NULL) {
					DrtgtkAction** _tmp8_;
					gint _tmp8__length1;
					DrtgtkAction* _tmp9_;
					DrtgtkAction* _tmp10_;
					_tmp8_ = actions_found;
					_tmp8__length1 = actions_found_length1;
					_tmp9_ = action;
					_tmp10_ = _g_object_ref0 (_tmp9_);
					_vala_array_add1 (&actions_found, &actions_found_length1, &_actions_found_size_, _tmp10_);
				} else {
					const gchar* _tmp11_;
					_tmp11_ = action_name;
					g_warning ("Notifications.vala:199: Action '%s' not found.", _tmp11_);
				}
				_g_object_unref0 (action);
				_g_free0 (action_name);
			}
		}
	}
	_tmp12_ = nuvola_notifications_get_or_create (self, name);
	_tmp13_ = _tmp12_;
	_tmp14_ = actions_found;
	_tmp14__length1 = actions_found_length1;
	nuvola_notification_set_actions (_tmp13_, _tmp14_, _tmp14__length1);
	_nuvola_notification_unref0 (_tmp13_);
	result = NUVOLA_BINDING_CONTINUE;
	actions_found = (_vala_array_free (actions_found, actions_found_length1, (GDestroyNotify) g_object_unref), NULL);
	return result;
}


static gboolean
nuvola_notifications_real_remove_actions (NuvolaNotificationInterface* base,
                                          const gchar* name)
{
	NuvolaNotifications * self;
	gboolean result = FALSE;
	NuvolaNotification* _tmp0_;
	NuvolaNotification* _tmp1_;
	self = (NuvolaNotifications*) base;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = nuvola_notifications_get_or_create (self, name);
	_tmp1_ = _tmp0_;
	nuvola_notification_remove_actions (_tmp1_);
	_nuvola_notification_unref0 (_tmp1_);
	result = NUVOLA_BINDING_CONTINUE;
	return result;
}


static gboolean
nuvola_notifications_real_show (NuvolaNotificationInterface* base,
                                const gchar* name,
                                gboolean force)
{
	NuvolaNotifications * self;
	gboolean result = FALSE;
	NuvolaNotification* notification = NULL;
	NuvolaNotification* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean add_actions = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	self = (NuvolaNotifications*) base;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = nuvola_notifications_get_or_create (self, name);
	notification = _tmp0_;
	_tmp2_ = self->priv->actions_supported;
	if (_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = self->priv->icons_supported;
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	add_actions = _tmp1_;
	if (force) {
		_tmp5_ = TRUE;
	} else {
		NuvolaAppRunnerController* _tmp6_;
		NuvolaWebAppWindow* _tmp7_;
		NuvolaWebAppWindow* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp6_ = self->priv->app;
		_tmp7_ = nuvola_app_runner_controller_get_main_window (_tmp6_);
		_tmp8_ = _tmp7_;
		g_object_get ((GtkWindow*) _tmp8_, "is-active", &_tmp9_, NULL);
		_tmp10_ = _tmp9_;
		_tmp5_ = !_tmp10_;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		NuvolaNotification* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		_tmp11_ = notification;
		_tmp12_ = nuvola_notification_get_resident (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp4_ = _tmp13_;
	}
	if (_tmp4_) {
		NuvolaNotification* _tmp14_;
		gboolean _tmp15_;
		_tmp14_ = notification;
		_tmp15_ = add_actions;
		nuvola_notification_show (_tmp14_, _tmp15_);
	}
	result = NUVOLA_BINDING_CONTINUE;
	_nuvola_notification_unref0 (notification);
	return result;
}


static gboolean
nuvola_notifications_real_show_anonymous (NuvolaNotificationsInterface* base,
                                          const gchar* summary,
                                          const gchar* body,
                                          const gchar* icon_name,
                                          const gchar* icon_path,
                                          gboolean force,
                                          const gchar* category)
{
	NuvolaNotifications * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaNotifications*) base;
	g_return_val_if_fail (summary != NULL, FALSE);
	g_return_val_if_fail (body != NULL, FALSE);
	g_return_val_if_fail (category != NULL, FALSE);
	if (force) {
		_tmp0_ = TRUE;
	} else {
		NuvolaAppRunnerController* _tmp1_;
		NuvolaWebAppWindow* _tmp2_;
		NuvolaWebAppWindow* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp1_ = self->priv->app;
		_tmp2_ = nuvola_app_runner_controller_get_main_window (_tmp1_);
		_tmp3_ = _tmp2_;
		g_object_get ((GtkWindow*) _tmp3_, "is-active", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		_tmp0_ = !_tmp5_;
	}
	if (_tmp0_) {
		NuvolaNotification* notification = NULL;
		NuvolaAppRunnerController* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		NuvolaNotification* _tmp9_;
		NuvolaNotification* _tmp10_;
		NuvolaNotification* _tmp11_;
		_tmp6_ = self->priv->app;
		_tmp7_ = drtgtk_application_get_app_id ((DrtgtkApplication*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = nuvola_notification_new (_tmp8_);
		notification = _tmp9_;
		_tmp10_ = notification;
		nuvola_notification_update (_tmp10_, summary, body, icon_name, icon_path, FALSE, category);
		_tmp11_ = notification;
		nuvola_notification_show (_tmp11_, FALSE);
		_nuvola_notification_unref0 (notification);
	}
	result = NUVOLA_BINDING_CONTINUE;
	return result;
}


static gboolean
nuvola_notifications_real_is_persistence_supported (NuvolaNotificationsInterface* base,
                                                    gboolean* supported)
{
	NuvolaNotifications * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaNotifications*) base;
	if (!(*supported)) {
		gboolean _tmp1_;
		_tmp1_ = self->priv->persistence_supported;
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		*supported = TRUE;
	}
	result = NUVOLA_BINDING_CONTINUE;
	return result;
}


gboolean
nuvola_notifications_get_running (NuvolaNotifications* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_running;
	result = _tmp0_;
	return result;
}


static void
nuvola_notifications_set_running (NuvolaNotifications* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	if (nuvola_notifications_get_running (self) != value) {
		self->priv->_running = value;
		g_object_notify_by_pspec ((GObject *) self, nuvola_notifications_properties[NUVOLA_NOTIFICATIONS_RUNNING_PROPERTY]);
	}
}


static void
nuvola_notifications_class_init (NuvolaNotificationsClass * klass)
{
	nuvola_notifications_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaNotificationsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_notifications_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_notifications_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_notifications_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_NOTIFICATIONS_RUNNING_PROPERTY, nuvola_notifications_properties[NUVOLA_NOTIFICATIONS_RUNNING_PROPERTY] = g_param_spec_boolean ("running", "running", "running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
nuvola_notifications_nuvola_notifications_interface_interface_init (NuvolaNotificationsInterfaceIface * iface)
{
	nuvola_notifications_nuvola_notifications_interface_parent_iface = g_type_interface_peek_parent (iface);
	iface->show_anonymous = (gboolean (*) (NuvolaNotificationsInterface *, const gchar*, const gchar*, const gchar*, const gchar*, gboolean, const gchar*)) nuvola_notifications_real_show_anonymous;
	iface->is_persistence_supported = (gboolean (*) (NuvolaNotificationsInterface *, gboolean*)) nuvola_notifications_real_is_persistence_supported;
}


static void
nuvola_notifications_nuvola_notification_interface_interface_init (NuvolaNotificationInterfaceIface * iface)
{
	nuvola_notifications_nuvola_notification_interface_parent_iface = g_type_interface_peek_parent (iface);
	iface->update = (gboolean (*) (NuvolaNotificationInterface *, const gchar*, const gchar*, const gchar*, const gchar*, const gchar*, gboolean, const gchar*)) nuvola_notifications_real_update;
	iface->set_actions = (gboolean (*) (NuvolaNotificationInterface *, const gchar*, gchar**, int)) nuvola_notifications_real_set_actions;
	iface->remove_actions = (gboolean (*) (NuvolaNotificationInterface *, const gchar*)) nuvola_notifications_real_remove_actions;
	iface->show = (gboolean (*) (NuvolaNotificationInterface *, const gchar*, gboolean)) nuvola_notifications_real_show;
}


static void
nuvola_notifications_instance_init (NuvolaNotifications * self)
{
	self->priv = NUVOLA_NOTIFICATIONS_GET_PRIVATE (self);
	self->priv->_running = FALSE;
	self->priv->actions_supported = FALSE;
	self->priv->persistence_supported = FALSE;
	self->priv->icons_supported = FALSE;
}


static void
nuvola_notifications_finalize (GObject * obj)
{
	NuvolaNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_NOTIFICATIONS, NuvolaNotifications);
	_g_object_unref0 (self->priv->app);
	_g_object_unref0 (self->priv->actions_helper);
	_g_hash_table_unref0 (self->priv->notifications);
	G_OBJECT_CLASS (nuvola_notifications_parent_class)->finalize (obj);
}


/**
 * Manages notifications
 */
GType
nuvola_notifications_get_type (void)
{
	static volatile gsize nuvola_notifications_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_notifications_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaNotificationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_notifications_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaNotifications), 0, (GInstanceInitFunc) nuvola_notifications_instance_init, NULL };
		static const GInterfaceInfo nuvola_notifications_interface_info = { (GInterfaceInitFunc) nuvola_notifications_nuvola_notifications_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo nuvola_notification_interface_info = { (GInterfaceInitFunc) nuvola_notifications_nuvola_notification_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType nuvola_notifications_type_id;
		nuvola_notifications_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaNotifications", &g_define_type_info, 0);
		g_type_add_interface_static (nuvola_notifications_type_id, NUVOLA_TYPE_NOTIFICATIONS_INTERFACE, &nuvola_notifications_interface_info);
		g_type_add_interface_static (nuvola_notifications_type_id, NUVOLA_TYPE_NOTIFICATION_INTERFACE, &nuvola_notification_interface_info);
		g_once_init_leave (&nuvola_notifications_type_id__volatile, nuvola_notifications_type_id);
	}
	return nuvola_notifications_type_id__volatile;
}


static void
_vala_nuvola_notifications_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	NuvolaNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_NOTIFICATIONS, NuvolaNotifications);
	switch (property_id) {
		case NUVOLA_NOTIFICATIONS_RUNNING_PROPERTY:
		g_value_set_boolean (value, nuvola_notifications_get_running (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_nuvola_notifications_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	NuvolaNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_NOTIFICATIONS, NuvolaNotifications);
	switch (property_id) {
		case NUVOLA_NOTIFICATIONS_RUNNING_PROPERTY:
		nuvola_notifications_set_running (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



