/* PreferencesDialog.c generated by valac 0.40.6, the Vala compiler
 * generated from PreferencesDialog.vala, do not modify */

/*
 * Copyright 2014-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <dioritegtk4.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define NUVOLA_TYPE_PREFERENCES_DIALOG (nuvola_preferences_dialog_get_type ())
#define NUVOLA_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_PREFERENCES_DIALOG, NuvolaPreferencesDialog))
#define NUVOLA_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_PREFERENCES_DIALOG, NuvolaPreferencesDialogClass))
#define NUVOLA_IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_PREFERENCES_DIALOG))
#define NUVOLA_IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_PREFERENCES_DIALOG))
#define NUVOLA_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_PREFERENCES_DIALOG, NuvolaPreferencesDialogClass))

typedef struct _NuvolaPreferencesDialog NuvolaPreferencesDialog;
typedef struct _NuvolaPreferencesDialogClass NuvolaPreferencesDialogClass;
typedef struct _NuvolaPreferencesDialogPrivate NuvolaPreferencesDialogPrivate;
enum  {
	NUVOLA_PREFERENCES_DIALOG_0_PROPERTY,
	NUVOLA_PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* nuvola_preferences_dialog_properties[NUVOLA_PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NuvolaPreferencesDialog {
	GtkDialog parent_instance;
	NuvolaPreferencesDialogPrivate * priv;
};

struct _NuvolaPreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _NuvolaPreferencesDialogPrivate {
	DrtgtkApplication* app;
	GtkNotebook* notebook;
};


static gpointer nuvola_preferences_dialog_parent_class = NULL;

GType nuvola_preferences_dialog_get_type (void) G_GNUC_CONST;
#define NUVOLA_PREFERENCES_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_PREFERENCES_DIALOG, NuvolaPreferencesDialogPrivate))
#define NUVOLA_PREFERENCES_DIALOG_TITLE "Web App Preferences"
NuvolaPreferencesDialog* nuvola_preferences_dialog_new (DrtgtkApplication* app,
                                                        GtkWindow* parent,
                                                        GtkWidget* form);
NuvolaPreferencesDialog* nuvola_preferences_dialog_construct (GType object_type,
                                                              DrtgtkApplication* app,
                                                              GtkWindow* parent,
                                                              GtkWidget* form);
void nuvola_preferences_dialog_add_tab (NuvolaPreferencesDialog* self,
                                        const gchar* label,
                                        GtkWidget* widget);
static gboolean nuvola_preferences_dialog_real_delete_event (GtkWidget* base,
                                                      GdkEventAny* event);
static void nuvola_preferences_dialog_finalize (GObject * obj);


/**
     * Constructs new main window
     *
     * @param app Application object
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


NuvolaPreferencesDialog*
nuvola_preferences_dialog_construct (GType object_type,
                                     DrtgtkApplication* app,
                                     GtkWindow* parent,
                                     GtkWidget* form)
{
	NuvolaPreferencesDialog * self = NULL;
	DrtgtkApplication* _tmp0_;
	GtkNotebook* _tmp6_;
	GtkNotebook* _tmp7_;
	GtkNotebook* _tmp8_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp9_;
	GtkNotebook* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkBox* _tmp13_;
	GtkNotebook* _tmp14_;
	GtkNotebook* _tmp15_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	g_return_val_if_fail (form != NULL, NULL);
	self = (NuvolaPreferencesDialog*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (app);
	_g_object_unref0 (self->priv->app);
	self->priv->app = _tmp0_;
	g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_CENTER, NULL);
	gtk_window_set_title ((GtkWindow*) self, NUVOLA_PREFERENCES_DIALOG_TITLE);
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 5);
	{
		GdkPixbuf* _tmp1_ = NULL;
		GtkIconTheme* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GdkPixbuf* _tmp5_;
		_tmp2_ = gtk_icon_theme_get_default ();
		_tmp3_ = drtgtk_application_get_icon (app);
		_tmp4_ = _tmp3_;
		_tmp5_ = gtk_icon_theme_load_icon (_tmp2_, _tmp4_, 48, 0, &_inner_error_);
		_tmp1_ = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch71_g_error;
		}
		gtk_window_set_icon ((GtkWindow*) self, _tmp1_);
		_g_object_unref0 (_tmp1_);
	}
	goto __finally71;
	__catch71_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("PreferencesDialog.vala:48: Unable to load application icon.");
		_g_error_free0 (e);
	}
	__finally71:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	gtk_window_set_default_size ((GtkWindow*) self, 650, 500);
	if (parent != NULL) {
		gtk_window_set_transient_for ((GtkWindow*) self, parent);
	}
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	gtk_dialog_add_buttons ((GtkDialog*) self, "Cancel", GTK_RESPONSE_CLOSE, "Save changes", GTK_RESPONSE_OK, NULL);
	_tmp6_ = (GtkNotebook*) gtk_notebook_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->notebook);
	self->priv->notebook = _tmp6_;
	_tmp7_ = self->priv->notebook;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp7_, 10);
	_tmp8_ = self->priv->notebook;
	gtk_notebook_set_tab_pos (_tmp8_, GTK_POS_LEFT);
	_tmp9_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp9_);
	scroll = _tmp9_;
	gtk_container_add ((GtkContainer*) scroll, form);
	gtk_widget_show_all ((GtkWidget*) scroll);
	_tmp10_ = self->priv->notebook;
	_tmp11_ = (GtkLabel*) gtk_label_new ("General");
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	gtk_notebook_append_page (_tmp10_, (GtkWidget*) scroll, (GtkWidget*) _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	_tmp14_ = self->priv->notebook;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = self->priv->notebook;
	gtk_widget_show ((GtkWidget*) _tmp15_);
	_g_object_unref0 (scroll);
	return self;
}


NuvolaPreferencesDialog*
nuvola_preferences_dialog_new (DrtgtkApplication* app,
                               GtkWindow* parent,
                               GtkWidget* form)
{
	return nuvola_preferences_dialog_construct (NUVOLA_TYPE_PREFERENCES_DIALOG, app, parent, form);
}


void
nuvola_preferences_dialog_add_tab (NuvolaPreferencesDialog* self,
                                   const gchar* label,
                                   GtkWidget* widget)
{
	GtkNotebook* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	g_return_if_fail (widget != NULL);
	gtk_widget_show (widget);
	_tmp0_ = self->priv->notebook;
	_tmp1_ = (GtkLabel*) gtk_label_new (label);
	g_object_ref_sink (_tmp1_);
	_tmp2_ = _tmp1_;
	gtk_notebook_append_page (_tmp0_, widget, (GtkWidget*) _tmp2_);
	_g_object_unref0 (_tmp2_);
}


static gboolean
nuvola_preferences_dialog_real_delete_event (GtkWidget* base,
                                             GdkEventAny* event)
{
	NuvolaPreferencesDialog * self;
	gboolean result = FALSE;
	self = (NuvolaPreferencesDialog*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	result = FALSE;
	return result;
}


static void
nuvola_preferences_dialog_class_init (NuvolaPreferencesDialogClass * klass)
{
	nuvola_preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaPreferencesDialogPrivate));
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget *, GdkEventAny*)) nuvola_preferences_dialog_real_delete_event;
	G_OBJECT_CLASS (klass)->finalize = nuvola_preferences_dialog_finalize;
}


static void
nuvola_preferences_dialog_instance_init (NuvolaPreferencesDialog * self)
{
	self->priv = NUVOLA_PREFERENCES_DIALOG_GET_PRIVATE (self);
}


static void
nuvola_preferences_dialog_finalize (GObject * obj)
{
	NuvolaPreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_PREFERENCES_DIALOG, NuvolaPreferencesDialog);
	_g_object_unref0 (self->priv->app);
	_g_object_unref0 (self->priv->notebook);
	G_OBJECT_CLASS (nuvola_preferences_dialog_parent_class)->finalize (obj);
}


GType
nuvola_preferences_dialog_get_type (void)
{
	static volatile gsize nuvola_preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_preferences_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaPreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaPreferencesDialog), 0, (GInstanceInitFunc) nuvola_preferences_dialog_instance_init, NULL };
		GType nuvola_preferences_dialog_type_id;
		nuvola_preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "NuvolaPreferencesDialog", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_preferences_dialog_type_id__volatile, nuvola_preferences_dialog_type_id);
	}
	return nuvola_preferences_dialog_type_id__volatile;
}



