/* TimePositionButton.c generated by valac 0.40.6, the Vala compiler
 * generated from TimePositionButton.vala, do not modify */

/*
 * Copyright 2017-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <dioritegtk4.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_TIME_POSITION_BUTTON (nuvola_time_position_button_get_type ())
#define NUVOLA_TIME_POSITION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton))
#define NUVOLA_TIME_POSITION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButtonClass))
#define NUVOLA_IS_TIME_POSITION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_TIME_POSITION_BUTTON))
#define NUVOLA_IS_TIME_POSITION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_TIME_POSITION_BUTTON))
#define NUVOLA_TIME_POSITION_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButtonClass))

typedef struct _NuvolaTimePositionButton NuvolaTimePositionButton;
typedef struct _NuvolaTimePositionButtonClass NuvolaTimePositionButtonClass;
typedef struct _NuvolaTimePositionButtonPrivate NuvolaTimePositionButtonPrivate;
enum  {
	NUVOLA_TIME_POSITION_BUTTON_0_PROPERTY,
	NUVOLA_TIME_POSITION_BUTTON_START_SEC_PROPERTY,
	NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC_PROPERTY,
	NUVOLA_TIME_POSITION_BUTTON_END_SEC_PROPERTY,
	NUVOLA_TIME_POSITION_BUTTON_ORIENTATION_PROPERTY,
	NUVOLA_TIME_POSITION_BUTTON_NUM_PROPERTIES
};
static GParamSpec* nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NUVOLA_TIME_POSITION_BUTTON_POSITION_CHANGED_SIGNAL,
	NUVOLA_TIME_POSITION_BUTTON_NUM_SIGNALS
};
static guint nuvola_time_position_button_signals[NUVOLA_TIME_POSITION_BUTTON_NUM_SIGNALS] = {0};

struct _NuvolaTimePositionButton {
	DrtgtkPopoverButton parent_instance;
	NuvolaTimePositionButtonPrivate * priv;
};

struct _NuvolaTimePositionButtonClass {
	DrtgtkPopoverButtonClass parent_class;
};

struct _NuvolaTimePositionButtonPrivate {
	gint _start_sec;
	gint _position_sec;
	gint _end_sec;
	GtkOrientation _orientation;
	GtkScale* scale;
};


static gpointer nuvola_time_position_button_parent_class = NULL;

GType nuvola_time_position_button_get_type (void) G_GNUC_CONST;
#define NUVOLA_TIME_POSITION_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButtonPrivate))
static gchar* nuvola_time_position_button_format_time_double (NuvolaTimePositionButton* self,
                                                       gdouble seconds);
static gchar* _nuvola_time_position_button_format_time_double_gtk_scale_format_value (GtkScale* _sender,
                                                                               gdouble value,
                                                                               gpointer self);
static void nuvola_time_position_button_update_label (NuvolaTimePositionButton* self);
static void _nuvola_time_position_button_update_label_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void nuvola_time_position_button_on_value_changed (NuvolaTimePositionButton* self,
                                                   GtkRange* scale);
static void _nuvola_time_position_button_on_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                            gpointer self);
NuvolaTimePositionButton* nuvola_time_position_button_new (gint start_sec,
                                                           gint end_sec,
                                                           gint position_sec,
                                                           GtkOrientation orientation);
NuvolaTimePositionButton* nuvola_time_position_button_construct (GType object_type,
                                                                 gint start_sec,
                                                                 gint end_sec,
                                                                 gint position_sec,
                                                                 GtkOrientation orientation);
static gchar* nuvola_time_position_button_format_time (NuvolaTimePositionButton* self,
                                                gint seconds);
gint nuvola_time_position_button_get_position_sec (NuvolaTimePositionButton* self);
gint nuvola_time_position_button_get_end_sec (NuvolaTimePositionButton* self);
static inline gint nuvola_time_position_button_round_sec (NuvolaTimePositionButton* self,
                                            gdouble sec);
void nuvola_time_position_button_set_position_sec (NuvolaTimePositionButton* self,
                                                   gint value);
gint nuvola_time_position_button_get_start_sec (NuvolaTimePositionButton* self);
void nuvola_time_position_button_set_start_sec (NuvolaTimePositionButton* self,
                                                gint value);
void nuvola_time_position_button_set_end_sec (NuvolaTimePositionButton* self,
                                              gint value);
GtkOrientation nuvola_time_position_button_get_orientation (NuvolaTimePositionButton* self);
void nuvola_time_position_button_set_orientation (NuvolaTimePositionButton* self,
                                                  GtkOrientation value);
static GObject * nuvola_time_position_button_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void nuvola_time_position_button_finalize (GObject * obj);
static void _vala_nuvola_time_position_button_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_nuvola_time_position_button_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);


static gchar*
_nuvola_time_position_button_format_time_double_gtk_scale_format_value (GtkScale* _sender,
                                                                        gdouble value,
                                                                        gpointer self)
{
	gchar* result;
	result = nuvola_time_position_button_format_time_double ((NuvolaTimePositionButton*) self, value);
	return result;
}


static void
_nuvola_time_position_button_update_label_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
	nuvola_time_position_button_update_label ((NuvolaTimePositionButton*) self);
}


static void
_nuvola_time_position_button_on_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                       gpointer self)
{
	nuvola_time_position_button_on_value_changed ((NuvolaTimePositionButton*) self, _sender);
}


/**
     * Create new TimePositionButton
     *
     * @param start_sec         The start time in seconds.
     * @param end_sec           The end time in seconds.
     * @param position_sec      The current time in seconds.
     * @param orientation       The orientation of the slider.
     */
NuvolaTimePositionButton*
nuvola_time_position_button_construct (GType object_type,
                                       gint start_sec,
                                       gint end_sec,
                                       gint position_sec,
                                       GtkOrientation orientation)
{
	NuvolaTimePositionButton * self = NULL;
	self = (NuvolaTimePositionButton*) g_object_new (object_type, "start-sec", start_sec, "end-sec", end_sec, "position-sec", position_sec, "orientation", orientation, NULL);
	return self;
}


NuvolaTimePositionButton*
nuvola_time_position_button_new (gint start_sec,
                                 gint end_sec,
                                 gint position_sec,
                                 GtkOrientation orientation)
{
	return nuvola_time_position_button_construct (NUVOLA_TYPE_TIME_POSITION_BUTTON, start_sec, end_sec, position_sec, orientation);
}


static void
nuvola_time_position_button_update_label (NuvolaTimePositionButton* self)
{
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_position_sec;
	_tmp1_ = nuvola_time_position_button_format_time (self, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_end_sec;
	_tmp4_ = nuvola_time_position_button_format_time (self, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("%s/%s", _tmp2_, _tmp5_);
	_tmp7_ = _tmp6_;
	gtk_button_set_label ((GtkButton*) self, _tmp7_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
}


static gchar*
nuvola_time_position_button_format_time (NuvolaTimePositionButton* self,
                                         gint seconds)
{
	gchar* result = NULL;
	gint hours = 0;
	gchar* _tmp0_ = NULL;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp5_;
	gint _tmp6_;
	gint minutes = 0;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	g_return_val_if_fail (self != NULL, NULL);
	hours = seconds / 3600;
	_tmp1_ = hours;
	if (_tmp1_ > 0) {
		gint _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = hours;
		_tmp3_ = g_strdup_printf ("%02d:", _tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = g_strdup (_tmp0_);
	_result_ = _tmp5_;
	_tmp6_ = hours;
	seconds = seconds - (_tmp6_ * 3600);
	minutes = seconds / 60;
	seconds = seconds - (minutes * 60);
	_tmp7_ = g_strdup_printf ("%02d:%02d", minutes, seconds);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_result_, _tmp8_, NULL);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	result = _tmp10_;
	_g_free0 (_result_);
	_g_free0 (_tmp0_);
	return result;
}


static gchar*
nuvola_time_position_button_format_time_double (NuvolaTimePositionButton* self,
                                                gdouble seconds)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = nuvola_time_position_button_format_time (self, nuvola_time_position_button_round_sec (self, seconds));
	result = _tmp0_;
	return result;
}


static inline gint
nuvola_time_position_button_round_sec (NuvolaTimePositionButton* self,
                                       gdouble sec)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) round (sec);
	return result;
}


static void
nuvola_time_position_button_on_value_changed (NuvolaTimePositionButton* self,
                                              GtkRange* scale)
{
	gint position = 0;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (scale != NULL);
	_tmp0_ = gtk_range_get_adjustment (scale);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	position = nuvola_time_position_button_round_sec (self, _tmp3_);
	_tmp4_ = self->priv->_position_sec;
	_tmp5_ = position;
	if (_tmp4_ != _tmp5_) {
		gint _tmp6_;
		_tmp6_ = position;
		nuvola_time_position_button_set_position_sec (self, _tmp6_);
		g_signal_emit (self, nuvola_time_position_button_signals[NUVOLA_TIME_POSITION_BUTTON_POSITION_CHANGED_SIGNAL], 0);
	}
}


gint
nuvola_time_position_button_get_start_sec (NuvolaTimePositionButton* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_start_sec;
	result = _tmp0_;
	return result;
}


void
nuvola_time_position_button_set_start_sec (NuvolaTimePositionButton* self,
                                           gint value)
{
	g_return_if_fail (self != NULL);
	if (nuvola_time_position_button_get_start_sec (self) != value) {
		self->priv->_start_sec = value;
		g_object_notify_by_pspec ((GObject *) self, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_START_SEC_PROPERTY]);
	}
}


gint
nuvola_time_position_button_get_position_sec (NuvolaTimePositionButton* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_position_sec;
	result = _tmp0_;
	return result;
}


void
nuvola_time_position_button_set_position_sec (NuvolaTimePositionButton* self,
                                              gint value)
{
	g_return_if_fail (self != NULL);
	if (nuvola_time_position_button_get_position_sec (self) != value) {
		self->priv->_position_sec = value;
		g_object_notify_by_pspec ((GObject *) self, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC_PROPERTY]);
	}
}


gint
nuvola_time_position_button_get_end_sec (NuvolaTimePositionButton* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_end_sec;
	result = _tmp0_;
	return result;
}


void
nuvola_time_position_button_set_end_sec (NuvolaTimePositionButton* self,
                                         gint value)
{
	g_return_if_fail (self != NULL);
	if (nuvola_time_position_button_get_end_sec (self) != value) {
		self->priv->_end_sec = value;
		g_object_notify_by_pspec ((GObject *) self, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_END_SEC_PROPERTY]);
	}
}


GtkOrientation
nuvola_time_position_button_get_orientation (NuvolaTimePositionButton* self)
{
	GtkOrientation result;
	GtkOrientation _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_orientation;
	result = _tmp0_;
	return result;
}


void
nuvola_time_position_button_set_orientation (NuvolaTimePositionButton* self,
                                             GtkOrientation value)
{
	g_return_if_fail (self != NULL);
	if (nuvola_time_position_button_get_orientation (self) != value) {
		self->priv->_orientation = value;
		g_object_notify_by_pspec ((GObject *) self, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_ORIENTATION_PROPERTY]);
	}
}


static GObject *
nuvola_time_position_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NuvolaTimePositionButton * self;
	GtkOrientation _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkScale* _tmp3_;
	GtkPopover* _tmp4_;
	GtkPopover* _tmp5_;
	GtkScale* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	GtkScale* _tmp9_;
	GtkScale* _tmp10_;
	GtkScale* _tmp11_;
	GtkScale* _tmp12_;
	GtkAdjustment* _tmp13_;
	GtkAdjustment* _tmp14_;
	GtkScale* _tmp15_;
	GtkAdjustment* _tmp16_;
	GtkAdjustment* _tmp17_;
	GtkScale* _tmp18_;
	GtkAdjustment* _tmp19_;
	GtkAdjustment* _tmp20_;
	GtkScale* _tmp21_;
	parent_class = G_OBJECT_CLASS (nuvola_time_position_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	nuvola_time_position_button_update_label (self);
	_tmp0_ = self->priv->_orientation;
	_tmp1_ = self->priv->_start_sec;
	_tmp2_ = self->priv->_end_sec;
	_tmp3_ = (GtkScale*) gtk_scale_new_with_range (_tmp0_, _tmp1_ * 1.0, _tmp2_ * 1.0, 1.0);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->scale);
	self->priv->scale = _tmp3_;
	_tmp4_ = drtgtk_popover_button_get_popover ((DrtgtkPopoverButton*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->scale;
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->scale;
	gtk_widget_set_size_request ((GtkWidget*) _tmp7_, 200, -1);
	_tmp8_ = self->priv->scale;
	g_signal_connect_object (_tmp8_, "format-value", (GCallback) _nuvola_time_position_button_format_time_double_gtk_scale_format_value, self, 0);
	_tmp9_ = self->priv->scale;
	g_object_set ((GtkWidget*) _tmp9_, "margin", 20, NULL);
	_tmp10_ = self->priv->scale;
	gtk_widget_show ((GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->scale;
	g_object_bind_property_with_closures ((GObject*) self, "orientation", (GObject*) _tmp11_, "orientation", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp12_ = self->priv->scale;
	_tmp13_ = gtk_range_get_adjustment ((GtkRange*) _tmp12_);
	_tmp14_ = _tmp13_;
	g_object_bind_property_with_closures ((GObject*) self, "start-sec", (GObject*) _tmp14_, "lower", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp15_ = self->priv->scale;
	_tmp16_ = gtk_range_get_adjustment ((GtkRange*) _tmp15_);
	_tmp17_ = _tmp16_;
	g_object_bind_property_with_closures ((GObject*) self, "end-sec", (GObject*) _tmp17_, "upper", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp18_ = self->priv->scale;
	_tmp19_ = gtk_range_get_adjustment ((GtkRange*) _tmp18_);
	_tmp20_ = _tmp19_;
	g_object_bind_property_with_closures ((GObject*) self, "position-sec", (GObject*) _tmp20_, "value", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_signal_connect_object ((GObject*) self, "notify::position-sec", (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GObject*) self, "notify::end-sec", (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self, G_CONNECT_AFTER);
	_tmp21_ = self->priv->scale;
	g_signal_connect_object ((GtkRange*) _tmp21_, "value-changed", (GCallback) _nuvola_time_position_button_on_value_changed_gtk_range_value_changed, self, G_CONNECT_AFTER);
	return obj;
}


static void
nuvola_time_position_button_class_init (NuvolaTimePositionButtonClass * klass)
{
	nuvola_time_position_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaTimePositionButtonPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_time_position_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_time_position_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = nuvola_time_position_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = nuvola_time_position_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_START_SEC_PROPERTY, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_START_SEC_PROPERTY] = g_param_spec_int ("start-sec", "start-sec", "start-sec", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC_PROPERTY, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC_PROPERTY] = g_param_spec_int ("position-sec", "position-sec", "position-sec", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_END_SEC_PROPERTY, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_END_SEC_PROPERTY] = g_param_spec_int ("end-sec", "end-sec", "end-sec", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_ORIENTATION_PROPERTY, nuvola_time_position_button_properties[NUVOLA_TIME_POSITION_BUTTON_ORIENTATION_PROPERTY] = g_param_spec_enum ("orientation", "orientation", "orientation", gtk_orientation_get_type (), GTK_ORIENTATION_HORIZONTAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Emitted when position is changed as a result of user action.
	     */
	nuvola_time_position_button_signals[NUVOLA_TIME_POSITION_BUTTON_POSITION_CHANGED_SIGNAL] = g_signal_new ("position-changed", NUVOLA_TYPE_TIME_POSITION_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
nuvola_time_position_button_instance_init (NuvolaTimePositionButton * self)
{
	self->priv = NUVOLA_TIME_POSITION_BUTTON_GET_PRIVATE (self);
	self->priv->_start_sec = 0;
	self->priv->_position_sec = 0;
	self->priv->_end_sec = 1;
	self->priv->_orientation = GTK_ORIENTATION_HORIZONTAL;
}


static void
nuvola_time_position_button_finalize (GObject * obj)
{
	NuvolaTimePositionButton * self;
	GtkScale* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	GQuark _tmp3_;
	guint _tmp4_;
	GQuark _tmp5_;
	GtkScale* _tmp6_;
	guint _tmp7_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	_tmp0_ = self->priv->scale;
	g_signal_parse_name ("format-value", gtk_scale_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _nuvola_time_position_button_format_time_double_gtk_scale_format_value, self);
	g_signal_parse_name ("notify::position-sec", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self);
	g_signal_parse_name ("notify::end-sec", G_TYPE_OBJECT, &_tmp4_, &_tmp5_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, _tmp5_, NULL, (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self);
	_tmp6_ = self->priv->scale;
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkRange*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _nuvola_time_position_button_on_value_changed_gtk_range_value_changed, self);
	_g_object_unref0 (self->priv->scale);
	G_OBJECT_CLASS (nuvola_time_position_button_parent_class)->finalize (obj);
}


/**
 * Button which shows position inside a time interval and a popover with a slider
 * is shown when the button is clicked.
 */
GType
nuvola_time_position_button_get_type (void)
{
	static volatile gsize nuvola_time_position_button_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_time_position_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaTimePositionButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_time_position_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaTimePositionButton), 0, (GInstanceInitFunc) nuvola_time_position_button_instance_init, NULL };
		GType nuvola_time_position_button_type_id;
		nuvola_time_position_button_type_id = g_type_register_static (DRTGTK_TYPE_POPOVER_BUTTON, "NuvolaTimePositionButton", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_time_position_button_type_id__volatile, nuvola_time_position_button_type_id);
	}
	return nuvola_time_position_button_type_id__volatile;
}


static void
_vala_nuvola_time_position_button_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NuvolaTimePositionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	switch (property_id) {
		case NUVOLA_TIME_POSITION_BUTTON_START_SEC_PROPERTY:
		g_value_set_int (value, nuvola_time_position_button_get_start_sec (self));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC_PROPERTY:
		g_value_set_int (value, nuvola_time_position_button_get_position_sec (self));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_END_SEC_PROPERTY:
		g_value_set_int (value, nuvola_time_position_button_get_end_sec (self));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_ORIENTATION_PROPERTY:
		g_value_set_enum (value, nuvola_time_position_button_get_orientation (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_nuvola_time_position_button_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NuvolaTimePositionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	switch (property_id) {
		case NUVOLA_TIME_POSITION_BUTTON_START_SEC_PROPERTY:
		nuvola_time_position_button_set_start_sec (self, g_value_get_int (value));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC_PROPERTY:
		nuvola_time_position_button_set_position_sec (self, g_value_get_int (value));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_END_SEC_PROPERTY:
		nuvola_time_position_button_set_end_sec (self, g_value_get_int (value));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_ORIENTATION_PROPERTY:
		nuvola_time_position_button_set_orientation (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



