/* URLBar.c generated by valac 0.40.6, the Vala compiler
 * generated from URLBar.vala, do not modify */

/*
 * Copyright 2017-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <dioritegtk4.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_URL_BAR (nuvola_url_bar_get_type ())
#define NUVOLA_URL_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_URL_BAR, NuvolaURLBar))
#define NUVOLA_URL_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_URL_BAR, NuvolaURLBarClass))
#define NUVOLA_IS_URL_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_URL_BAR))
#define NUVOLA_IS_URL_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_URL_BAR))
#define NUVOLA_URL_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_URL_BAR, NuvolaURLBarClass))

typedef struct _NuvolaURLBar NuvolaURLBar;
typedef struct _NuvolaURLBarClass NuvolaURLBarClass;
typedef struct _NuvolaURLBarPrivate NuvolaURLBarPrivate;
enum  {
	NUVOLA_URL_BAR_0_PROPERTY,
	NUVOLA_URL_BAR_URL_PROPERTY,
	NUVOLA_URL_BAR_NUM_PROPERTIES
};
static GParamSpec* nuvola_url_bar_properties[NUVOLA_URL_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NUVOLA_URL_BAR_RESPONSE_SIGNAL,
	NUVOLA_URL_BAR_NUM_SIGNALS
};
static guint nuvola_url_bar_signals[NUVOLA_URL_BAR_NUM_SIGNALS] = {0};

struct _NuvolaURLBar {
	GtkGrid parent_instance;
	NuvolaURLBarPrivate * priv;
	DrtgtkEntry* entry;
};

struct _NuvolaURLBarClass {
	GtkGridClass parent_class;
};

struct _NuvolaURLBarPrivate {
	GtkButton* go_button;
	GtkButton* copy_button;
	GtkButton* close_button;
};


static gpointer nuvola_url_bar_parent_class = NULL;

GType nuvola_url_bar_get_type (void) G_GNUC_CONST;
#define NUVOLA_URL_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_URL_BAR, NuvolaURLBarPrivate))
static void nuvola_url_bar_on_go_button_clicked (NuvolaURLBar* self);
static void _nuvola_url_bar_on_go_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void _nuvola_url_bar_on_go_button_clicked_gtk_entry_activate (GtkEntry* _sender,
                                                              gpointer self);
static void nuvola_url_bar_on_close_button_clicked (NuvolaURLBar* self);
static void _nuvola_url_bar_on_close_button_clicked_drtgtk_entry_escape (DrtgtkEntry* _sender,
                                                                  gpointer self);
static void nuvola_url_bar_on_copy_button_clicked (NuvolaURLBar* self);
static void _nuvola_url_bar_on_copy_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _nuvola_url_bar_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
NuvolaURLBar* nuvola_url_bar_new (const gchar* url);
NuvolaURLBar* nuvola_url_bar_construct (GType object_type,
                                        const gchar* url);
const gchar* nuvola_url_bar_get_url (NuvolaURLBar* self);
void nuvola_url_bar_set_url (NuvolaURLBar* self,
                             const gchar* value);
static void nuvola_url_bar_finalize (GObject * obj);
static void _vala_nuvola_url_bar_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_nuvola_url_bar_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);


static void
_nuvola_url_bar_on_go_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	nuvola_url_bar_on_go_button_clicked ((NuvolaURLBar*) self);
}


static void
_nuvola_url_bar_on_go_button_clicked_gtk_entry_activate (GtkEntry* _sender,
                                                         gpointer self)
{
	nuvola_url_bar_on_go_button_clicked ((NuvolaURLBar*) self);
}


static void
_nuvola_url_bar_on_close_button_clicked_drtgtk_entry_escape (DrtgtkEntry* _sender,
                                                             gpointer self)
{
	nuvola_url_bar_on_close_button_clicked ((NuvolaURLBar*) self);
}


static void
_nuvola_url_bar_on_copy_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	nuvola_url_bar_on_copy_button_clicked ((NuvolaURLBar*) self);
}


static void
_nuvola_url_bar_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
	nuvola_url_bar_on_close_button_clicked ((NuvolaURLBar*) self);
}


NuvolaURLBar*
nuvola_url_bar_construct (GType object_type,
                          const gchar* url)
{
	NuvolaURLBar * self = NULL;
	GtkStyleContext* _tmp0_;
	DrtgtkEntry* _tmp1_;
	DrtgtkEntry* _tmp2_;
	DrtgtkEntry* _tmp3_;
	DrtgtkEntry* _tmp4_;
	DrtgtkEntry* _tmp5_;
	DrtgtkEntry* _tmp6_;
	DrtgtkEntry* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	self = (NuvolaURLBar*) g_object_new (object_type, NULL);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	gtk_widget_set_margin_end ((GtkWidget*) self, 20);
	gtk_widget_set_margin_start ((GtkWidget*) self, 20);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "linked");
	_tmp1_ = drtgtk_entry_new (url);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->entry);
	self->entry = _tmp1_;
	_tmp2_ = self->entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = self->entry;
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_FILL);
	_tmp4_ = self->entry;
	g_signal_connect_object ((GtkEntry*) _tmp4_, "activate", (GCallback) _nuvola_url_bar_on_go_button_clicked_gtk_entry_activate, self, 0);
	_tmp5_ = self->entry;
	g_signal_connect_object (_tmp5_, "escape", (GCallback) _nuvola_url_bar_on_close_button_clicked_drtgtk_entry_escape, self, 0);
	_tmp6_ = self->entry;
	gtk_widget_show ((GtkWidget*) _tmp6_);
	_tmp7_ = self->entry;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
	_tmp8_ = (GtkButton*) gtk_button_new_with_label ("Go");
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->go_button);
	self->priv->go_button = _tmp8_;
	_tmp9_ = self->priv->go_button;
	g_signal_connect_object (_tmp9_, "clicked", (GCallback) _nuvola_url_bar_on_go_button_clicked_gtk_button_clicked, self, 0);
	_tmp10_ = self->priv->go_button;
	gtk_widget_show ((GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->go_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp11_);
	_tmp12_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-copy-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->copy_button);
	self->priv->copy_button = _tmp12_;
	_tmp13_ = self->priv->copy_button;
	g_signal_connect_object (_tmp13_, "clicked", (GCallback) _nuvola_url_bar_on_copy_button_clicked_gtk_button_clicked, self, 0);
	_tmp14_ = self->priv->copy_button;
	gtk_widget_show ((GtkWidget*) _tmp14_);
	_tmp15_ = self->priv->copy_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp15_);
	_tmp16_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->close_button);
	self->priv->close_button = _tmp16_;
	_tmp17_ = self->priv->close_button;
	g_signal_connect_object (_tmp17_, "clicked", (GCallback) _nuvola_url_bar_on_close_button_clicked_gtk_button_clicked, self, 0);
	_tmp18_ = self->priv->close_button;
	gtk_widget_show ((GtkWidget*) _tmp18_);
	_tmp19_ = self->priv->close_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp19_);
	return self;
}


NuvolaURLBar*
nuvola_url_bar_new (const gchar* url)
{
	return nuvola_url_bar_construct (NUVOLA_TYPE_URL_BAR, url);
}


static void
nuvola_url_bar_on_go_button_clicked (NuvolaURLBar* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, nuvola_url_bar_signals[NUVOLA_URL_BAR_RESPONSE_SIGNAL], 0, TRUE);
}


static void
nuvola_url_bar_on_copy_button_clicked (NuvolaURLBar* self)
{
	DrtgtkEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->entry;
	drtgtk_entry_copy_to_clipboard (_tmp0_);
}


static void
nuvola_url_bar_on_close_button_clicked (NuvolaURLBar* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, nuvola_url_bar_signals[NUVOLA_URL_BAR_RESPONSE_SIGNAL], 0, FALSE);
}


const gchar*
nuvola_url_bar_get_url (NuvolaURLBar* self)
{
	const gchar* result;
	DrtgtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->entry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void
nuvola_url_bar_set_url (NuvolaURLBar* self,
                        const gchar* value)
{
	DrtgtkEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->entry;
	gtk_entry_set_text ((GtkEntry*) _tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, nuvola_url_bar_properties[NUVOLA_URL_BAR_URL_PROPERTY]);
}


static void
nuvola_url_bar_class_init (NuvolaURLBarClass * klass)
{
	nuvola_url_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaURLBarPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_url_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_url_bar_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_url_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_URL_BAR_URL_PROPERTY, nuvola_url_bar_properties[NUVOLA_URL_BAR_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	nuvola_url_bar_signals[NUVOLA_URL_BAR_RESPONSE_SIGNAL] = g_signal_new ("response", NUVOLA_TYPE_URL_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}


static void
nuvola_url_bar_instance_init (NuvolaURLBar * self)
{
	self->priv = NUVOLA_URL_BAR_GET_PRIVATE (self);
}


static void
nuvola_url_bar_finalize (GObject * obj)
{
	NuvolaURLBar * self;
	GtkButton* _tmp0_;
	guint _tmp1_;
	DrtgtkEntry* _tmp2_;
	guint _tmp3_;
	DrtgtkEntry* _tmp4_;
	guint _tmp5_;
	GtkButton* _tmp6_;
	guint _tmp7_;
	GtkButton* _tmp8_;
	guint _tmp9_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_URL_BAR, NuvolaURLBar);
	_tmp0_ = self->priv->go_button;
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _nuvola_url_bar_on_go_button_clicked_gtk_button_clicked, self);
	_tmp2_ = self->entry;
	g_signal_parse_name ("activate", gtk_entry_get_type (), &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkEntry*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _nuvola_url_bar_on_go_button_clicked_gtk_entry_activate, self);
	_tmp4_ = self->entry;
	g_signal_parse_name ("escape", DRTGTK_TYPE_ENTRY, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _nuvola_url_bar_on_close_button_clicked_drtgtk_entry_escape, self);
	_tmp6_ = self->priv->copy_button;
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _nuvola_url_bar_on_copy_button_clicked_gtk_button_clicked, self);
	_tmp8_ = self->priv->close_button;
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _nuvola_url_bar_on_close_button_clicked_gtk_button_clicked, self);
	_g_object_unref0 (self->entry);
	_g_object_unref0 (self->priv->go_button);
	_g_object_unref0 (self->priv->copy_button);
	_g_object_unref0 (self->priv->close_button);
	G_OBJECT_CLASS (nuvola_url_bar_parent_class)->finalize (obj);
}


GType
nuvola_url_bar_get_type (void)
{
	static volatile gsize nuvola_url_bar_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_url_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaURLBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_url_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaURLBar), 0, (GInstanceInitFunc) nuvola_url_bar_instance_init, NULL };
		GType nuvola_url_bar_type_id;
		nuvola_url_bar_type_id = g_type_register_static (gtk_grid_get_type (), "NuvolaURLBar", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_url_bar_type_id__volatile, nuvola_url_bar_type_id);
	}
	return nuvola_url_bar_type_id__volatile;
}


static void
_vala_nuvola_url_bar_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	NuvolaURLBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_URL_BAR, NuvolaURLBar);
	switch (property_id) {
		case NUVOLA_URL_BAR_URL_PROPERTY:
		g_value_set_string (value, nuvola_url_bar_get_url (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_nuvola_url_bar_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	NuvolaURLBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_URL_BAR, NuvolaURLBar);
	switch (property_id) {
		case NUVOLA_URL_BAR_URL_PROPERTY:
		nuvola_url_bar_set_url (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



