/* WebAppRegistry.c generated by valac 0.40.6, the Vala compiler
 * generated from WebAppRegistry.vala, do not modify */

/*
 * Copyright 2011-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_WEB_APP_REGISTRY (nuvola_web_app_registry_get_type ())
#define NUVOLA_WEB_APP_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistry))
#define NUVOLA_WEB_APP_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistryClass))
#define NUVOLA_IS_WEB_APP_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_APP_REGISTRY))
#define NUVOLA_IS_WEB_APP_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_APP_REGISTRY))
#define NUVOLA_WEB_APP_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistryClass))

typedef struct _NuvolaWebAppRegistry NuvolaWebAppRegistry;
typedef struct _NuvolaWebAppRegistryClass NuvolaWebAppRegistryClass;
typedef struct _NuvolaWebAppRegistryPrivate NuvolaWebAppRegistryPrivate;
enum  {
	NUVOLA_WEB_APP_REGISTRY_0_PROPERTY,
	NUVOLA_WEB_APP_REGISTRY_NUM_PROPERTIES
};
static GParamSpec* nuvola_web_app_registry_properties[NUVOLA_WEB_APP_REGISTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NUVOLA_TYPE_WEB_APP (nuvola_web_app_get_type ())
#define NUVOLA_WEB_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_APP, NuvolaWebApp))
#define NUVOLA_WEB_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_APP, NuvolaWebAppClass))
#define NUVOLA_IS_WEB_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_APP))
#define NUVOLA_IS_WEB_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_APP))
#define NUVOLA_WEB_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_APP, NuvolaWebAppClass))

typedef struct _NuvolaWebApp NuvolaWebApp;
typedef struct _NuvolaWebAppClass NuvolaWebAppClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NuvolaWebAppRegistry {
	GObject parent_instance;
	NuvolaWebAppRegistryPrivate * priv;
};

struct _NuvolaWebAppRegistryClass {
	GObjectClass parent_class;
};

struct _NuvolaWebAppRegistryPrivate {
	GFile* user_storage;
	GFile** system_storage;
	gint system_storage_length1;
	gint _system_storage_size_;
};

typedef enum  {
	NUVOLA_WEB_APP_ERROR_INVALID_METADATA,
	NUVOLA_WEB_APP_ERROR_LOADING_FAILED,
	NUVOLA_WEB_APP_ERROR_COMMAND_FAILED,
	NUVOLA_WEB_APP_ERROR_INVALID_FILE,
	NUVOLA_WEB_APP_ERROR_IOERROR,
	NUVOLA_WEB_APP_ERROR_NOT_ALLOWED,
	NUVOLA_WEB_APP_ERROR_SERVER_ERROR,
	NUVOLA_WEB_APP_ERROR_SERVER_ERROR_MESSAGE,
	NUVOLA_WEB_APP_ERROR_EXTRACT_ERROR
} NuvolaWebAppError;
#define NUVOLA_WEB_APP_ERROR nuvola_web_app_error_quark ()

static gpointer nuvola_web_app_registry_parent_class = NULL;

GType nuvola_web_app_registry_get_type (void) G_GNUC_CONST;
#define NUVOLA_WEB_APP_REGISTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistryPrivate))
NuvolaWebAppRegistry* nuvola_web_app_registry_new (GFile* user_storage,
                                                   GFile** system_storage,
                                                   int system_storage_length1);
NuvolaWebAppRegistry* nuvola_web_app_registry_construct (GType object_type,
                                                         GFile* user_storage,
                                                         GFile** system_storage,
                                                         int system_storage_length1);
static GFile** _vala_array_dup4 (GFile** self,
                          int length);
GType nuvola_web_app_get_type (void) G_GNUC_CONST;
NuvolaWebApp* nuvola_web_app_registry_get_app_meta (NuvolaWebAppRegistry* self,
                                                    const gchar* id);
gboolean nuvola_web_app_validate_id (const gchar* id);
GHashTable* nuvola_web_app_registry_list_web_apps (NuvolaWebAppRegistry* self,
                                                   const gchar* filter_id);
GFile* nuvola_web_app_get_data_dir (NuvolaWebApp* self);
const gchar* nuvola_web_app_get_name (NuvolaWebApp* self);
gint nuvola_web_app_get_version_major (NuvolaWebApp* self);
gint nuvola_web_app_get_version_minor (NuvolaWebApp* self);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void nuvola_web_app_registry_find_apps (NuvolaWebAppRegistry* self,
                                        GFile* directory,
                                        const gchar* filter_id,
                                        GHashTable* _result_);
GQuark nuvola_web_app_error_quark (void);
NuvolaWebApp* nuvola_web_app_new_from_dir (GFile* dir,
                                           GError** error);
NuvolaWebApp* nuvola_web_app_construct_from_dir (GType object_type,
                                                 GFile* dir,
                                                 GError** error);
const gchar* nuvola_web_app_get_id (NuvolaWebApp* self);
static void nuvola_web_app_registry_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


/**
     * Creates new web app registry
     *
     * @param user_storage        user-specific directory with service integrations
     * @param system_storage      system-wide directories with service integrations
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static GFile**
_vala_array_dup4 (GFile** self,
                  int length)
{
	GFile** result;
	int i;
	result = g_new0 (GFile*, length + 1);
	for (i = 0; i < length; i++) {
		GFile* _tmp0_;
		_tmp0_ = _g_object_ref0 (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


NuvolaWebAppRegistry*
nuvola_web_app_registry_construct (GType object_type,
                                   GFile* user_storage,
                                   GFile** system_storage,
                                   int system_storage_length1)
{
	NuvolaWebAppRegistry * self = NULL;
	GFile* _tmp0_;
	GFile** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (user_storage != NULL, NULL);
	self = (NuvolaWebAppRegistry*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (user_storage);
	_g_object_unref0 (self->priv->user_storage);
	self->priv->user_storage = _tmp0_;
	_tmp1_ = (system_storage != NULL) ? _vala_array_dup4 (system_storage, system_storage_length1) : ((gpointer) system_storage);
	_tmp1__length1 = system_storage_length1;
	self->priv->system_storage = (_vala_array_free (self->priv->system_storage, self->priv->system_storage_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->system_storage = _tmp1_;
	self->priv->system_storage_length1 = _tmp1__length1;
	self->priv->_system_storage_size_ = self->priv->system_storage_length1;
	return self;
}


NuvolaWebAppRegistry*
nuvola_web_app_registry_new (GFile* user_storage,
                             GFile** system_storage,
                             int system_storage_length1)
{
	return nuvola_web_app_registry_construct (NUVOLA_TYPE_WEB_APP_REGISTRY, user_storage, system_storage, system_storage_length1);
}


/**
     * Return web app by id.
     */
NuvolaWebApp*
nuvola_web_app_registry_get_app_meta (NuvolaWebAppRegistry* self,
                                      const gchar* id)
{
	NuvolaWebApp* result = NULL;
	GHashTable* apps = NULL;
	GHashTable* _tmp0_;
	NuvolaWebApp* app = NULL;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	NuvolaWebApp* _tmp3_;
	NuvolaWebApp* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	if (!nuvola_web_app_validate_id (id)) {
		g_warning ("WebAppRegistry.vala:50: Service id '%s' is invalid.", id);
		result = NULL;
		return result;
	}
	_tmp0_ = nuvola_web_app_registry_list_web_apps (self, id);
	apps = _tmp0_;
	_tmp1_ = apps;
	_tmp2_ = g_hash_table_lookup (_tmp1_, id);
	_tmp3_ = _g_object_ref0 ((NuvolaWebApp*) _tmp2_);
	app = _tmp3_;
	_tmp4_ = app;
	if (_tmp4_ != NULL) {
		gchar* _tmp5_ = NULL;
		NuvolaWebApp* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		NuvolaWebApp* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		NuvolaWebApp* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		NuvolaWebApp* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		_tmp6_ = app;
		_tmp7_ = nuvola_web_app_get_data_dir (_tmp6_);
		_tmp8_ = _tmp7_;
		if (_tmp8_ == NULL) {
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("(null)");
			_g_free0 (_tmp5_);
			_tmp5_ = _tmp9_;
		} else {
			NuvolaWebApp* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			gchar* _tmp13_;
			_tmp10_ = app;
			_tmp11_ = nuvola_web_app_get_data_dir (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_file_get_path (_tmp12_);
			_g_free0 (_tmp5_);
			_tmp5_ = _tmp13_;
		}
		_tmp14_ = app;
		_tmp15_ = nuvola_web_app_get_name (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = app;
		_tmp18_ = nuvola_web_app_get_version_major (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = app;
		_tmp21_ = nuvola_web_app_get_version_minor (_tmp20_);
		_tmp22_ = _tmp21_;
		g_message ("WebAppRegistry.vala:57: Using web app %s, version %u.%u, data dir %s", _tmp16_, (guint) _tmp19_, (guint) _tmp22_, _tmp5_);
		_g_free0 (_tmp5_);
	} else {
		g_message ("WebAppRegistry.vala:60: Web App %s not found.", id);
	}
	result = app;
	_g_hash_table_unref0 (apps);
	return result;
}


/**
     * Lists available web apps
     *
     * @param filter_id    if not null, filter apps by id
     * @return hash table of web app id - metadata pairs
     */
static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


GHashTable*
nuvola_web_app_registry_list_web_apps (NuvolaWebAppRegistry* self,
                                       const gchar* filter_id)
{
	GHashTable* result = NULL;
	GHashTable* _result_ = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GFile* _tmp3_;
	GHashTable* _tmp4_;
	GFile** _tmp5_;
	gint _tmp5__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
	_result_ = _tmp2_;
	_tmp3_ = self->priv->user_storage;
	_tmp4_ = _result_;
	nuvola_web_app_registry_find_apps (self, _tmp3_, filter_id, _tmp4_);
	_tmp5_ = self->priv->system_storage;
	_tmp5__length1 = self->priv->system_storage_length1;
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp5_;
		dir_collection_length1 = _tmp5__length1;
		for (dir_it = 0; dir_it < _tmp5__length1; dir_it = dir_it + 1) {
			GFile* _tmp6_;
			GFile* dir = NULL;
			_tmp6_ = _g_object_ref0 (dir_collection[dir_it]);
			dir = _tmp6_;
			{
				GFile* _tmp7_;
				GHashTable* _tmp8_;
				_tmp7_ = dir;
				_tmp8_ = _result_;
				nuvola_web_app_registry_find_apps (self, _tmp7_, filter_id, _tmp8_);
				_g_object_unref0 (dir);
			}
		}
	}
	result = _result_;
	return result;
}


static void
nuvola_web_app_registry_find_apps (NuvolaWebAppRegistry* self,
                                   GFile* directory,
                                   const gchar* filter_id,
                                   GHashTable* _result_)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (directory != NULL);
	g_return_if_fail (_result_ != NULL);
	if (g_file_query_exists (directory, NULL)) {
		{
			GFileInfo* file_info = NULL;
			GFileEnumerator* enumerator = NULL;
			GFileEnumerator* _tmp0_;
			_tmp0_ = g_file_enumerate_children (directory, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
			enumerator = _tmp0_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (file_info);
				goto __catch64_g_error;
			}
			while (TRUE) {
				GFileInfo* _tmp1_ = NULL;
				GFileEnumerator* _tmp2_;
				GFileInfo* _tmp3_;
				GFileInfo* _tmp4_;
				GFileInfo* _tmp5_;
				gchar* dirname = NULL;
				GFileInfo* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				GFile* app_dir = NULL;
				const gchar* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				_tmp2_ = enumerator;
				_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error_);
				_tmp1_ = _tmp3_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (enumerator);
					_g_object_unref0 (file_info);
					goto __catch64_g_error;
				}
				_tmp4_ = _tmp1_;
				_tmp1_ = NULL;
				_g_object_unref0 (file_info);
				file_info = _tmp4_;
				_tmp5_ = file_info;
				if (!(_tmp5_ != NULL)) {
					_g_object_unref0 (_tmp1_);
					break;
				}
				_tmp6_ = file_info;
				_tmp7_ = g_file_info_get_name (_tmp6_);
				_tmp8_ = g_strdup (_tmp7_);
				dirname = _tmp8_;
				_tmp9_ = dirname;
				_tmp10_ = g_file_get_child (directory, _tmp9_);
				app_dir = _tmp10_;
				_tmp11_ = app_dir;
				if (g_file_query_file_type (_tmp11_, 0, NULL) != G_FILE_TYPE_DIRECTORY) {
					_g_object_unref0 (app_dir);
					_g_free0 (dirname);
					_g_object_unref0 (_tmp1_);
					continue;
				}
				{
					NuvolaWebApp* app = NULL;
					GFile* _tmp12_;
					NuvolaWebApp* _tmp13_;
					gchar* id = NULL;
					NuvolaWebApp* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					NuvolaWebApp* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					GFile* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					NuvolaWebApp* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					NuvolaWebApp* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gboolean _tmp30_ = FALSE;
					_tmp12_ = app_dir;
					_tmp13_ = nuvola_web_app_new_from_dir (_tmp12_, &_inner_error_);
					app = _tmp13_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_WEB_APP_ERROR) {
							goto __catch65_nuvola_web_app_error;
						}
						_g_object_unref0 (app_dir);
						_g_free0 (dirname);
						_g_object_unref0 (_tmp1_);
						_g_object_unref0 (enumerator);
						_g_object_unref0 (file_info);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					_tmp14_ = app;
					_tmp15_ = nuvola_web_app_get_id (_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp17_ = g_strdup (_tmp16_);
					id = _tmp17_;
					_tmp18_ = app;
					_tmp19_ = nuvola_web_app_get_name (_tmp18_);
					_tmp20_ = _tmp19_;
					_tmp21_ = app_dir;
					_tmp22_ = g_file_get_path (_tmp21_);
					_tmp23_ = _tmp22_;
					_tmp24_ = app;
					_tmp25_ = nuvola_web_app_get_version_major (_tmp24_);
					_tmp26_ = _tmp25_;
					_tmp27_ = app;
					_tmp28_ = nuvola_web_app_get_version_minor (_tmp27_);
					_tmp29_ = _tmp28_;
					g_debug ("WebAppRegistry.vala:96: Found web app %s at %s, version %u.%u", _tmp20_, _tmp23_, (guint) _tmp26_, (guint) _tmp29_);
					_g_free0 (_tmp23_);
					if (filter_id == NULL) {
						_tmp30_ = TRUE;
					} else {
						const gchar* _tmp31_;
						_tmp31_ = id;
						_tmp30_ = g_strcmp0 (filter_id, _tmp31_) == 0;
					}
					if (_tmp30_) {
						NuvolaWebApp* prev_app = NULL;
						const gchar* _tmp32_;
						gconstpointer _tmp33_;
						gboolean _tmp34_ = FALSE;
						gboolean _tmp35_ = FALSE;
						NuvolaWebApp* _tmp36_;
						_tmp32_ = id;
						_tmp33_ = g_hash_table_lookup (_result_, _tmp32_);
						prev_app = (NuvolaWebApp*) _tmp33_;
						_tmp36_ = prev_app;
						if (_tmp36_ == NULL) {
							_tmp35_ = TRUE;
						} else {
							NuvolaWebApp* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							NuvolaWebApp* _tmp40_;
							gint _tmp41_;
							gint _tmp42_;
							_tmp37_ = app;
							_tmp38_ = nuvola_web_app_get_version_major (_tmp37_);
							_tmp39_ = _tmp38_;
							_tmp40_ = prev_app;
							_tmp41_ = nuvola_web_app_get_version_major (_tmp40_);
							_tmp42_ = _tmp41_;
							_tmp35_ = _tmp39_ > _tmp42_;
						}
						if (_tmp35_) {
							_tmp34_ = TRUE;
						} else {
							gboolean _tmp43_ = FALSE;
							NuvolaWebApp* _tmp44_;
							gint _tmp45_;
							gint _tmp46_;
							NuvolaWebApp* _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							_tmp44_ = app;
							_tmp45_ = nuvola_web_app_get_version_major (_tmp44_);
							_tmp46_ = _tmp45_;
							_tmp47_ = prev_app;
							_tmp48_ = nuvola_web_app_get_version_major (_tmp47_);
							_tmp49_ = _tmp48_;
							if (_tmp46_ == _tmp49_) {
								NuvolaWebApp* _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								NuvolaWebApp* _tmp53_;
								gint _tmp54_;
								gint _tmp55_;
								_tmp50_ = app;
								_tmp51_ = nuvola_web_app_get_version_minor (_tmp50_);
								_tmp52_ = _tmp51_;
								_tmp53_ = prev_app;
								_tmp54_ = nuvola_web_app_get_version_minor (_tmp53_);
								_tmp55_ = _tmp54_;
								_tmp43_ = _tmp52_ > _tmp55_;
							} else {
								_tmp43_ = FALSE;
							}
							_tmp34_ = _tmp43_;
						}
						if (_tmp34_) {
							const gchar* _tmp56_;
							gchar* _tmp57_;
							NuvolaWebApp* _tmp58_;
							NuvolaWebApp* _tmp59_;
							_tmp56_ = id;
							_tmp57_ = g_strdup (_tmp56_);
							_tmp58_ = app;
							_tmp59_ = _g_object_ref0 (_tmp58_);
							g_hash_table_insert (_result_, _tmp57_, _tmp59_);
						}
					}
					_g_free0 (id);
					_g_object_unref0 (app);
				}
				goto __finally65;
				__catch65_nuvola_web_app_error:
				{
					GError* e = NULL;
					GFile* _tmp60_;
					gchar* _tmp61_;
					gchar* _tmp62_;
					GError* _tmp63_;
					const gchar* _tmp64_;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp60_ = app_dir;
					_tmp61_ = g_file_get_path (_tmp60_);
					_tmp62_ = _tmp61_;
					_tmp63_ = e;
					_tmp64_ = _tmp63_->message;
					g_warning ("WebAppRegistry.vala:112: Unable to load app from %s: %s", _tmp62_, _tmp64_);
					_g_free0 (_tmp62_);
					_g_error_free0 (e);
				}
				__finally65:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (app_dir);
					_g_free0 (dirname);
					_g_object_unref0 (_tmp1_);
					_g_object_unref0 (enumerator);
					_g_object_unref0 (file_info);
					goto __catch64_g_error;
				}
				_g_object_unref0 (app_dir);
				_g_free0 (dirname);
				_g_object_unref0 (_tmp1_);
			}
			_g_object_unref0 (enumerator);
			_g_object_unref0 (file_info);
		}
		goto __finally64;
		__catch64_g_error:
		{
			GError* e = NULL;
			GError* _tmp65_;
			const gchar* _tmp66_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp65_ = e;
			_tmp66_ = _tmp65_->message;
			g_warning ("WebAppRegistry.vala:117: Filesystem error: %s", _tmp66_);
			_g_error_free0 (e);
		}
		__finally64:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void
nuvola_web_app_registry_class_init (NuvolaWebAppRegistryClass * klass)
{
	nuvola_web_app_registry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaWebAppRegistryPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_web_app_registry_finalize;
}


static void
nuvola_web_app_registry_instance_init (NuvolaWebAppRegistry * self)
{
	self->priv = NUVOLA_WEB_APP_REGISTRY_GET_PRIVATE (self);
}


static void
nuvola_web_app_registry_finalize (GObject * obj)
{
	NuvolaWebAppRegistry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistry);
	_g_object_unref0 (self->priv->user_storage);
	self->priv->system_storage = (_vala_array_free (self->priv->system_storage, self->priv->system_storage_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (nuvola_web_app_registry_parent_class)->finalize (obj);
}


/**
 *  WebAppRegistry deals with management and loading of web apps from filesystem.
 */
GType
nuvola_web_app_registry_get_type (void)
{
	static volatile gsize nuvola_web_app_registry_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_web_app_registry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaWebAppRegistryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_web_app_registry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaWebAppRegistry), 0, (GInstanceInitFunc) nuvola_web_app_registry_instance_init, NULL };
		GType nuvola_web_app_registry_type_id;
		nuvola_web_app_registry_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaWebAppRegistry", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_web_app_registry_type_id__volatile, nuvola_web_app_registry_type_id);
	}
	return nuvola_web_app_registry_type_id__volatile;
}


GQuark
nuvola_web_app_error_quark (void)
{
	return g_quark_from_static_string ("nuvola_web_app_error-quark");
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



