/* WelcomeScreen.c generated by valac 0.40.6, the Vala compiler
 * generated from WelcomeScreen.vala, do not modify */

/*
 * Copyright 2015-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <dioritegtk4.h>
#include <webkit2/webkit2.h>
#include <stdlib.h>
#include <string.h>
#include <dioriteglib4.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define NUVOLA_TYPE_WELCOME_SCREEN (nuvola_welcome_screen_get_type ())
#define NUVOLA_WELCOME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreen))
#define NUVOLA_WELCOME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreenClass))
#define NUVOLA_IS_WELCOME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WELCOME_SCREEN))
#define NUVOLA_IS_WELCOME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WELCOME_SCREEN))
#define NUVOLA_WELCOME_SCREEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreenClass))

typedef struct _NuvolaWelcomeScreen NuvolaWelcomeScreen;
typedef struct _NuvolaWelcomeScreenClass NuvolaWelcomeScreenClass;
typedef struct _NuvolaWelcomeScreenPrivate NuvolaWelcomeScreenPrivate;

#define NUVOLA_TYPE_WEB_VIEW (nuvola_web_view_get_type ())
#define NUVOLA_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebView))
#define NUVOLA_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))
#define NUVOLA_IS_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_IS_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))

typedef struct _NuvolaWebView NuvolaWebView;
typedef struct _NuvolaWebViewClass NuvolaWebViewClass;
enum  {
	NUVOLA_WELCOME_SCREEN_0_PROPERTY,
	NUVOLA_WELCOME_SCREEN_NUM_PROPERTIES
};
static GParamSpec* nuvola_welcome_screen_properties[NUVOLA_WELCOME_SCREEN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _webkit_javascript_result_unref0(var) ((var == NULL) ? NULL : (var = (webkit_javascript_result_unref (var), NULL)))

struct _NuvolaWelcomeScreen {
	GtkGrid parent_instance;
	NuvolaWelcomeScreenPrivate * priv;
};

struct _NuvolaWelcomeScreenClass {
	GtkGridClass parent_class;
};

struct _NuvolaWelcomeScreenPrivate {
	GtkGrid* grid;
	DrtgtkApplication* app;
	NuvolaWebView* web_view;
	DrtgtkRichTextView* welcome_text;
	GtkScrolledWindow* scroll;
};


static gpointer nuvola_welcome_screen_parent_class = NULL;

GType nuvola_welcome_screen_get_type (void) G_GNUC_CONST;
GType nuvola_web_view_get_type (void) G_GNUC_CONST;
#define NUVOLA_WELCOME_SCREEN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreenPrivate))
#define NUVOLA_WELCOME_SCREEN_PATRONS_BOX_URI "https://tiliado.eu/nuvolaplayer/funding/patrons_list_box/"
NuvolaWelcomeScreen* nuvola_welcome_screen_new (DrtgtkApplication* app,
                                                DrtStorage* storage,
                                                WebKitWebContext* web_context);
NuvolaWelcomeScreen* nuvola_welcome_screen_construct (GType object_type,
                                                      DrtgtkApplication* app,
                                                      DrtStorage* storage,
                                                      WebKitWebContext* web_context);
static void nuvola_welcome_screen_show_uri (NuvolaWelcomeScreen* self,
                                     const gchar* uri);
static void _nuvola_welcome_screen_show_uri_drtgtk_uri_opener (const gchar* uri,
                                                        gpointer self);
static gboolean nuvola_welcome_screen_on_motion_notify (NuvolaWelcomeScreen* self,
                                                 GtkWidget* widget,
                                                 GdkEventMotion* event);
static gboolean _nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                 GdkEventMotion* event,
                                                                                 gpointer self);
NuvolaWebView* nuvola_web_view_new (WebKitWebContext* context);
NuvolaWebView* nuvola_web_view_construct (GType object_type,
                                          WebKitWebContext* context);
static gboolean nuvola_welcome_screen_on_scroll_event (NuvolaWelcomeScreen* self,
                                                GdkEventScroll* event);
static gboolean _nuvola_welcome_screen_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                         GdkEventScroll* event,
                                                                         gpointer self);
static void nuvola_welcome_screen_on_load_changed (NuvolaWelcomeScreen* self,
                                            WebKitWebView* view,
                                            WebKitLoadEvent event);
static void _nuvola_welcome_screen_on_load_changed_webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                          WebKitLoadEvent load_event,
                                                                          gpointer self);
static gboolean nuvola_welcome_screen_on_decide_policy (NuvolaWelcomeScreen* self,
                                                 WebKitPolicyDecision* decision,
                                                 WebKitPolicyDecisionType decision_type);
static gboolean _nuvola_welcome_screen_on_decide_policy_webkit_web_view_decide_policy (WebKitWebView* _sender,
                                                                                WebKitPolicyDecision* decision,
                                                                                WebKitPolicyDecisionType type,
                                                                                gpointer self);
static gboolean nuvola_welcome_screen_set_web_view_height (NuvolaWelcomeScreen* self);
static void nuvola_welcome_screen_on_height_retrieved (NuvolaWelcomeScreen* self,
                                                GObject* o,
                                                GAsyncResult* _result_);
static void _nuvola_welcome_screen_on_height_retrieved_gasync_ready_callback (GObject* source_object,
                                                                       GAsyncResult* res,
                                                                       gpointer self);
static gboolean nuvola_welcome_screen_decide_navigation_policy (NuvolaWelcomeScreen* self,
                                                         gboolean new_window,
                                                         WebKitNavigationPolicyDecision* decision);
static void nuvola_welcome_screen_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_nuvola_welcome_screen_show_uri_drtgtk_uri_opener (const gchar* uri,
                                                   gpointer self)
{
	nuvola_welcome_screen_show_uri ((NuvolaWelcomeScreen*) self, uri);
}


static gboolean
_nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                        GdkEventMotion* event,
                                                                        gpointer self)
{
	gboolean result;
	result = nuvola_welcome_screen_on_motion_notify ((NuvolaWelcomeScreen*) self, _sender, event);
	return result;
}


static gboolean
_nuvola_welcome_screen_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                GdkEventScroll* event,
                                                                gpointer self)
{
	gboolean result;
	result = nuvola_welcome_screen_on_scroll_event ((NuvolaWelcomeScreen*) self, event);
	return result;
}


static void
_nuvola_welcome_screen_on_load_changed_webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                     WebKitLoadEvent load_event,
                                                                     gpointer self)
{
	nuvola_welcome_screen_on_load_changed ((NuvolaWelcomeScreen*) self, _sender, load_event);
}


static gboolean
_nuvola_welcome_screen_on_decide_policy_webkit_web_view_decide_policy (WebKitWebView* _sender,
                                                                       WebKitPolicyDecision* decision,
                                                                       WebKitPolicyDecisionType type,
                                                                       gpointer self)
{
	gboolean result;
	result = nuvola_welcome_screen_on_decide_policy ((NuvolaWelcomeScreen*) self, decision, type);
	return result;
}


NuvolaWelcomeScreen*
nuvola_welcome_screen_construct (GType object_type,
                                 DrtgtkApplication* app,
                                 DrtStorage* storage,
                                 WebKitWebContext* web_context)
{
	NuvolaWelcomeScreen * self = NULL;
	DrtgtkApplication* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GdkRGBA _tmp3_ = {0};
	GtkGrid* _tmp4_;
	gchar* welcome_xml = NULL;
	GFile* welcome_xml_file = NULL;
	GFile* _tmp5_;
	DrtgtkRichTextBuffer* buffer = NULL;
	DrtgtkRichTextBuffer* _tmp12_;
	DrtgtkRichTextView* _tmp17_;
	DrtgtkRichTextView* _tmp18_;
	DrtgtkRichTextView* _tmp19_;
	DrtgtkRichTextView* _tmp20_;
	DrtgtkRichTextView* _tmp21_;
	DrtgtkRichTextView* _tmp22_;
	GtkGrid* _tmp23_;
	DrtgtkRichTextView* _tmp24_;
	NuvolaWebView* _tmp25_;
	NuvolaWebView* _tmp26_;
	NuvolaWebView* _tmp27_;
	NuvolaWebView* _tmp28_;
	NuvolaWebView* _tmp29_;
	NuvolaWebView* _tmp30_;
	NuvolaWebView* _tmp31_;
	NuvolaWebView* _tmp32_;
	NuvolaWebView* _tmp33_;
	NuvolaWebView* _tmp34_;
	NuvolaWebView* _tmp35_;
	GtkGrid* _tmp36_;
	NuvolaWebView* _tmp37_;
	GtkScrolledWindow* _tmp38_;
	GtkScrolledWindow* _tmp39_;
	GtkGrid* _tmp40_;
	GtkScrolledWindow* _tmp41_;
	GtkScrolledWindow* _tmp42_;
	GtkScrolledWindow* _tmp43_;
	GtkScrolledWindow* _tmp44_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	g_return_val_if_fail (storage != NULL, NULL);
	g_return_val_if_fail (web_context != NULL, NULL);
	self = (NuvolaWelcomeScreen*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (app);
	_g_object_unref0 (self->priv->app);
	self->priv->app = _tmp0_;
	_tmp1_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp1_;
	_tmp2_ = self->priv->grid;
	_tmp3_.red = 1.0;
	_tmp3_.green = 1.0;
	_tmp3_.blue = 1.0;
	_tmp3_.alpha = 1.0;
	gtk_widget_override_background_color ((GtkWidget*) _tmp2_, GTK_STATE_FLAG_NORMAL, &_tmp3_);
	_tmp4_ = self->priv->grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp4_, GTK_ORIENTATION_VERTICAL);
	welcome_xml = NULL;
	_tmp5_ = drt_storage_require_data_file (storage, "welcome.xml");
	welcome_xml_file = _tmp5_;
	{
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp7_ = drt_system_read_file (welcome_xml_file, &_inner_error_);
		_tmp6_ = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch73_g_error;
		}
		_tmp8_ = _tmp6_;
		_tmp6_ = NULL;
		_g_free0 (welcome_xml);
		welcome_xml = _tmp8_;
		_g_free0 (_tmp6_);
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError* e = NULL;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = g_file_get_path (welcome_xml_file);
		_tmp10_ = _tmp9_;
		_tmp11_ = e->message;
		g_error ("WelcomeScreen.vala:48: Failed to load '%s': %s", _tmp10_, _tmp11_);
		_g_free0 (_tmp10_);
		_g_error_free0 (e);
	}
	__finally73:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (welcome_xml_file);
		_g_free0 (welcome_xml);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp12_ = drtgtk_rich_text_buffer_new ();
	buffer = _tmp12_;
	{
		const gchar* _tmp13_;
		_tmp13_ = welcome_xml;
		drtgtk_rich_text_buffer_load (buffer, _tmp13_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_MARKUP_ERROR) {
				goto __catch74_g_markup_error;
			}
			_g_object_unref0 (buffer);
			_g_object_unref0 (welcome_xml_file);
			_g_free0 (welcome_xml);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally74;
	__catch74_g_markup_error:
	{
		GError* e = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp14_ = g_file_get_path (welcome_xml_file);
		_tmp15_ = _tmp14_;
		_tmp16_ = e->message;
		g_error ("WelcomeScreen.vala:56: Markup Error in '%s': %s", _tmp15_, _tmp16_);
		_g_free0 (_tmp15_);
		_g_error_free0 (e);
	}
	__finally74:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (buffer);
		_g_object_unref0 (welcome_xml_file);
		_g_free0 (welcome_xml);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp17_ = drtgtk_rich_text_view_new (buffer);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->welcome_text);
	self->priv->welcome_text = _tmp17_;
	_tmp18_ = self->priv->welcome_text;
	drtgtk_rich_text_view_set_link_opener (_tmp18_, _nuvola_welcome_screen_show_uri_drtgtk_uri_opener, g_object_ref (self), g_object_unref);
	_tmp19_ = self->priv->welcome_text;
	g_object_set ((GtkWidget*) _tmp19_, "margin", 18, NULL);
	_tmp20_ = self->priv->welcome_text;
	_tmp21_ = self->priv->welcome_text;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp20_, TRUE);
	_tmp22_ = self->priv->welcome_text;
	g_signal_connect_object ((GtkWidget*) _tmp22_, "motion-notify-event", (GCallback) _nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event, self, 0);
	_tmp23_ = self->priv->grid;
	_tmp24_ = self->priv->welcome_text;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 0, 0, 1, 1);
	_tmp25_ = nuvola_web_view_new (web_context);
	g_object_ref_sink (_tmp25_);
	_g_object_unref0 (self->priv->web_view);
	self->priv->web_view = _tmp25_;
	_tmp26_ = self->priv->web_view;
	gtk_widget_add_events ((GtkWidget*) _tmp26_, (gint) GDK_SCROLL_MASK);
	_tmp27_ = self->priv->web_view;
	g_signal_connect_object ((GtkWidget*) _tmp27_, "motion-notify-event", (GCallback) _nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event, self, 0);
	_tmp28_ = self->priv->web_view;
	g_signal_connect_object ((GtkWidget*) _tmp28_, "scroll-event", (GCallback) _nuvola_welcome_screen_on_scroll_event_gtk_widget_scroll_event, self, 0);
	_tmp29_ = self->priv->web_view;
	g_signal_connect_object ((WebKitWebView*) _tmp29_, "load-changed", (GCallback) _nuvola_welcome_screen_on_load_changed_webkit_web_view_load_changed, self, 0);
	_tmp30_ = self->priv->web_view;
	webkit_web_view_load_uri ((WebKitWebView*) _tmp30_, NUVOLA_WELCOME_SCREEN_PATRONS_BOX_URI);
	_tmp31_ = self->priv->web_view;
	g_object_set ((GtkWidget*) _tmp31_, "margin", 18, NULL);
	_tmp32_ = self->priv->web_view;
	g_signal_connect_object ((WebKitWebView*) _tmp32_, "decide-policy", (GCallback) _nuvola_welcome_screen_on_decide_policy_webkit_web_view_decide_policy, self, 0);
	_tmp33_ = self->priv->web_view;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp33_, FALSE);
	_tmp34_ = self->priv->web_view;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp34_, TRUE);
	_tmp35_ = self->priv->web_view;
	gtk_widget_set_size_request ((GtkWidget*) _tmp35_, 275, -1);
	_tmp36_ = self->priv->grid;
	_tmp37_ = self->priv->web_view;
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, 1, 0, 1, 1);
	_tmp38_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->priv->scroll);
	self->priv->scroll = _tmp38_;
	_tmp39_ = self->priv->scroll;
	_tmp40_ = self->priv->grid;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
	_tmp41_ = self->priv->scroll;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp41_, TRUE);
	_tmp42_ = self->priv->scroll;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp42_, TRUE);
	_tmp43_ = self->priv->scroll;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp43_);
	_tmp44_ = self->priv->scroll;
	gtk_widget_show_all ((GtkWidget*) _tmp44_);
	_g_object_unref0 (buffer);
	_g_object_unref0 (welcome_xml_file);
	_g_free0 (welcome_xml);
	return self;
}


NuvolaWelcomeScreen*
nuvola_welcome_screen_new (DrtgtkApplication* app,
                           DrtStorage* storage,
                           WebKitWebContext* web_context)
{
	return nuvola_welcome_screen_construct (NUVOLA_TYPE_WELCOME_SCREEN, app, storage, web_context);
}


static gboolean
nuvola_welcome_screen_on_scroll_event (NuvolaWelcomeScreen* self,
                                       GdkEventScroll* event)
{
	gboolean result = FALSE;
	GtkScrolledWindow* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->scroll;
	g_signal_emit_by_name ((GtkWidget*) _tmp0_, "scroll-event", event, &_tmp1_);
	result = TRUE;
	return result;
}


static gboolean
nuvola_welcome_screen_on_motion_notify (NuvolaWelcomeScreen* self,
                                        GtkWidget* widget,
                                        GdkEventMotion* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	g_object_get (widget, "has-focus", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		GtkAdjustment* adjustment = NULL;
		GtkScrolledWindow* _tmp2_;
		GtkAdjustment* _tmp3_;
		GtkAdjustment* _tmp4_;
		gdouble position = 0.0;
		GtkAdjustment* _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
		GtkAdjustment* _tmp8_;
		gdouble _tmp9_;
		_tmp2_ = self->priv->scroll;
		_tmp3_ = gtk_scrolled_window_get_vadjustment (_tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		adjustment = _tmp4_;
		_tmp5_ = adjustment;
		_tmp6_ = gtk_adjustment_get_value (_tmp5_);
		_tmp7_ = _tmp6_;
		position = _tmp7_;
		gtk_widget_grab_focus (widget);
		_tmp8_ = adjustment;
		_tmp9_ = position;
		gtk_adjustment_set_value (_tmp8_, _tmp9_);
		_g_object_unref0 (adjustment);
	}
	result = FALSE;
	return result;
}


static void
nuvola_welcome_screen_on_load_changed (NuvolaWelcomeScreen* self,
                                       WebKitWebView* view,
                                       WebKitLoadEvent event)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	if (event == WEBKIT_LOAD_FINISHED) {
		nuvola_welcome_screen_set_web_view_height (self);
	}
}


static void
_nuvola_welcome_screen_on_height_retrieved_gasync_ready_callback (GObject* source_object,
                                                                  GAsyncResult* res,
                                                                  gpointer self)
{
	nuvola_welcome_screen_on_height_retrieved ((NuvolaWelcomeScreen*) self, source_object, res);
	g_object_unref (self);
}


static gboolean
nuvola_welcome_screen_set_web_view_height (NuvolaWelcomeScreen* self)
{
	gboolean result = FALSE;
	NuvolaWebView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->web_view;
	webkit_web_view_run_javascript ((WebKitWebView*) _tmp0_, "\n" \
"            var bodyElm = document.body, htmlElm = document.documentEl" \
"ement;\n" \
"            document.title = Math.max(\n" \
"            bodyElm.scrollHeight, bodyElm.offsetHeight,\n" \
"            htmlElm.clientHeight, htmlElm.scrollHeight, htmlElm.offset" \
"Height);\n" \
"            ", NULL, _nuvola_welcome_screen_on_height_retrieved_gasync_ready_callback, g_object_ref (self));
	result = TRUE;
	return result;
}


static void
nuvola_welcome_screen_on_height_retrieved (NuvolaWelcomeScreen* self,
                                           GObject* o,
                                           GAsyncResult* _result_)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_result_ != NULL);
	{
		NuvolaWebView* _tmp0_;
		WebKitJavascriptResult* _tmp1_;
		WebKitJavascriptResult* _tmp2_;
		gint page_height = 0;
		NuvolaWebView* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gint width = 0;
		gint height = 0;
		NuvolaWebView* _tmp6_;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
		gint _tmp10_;
		gint _tmp11_;
		_tmp0_ = self->priv->web_view;
		_tmp1_ = webkit_web_view_run_javascript_finish ((WebKitWebView*) _tmp0_, _result_, &_inner_error_);
		_tmp2_ = _tmp1_;
		_webkit_javascript_result_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch75_g_error;
		}
		_tmp3_ = self->priv->web_view;
		_tmp4_ = webkit_web_view_get_title ((WebKitWebView*) _tmp3_);
		_tmp5_ = _tmp4_;
		page_height = atoi (_tmp5_);
		_tmp6_ = self->priv->web_view;
		gtk_widget_get_size_request ((GtkWidget*) _tmp6_, &_tmp7_, &_tmp8_);
		width = _tmp7_;
		height = _tmp8_;
		_tmp10_ = height;
		_tmp11_ = page_height;
		if (_tmp10_ < _tmp11_) {
			gint _tmp12_;
			_tmp12_ = page_height;
			_tmp9_ = _tmp12_ > 100;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			NuvolaWebView* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			_tmp13_ = self->priv->web_view;
			_tmp14_ = width;
			_tmp15_ = page_height;
			gtk_widget_set_size_request ((GtkWidget*) _tmp13_, _tmp14_, _tmp15_);
		}
	}
	goto __finally75;
	__catch75_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		g_debug ("WelcomeScreen.vala:139: JavaScript error: %s", _tmp17_);
		_g_error_free0 (e);
	}
	__finally75:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void
nuvola_welcome_screen_show_uri (NuvolaWelcomeScreen* self,
                                const gchar* uri)
{
	DrtgtkApplication* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri != NULL);
	_tmp0_ = self->priv->app;
	drtgtk_application_show_uri (_tmp0_, uri, (guint32) GDK_CURRENT_TIME);
}


static gboolean
nuvola_welcome_screen_decide_navigation_policy (NuvolaWelcomeScreen* self,
                                                gboolean new_window,
                                                WebKitNavigationPolicyDecision* decision)
{
	gboolean result = FALSE;
	gchar* uri = NULL;
	WebKitNavigationAction* _tmp0_;
	WebKitNavigationAction* _tmp1_;
	WebKitURIRequest* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	const gchar* _tmp11_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (decision != NULL, FALSE);
	_tmp0_ = webkit_navigation_policy_decision_get_navigation_action (decision);
	_tmp1_ = _tmp0_;
	_tmp2_ = webkit_navigation_action_get_request (_tmp1_);
	_tmp3_ = webkit_uri_request_get_uri (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup (_tmp4_);
	uri = _tmp5_;
	_tmp8_ = uri;
	if (!g_str_has_prefix (_tmp8_, "http://")) {
		const gchar* _tmp9_;
		_tmp9_ = uri;
		_tmp7_ = !g_str_has_prefix (_tmp9_, "https://");
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		const gchar* _tmp10_;
		_tmp10_ = uri;
		_tmp6_ = g_strcmp0 (_tmp10_, NUVOLA_WELCOME_SCREEN_PATRONS_BOX_URI) == 0;
	}
	if (_tmp6_) {
		result = FALSE;
		_g_free0 (uri);
		return result;
	}
	_tmp11_ = uri;
	nuvola_welcome_screen_show_uri (self, _tmp11_);
	webkit_policy_decision_ignore ((WebKitPolicyDecision*) decision);
	result = TRUE;
	_g_free0 (uri);
	return result;
}


static gboolean
nuvola_welcome_screen_on_decide_policy (NuvolaWelcomeScreen* self,
                                        WebKitPolicyDecision* decision,
                                        WebKitPolicyDecisionType decision_type)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (decision != NULL, FALSE);
	switch (decision_type) {
		case WEBKIT_POLICY_DECISION_TYPE_NAVIGATION_ACTION:
		{
			result = nuvola_welcome_screen_decide_navigation_policy (self, FALSE, G_TYPE_CHECK_INSTANCE_CAST (decision, webkit_navigation_policy_decision_get_type (), WebKitNavigationPolicyDecision));
			return result;
		}
		case WEBKIT_POLICY_DECISION_TYPE_NEW_WINDOW_ACTION:
		{
			result = nuvola_welcome_screen_decide_navigation_policy (self, TRUE, G_TYPE_CHECK_INSTANCE_CAST (decision, webkit_navigation_policy_decision_get_type (), WebKitNavigationPolicyDecision));
			return result;
		}
		default:
		case WEBKIT_POLICY_DECISION_TYPE_RESPONSE:
		{
			result = FALSE;
			return result;
		}
	}
}


static void
nuvola_welcome_screen_class_init (NuvolaWelcomeScreenClass * klass)
{
	nuvola_welcome_screen_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaWelcomeScreenPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_welcome_screen_finalize;
}


static void
nuvola_welcome_screen_instance_init (NuvolaWelcomeScreen * self)
{
	self->priv = NUVOLA_WELCOME_SCREEN_GET_PRIVATE (self);
}


static void
nuvola_welcome_screen_finalize (GObject * obj)
{
	NuvolaWelcomeScreen * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreen);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->app);
	_g_object_unref0 (self->priv->web_view);
	_g_object_unref0 (self->priv->welcome_text);
	_g_object_unref0 (self->priv->scroll);
	G_OBJECT_CLASS (nuvola_welcome_screen_parent_class)->finalize (obj);
}


GType
nuvola_welcome_screen_get_type (void)
{
	static volatile gsize nuvola_welcome_screen_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_welcome_screen_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaWelcomeScreenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_welcome_screen_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaWelcomeScreen), 0, (GInstanceInitFunc) nuvola_welcome_screen_instance_init, NULL };
		GType nuvola_welcome_screen_type_id;
		nuvola_welcome_screen_type_id = g_type_register_static (gtk_grid_get_type (), "NuvolaWelcomeScreen", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_welcome_screen_type_id__volatile, nuvola_welcome_screen_type_id);
	}
	return nuvola_welcome_screen_type_id__volatile;
}



