/* XKeyGrabber.c generated by valac 0.40.6, the Vala compiler
 * generated from XKeyGrabber.vala, do not modify */

/*
 * Copyright 2014-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdkx.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>


#define NUVOLA_TYPE_XKEY_GRABBER (nuvola_xkey_grabber_get_type ())
#define NUVOLA_XKEY_GRABBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_XKEY_GRABBER, NuvolaXKeyGrabber))
#define NUVOLA_XKEY_GRABBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_XKEY_GRABBER, NuvolaXKeyGrabberClass))
#define NUVOLA_IS_XKEY_GRABBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_XKEY_GRABBER))
#define NUVOLA_IS_XKEY_GRABBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_XKEY_GRABBER))
#define NUVOLA_XKEY_GRABBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_XKEY_GRABBER, NuvolaXKeyGrabberClass))

typedef struct _NuvolaXKeyGrabber NuvolaXKeyGrabber;
typedef struct _NuvolaXKeyGrabberClass NuvolaXKeyGrabberClass;
typedef struct _NuvolaXKeyGrabberPrivate NuvolaXKeyGrabberPrivate;
enum  {
	NUVOLA_XKEY_GRABBER_0_PROPERTY,
	NUVOLA_XKEY_GRABBER_NUM_PROPERTIES
};
static GParamSpec* nuvola_xkey_grabber_properties[NUVOLA_XKEY_GRABBER_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NUVOLA_XKEY_GRABBER_KEYBINDING_PRESSED_SIGNAL,
	NUVOLA_XKEY_GRABBER_NUM_SIGNALS
};
static guint nuvola_xkey_grabber_signals[NUVOLA_XKEY_GRABBER_NUM_SIGNALS] = {0};

struct _NuvolaXKeyGrabber {
	GObject parent_instance;
	NuvolaXKeyGrabberPrivate * priv;
};

struct _NuvolaXKeyGrabberClass {
	GObjectClass parent_class;
};

struct _NuvolaXKeyGrabberPrivate {
	GHashTable* keybindings;
	GdkX11Window* root_window;
};


static gpointer nuvola_xkey_grabber_parent_class = NULL;
static GdkModifierType* nuvola_xkey_grabber_lock_modifiers;
static gint nuvola_xkey_grabber_lock_modifiers_length1;
static GdkModifierType* nuvola_xkey_grabber_lock_modifiers = NULL;
static gint nuvola_xkey_grabber_lock_modifiers_length1 = 0;
static gint _nuvola_xkey_grabber_lock_modifiers_size_ = 0;

GType nuvola_xkey_grabber_get_type (void) G_GNUC_CONST;
#define NUVOLA_XKEY_GRABBER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_XKEY_GRABBER, NuvolaXKeyGrabberPrivate))
NuvolaXKeyGrabber* nuvola_xkey_grabber_new (void);
NuvolaXKeyGrabber* nuvola_xkey_grabber_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void nuvola_xkey_grabber_setup_display (NuvolaXKeyGrabber* self,
                                        GdkDisplay* display);
static void _nuvola_xkey_grabber_setup_display_gdk_display_manager_display_opened (GdkDisplayManager* _sender,
                                                                            GdkDisplay* display,
                                                                            gpointer self);
gboolean nuvola_xkey_grabber_is_grabbed (NuvolaXKeyGrabber* self,
                                         const gchar* accelerator);
gboolean nuvola_xkey_grabber_grab (NuvolaXKeyGrabber* self,
                                   const gchar* accelerator,
                                   gboolean allow_multiple);
static gboolean nuvola_xkey_grabber_grab_ungrab (NuvolaXKeyGrabber* self,
                                          gboolean grab,
                                          const gchar* accelerator);
gboolean nuvola_xkey_grabber_ungrab (NuvolaXKeyGrabber* self,
                                     const gchar* accelerator);
static GdkFilterReturn nuvola_xkey_grabber_event_filter (NuvolaXKeyGrabber* self,
                                                  GdkXEvent* gdk_xevent,
                                                  GdkEvent* gdk_event);
static GdkFilterReturn _nuvola_xkey_grabber_event_filter_gdk_filter_func (GdkXEvent* xevent,
                                                                   GdkEvent* event,
                                                                   gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_UINT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void nuvola_xkey_grabber_finalize (GObject * obj);


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_nuvola_xkey_grabber_setup_display_gdk_display_manager_display_opened (GdkDisplayManager* _sender,
                                                                       GdkDisplay* display,
                                                                       gpointer self)
{
	nuvola_xkey_grabber_setup_display ((NuvolaXKeyGrabber*) self, display);
}


NuvolaXKeyGrabber*
nuvola_xkey_grabber_construct (GType object_type)
{
	NuvolaXKeyGrabber * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkDisplay* _tmp5_;
	self = (NuvolaXKeyGrabber*) g_object_new (object_type, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, NULL);
	_g_hash_table_unref0 (self->priv->keybindings);
	self->priv->keybindings = _tmp2_;
	_tmp3_ = gdk_display_get_default ();
	_tmp4_ = _g_object_ref0 (_tmp3_);
	display = _tmp4_;
	_tmp5_ = display;
	if (_tmp5_ != NULL) {
		GdkDisplay* _tmp6_;
		_tmp6_ = display;
		nuvola_xkey_grabber_setup_display (self, _tmp6_);
	} else {
		GdkDisplayManager* _tmp7_;
		_tmp7_ = gdk_display_manager_get ();
		g_signal_connect_object (_tmp7_, "display-opened", (GCallback) _nuvola_xkey_grabber_setup_display_gdk_display_manager_display_opened, self, 0);
	}
	_g_object_unref0 (display);
	return self;
}


NuvolaXKeyGrabber*
nuvola_xkey_grabber_new (void)
{
	return nuvola_xkey_grabber_construct (NUVOLA_TYPE_XKEY_GRABBER);
}


gboolean
nuvola_xkey_grabber_is_grabbed (NuvolaXKeyGrabber* self,
                                const gchar* accelerator)
{
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (accelerator != NULL, FALSE);
	_tmp0_ = self->priv->keybindings;
	result = g_hash_table_contains (_tmp0_, accelerator);
	return result;
}


gboolean
nuvola_xkey_grabber_grab (NuvolaXKeyGrabber* self,
                          const gchar* accelerator,
                          gboolean allow_multiple)
{
	gboolean result = FALSE;
	GHashTable* _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (accelerator != NULL, FALSE);
	if (nuvola_xkey_grabber_is_grabbed (self, accelerator)) {
		guint count = 0U;
		GHashTable* _tmp0_;
		gconstpointer _tmp1_;
		GHashTable* _tmp2_;
		gchar* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
		if (!allow_multiple) {
			result = FALSE;
			return result;
		}
		_tmp0_ = self->priv->keybindings;
		_tmp1_ = g_hash_table_lookup (_tmp0_, accelerator);
		count = ((guint) ((guintptr) _tmp1_)) + 1;
		_tmp2_ = self->priv->keybindings;
		_tmp3_ = g_strdup (accelerator);
		_tmp4_ = count;
		g_hash_table_insert (_tmp2_, _tmp3_, (gpointer) ((guintptr) _tmp4_));
		_tmp5_ = count;
		g_debug ("XKeyGrabber.vala:67: Grabbed %s, count %u", accelerator, _tmp5_);
		result = TRUE;
		return result;
	}
	if (!nuvola_xkey_grabber_grab_ungrab (self, TRUE, accelerator)) {
		result = FALSE;
		return result;
	}
	_tmp6_ = self->priv->keybindings;
	_tmp7_ = g_strdup (accelerator);
	g_hash_table_insert (_tmp6_, _tmp7_, (gpointer) ((guintptr) ((guint) 1)));
	g_debug ("XKeyGrabber.vala:76: Grabbed %s, count %d", accelerator, 1);
	result = TRUE;
	return result;
}


gboolean
nuvola_xkey_grabber_ungrab (NuvolaXKeyGrabber* self,
                            const gchar* accelerator)
{
	gboolean result = FALSE;
	guint count = 0U;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	guint _tmp2_;
	GHashTable* _tmp7_;
	guint _tmp8_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (accelerator != NULL, FALSE);
	if (!nuvola_xkey_grabber_is_grabbed (self, accelerator)) {
		result = FALSE;
		return result;
	}
	_tmp0_ = self->priv->keybindings;
	_tmp1_ = g_hash_table_lookup (_tmp0_, accelerator);
	count = ((guint) ((guintptr) _tmp1_)) - 1;
	_tmp2_ = count;
	if (_tmp2_ > ((guint) 0)) {
		GHashTable* _tmp3_;
		gchar* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
		_tmp3_ = self->priv->keybindings;
		_tmp4_ = g_strdup (accelerator);
		_tmp5_ = count;
		g_hash_table_insert (_tmp3_, _tmp4_, (gpointer) ((guintptr) _tmp5_));
		_tmp6_ = count;
		g_debug ("XKeyGrabber.vala:88: Ungrabbed %s, count %u", accelerator, _tmp6_);
		result = TRUE;
		return result;
	}
	if (!nuvola_xkey_grabber_grab_ungrab (self, FALSE, accelerator)) {
		result = FALSE;
		return result;
	}
	_tmp7_ = self->priv->keybindings;
	g_hash_table_remove (_tmp7_, accelerator);
	_tmp8_ = count;
	g_debug ("XKeyGrabber.vala:97: Ungrabbed %s, count %u", accelerator, _tmp8_);
	result = TRUE;
	return result;
}


static gboolean
nuvola_xkey_grabber_grab_ungrab (NuvolaXKeyGrabber* self,
                                 gboolean grab,
                                 const gchar* accelerator)
{
	gboolean result = FALSE;
	GdkX11Window* _tmp0_;
	guint keysym = 0U;
	GdkModifierType modifiers = 0;
	guint _tmp1_ = 0U;
	GdkModifierType _tmp2_ = 0;
	guint _tmp3_;
	GdkKeymap* keymap = NULL;
	GdkKeymap* _tmp4_;
	GdkKeymap* _tmp5_;
	GdkKeymap* _tmp6_;
	gboolean _tmp7_;
	GdkX11Display* gdk_display = NULL;
	GdkX11Window* _tmp8_;
	GdkDisplay* _tmp9_;
	GdkX11Display* _tmp10_;
	GdkX11Display* _tmp11_;
	Display* display = NULL;
	GdkX11Display* _tmp12_;
	Display* _tmp13_;
	XID xid = 0;
	GdkX11Window* _tmp14_;
	gint keycode = 0;
	Display* _tmp15_;
	guint _tmp16_;
	gint _tmp17_;
	GdkModifierType* _tmp18_;
	gint _tmp18__length1;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (accelerator != NULL, FALSE);
	_tmp0_ = self->priv->root_window;
	if (_tmp0_ == NULL) {
		g_warning ("XKeyGrabber.vala:103: Failed to set a keybinding '%s' because a X11 wi" \
"ndow has not been set yet.", accelerator);
		result = FALSE;
		return result;
	}
	gtk_accelerator_parse (accelerator, &_tmp1_, &_tmp2_);
	keysym = _tmp1_;
	modifiers = _tmp2_;
	_tmp3_ = keysym;
	g_return_val_if_fail (_tmp3_ != ((guint) 0), FALSE);
	_tmp4_ = gdk_keymap_get_default ();
	_tmp5_ = _g_object_ref0 (_tmp4_);
	keymap = _tmp5_;
	_tmp6_ = keymap;
	_tmp7_ = gdk_keymap_map_virtual_modifiers (_tmp6_, &modifiers);
	if (!_tmp7_) {
		g_warning ("XKeyGrabber.vala:114: Failed to map virtual modifiers.");
		result = FALSE;
		_g_object_unref0 (keymap);
		return result;
	}
	_tmp8_ = self->priv->root_window;
	_tmp9_ = gdk_window_get_display ((GdkWindow*) _tmp8_);
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp9_) : NULL);
	gdk_display = _tmp10_;
	_tmp11_ = gdk_display;
	g_return_val_if_fail (_tmp11_ != NULL, FALSE);
	_tmp12_ = gdk_display;
	_tmp13_ = gdk_x11_display_get_xdisplay (_tmp12_);
	display = _tmp13_;
	_tmp14_ = self->priv->root_window;
	xid = (XID) gdk_x11_window_get_xid (_tmp14_);
	_tmp15_ = display;
	_tmp16_ = keysym;
	keycode = (gint) XKeysymToKeycode (_tmp15_, (gulong) _tmp16_);
	_tmp17_ = keycode;
	g_return_val_if_fail (_tmp17_ != 0, FALSE);
	gdk_error_trap_push ();
	_tmp18_ = nuvola_xkey_grabber_lock_modifiers;
	_tmp18__length1 = nuvola_xkey_grabber_lock_modifiers_length1;
	{
		GdkModifierType* lock_modifier_collection = NULL;
		gint lock_modifier_collection_length1 = 0;
		gint _lock_modifier_collection_size_ = 0;
		gint lock_modifier_it = 0;
		lock_modifier_collection = _tmp18_;
		lock_modifier_collection_length1 = _tmp18__length1;
		for (lock_modifier_it = 0; lock_modifier_it < _tmp18__length1; lock_modifier_it = lock_modifier_it + 1) {
			GdkModifierType lock_modifier = 0;
			lock_modifier = lock_modifier_collection[lock_modifier_it];
			{
				if (grab) {
					Display* _tmp19_;
					gint _tmp20_;
					GdkModifierType _tmp21_;
					GdkModifierType _tmp22_;
					XID _tmp23_;
					_tmp19_ = display;
					_tmp20_ = keycode;
					_tmp21_ = modifiers;
					_tmp22_ = lock_modifier;
					_tmp23_ = xid;
					XGrabKey (_tmp19_, _tmp20_, (guint) (_tmp21_ | _tmp22_), (Window) _tmp23_, FALSE, (gint) GrabModeAsync, (gint) GrabModeAsync);
				} else {
					Display* _tmp24_;
					gint _tmp25_;
					GdkModifierType _tmp26_;
					GdkModifierType _tmp27_;
					XID _tmp28_;
					_tmp24_ = display;
					_tmp25_ = keycode;
					_tmp26_ = modifiers;
					_tmp27_ = lock_modifier;
					_tmp28_ = xid;
					XUngrabKey (_tmp24_, _tmp25_, (guint) (_tmp26_ | _tmp27_), (Window) _tmp28_);
				}
			}
		}
	}
	gdk_flush ();
	result = gdk_error_trap_pop () == 0;
	_g_object_unref0 (gdk_display);
	_g_object_unref0 (keymap);
	return result;
}


static GdkFilterReturn
nuvola_xkey_grabber_event_filter (NuvolaXKeyGrabber* self,
                                  GdkXEvent* gdk_xevent,
                                  GdkEvent* gdk_event)
{
	GdkFilterReturn result = 0;
	XEvent* xevent = NULL;
	XEvent* _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (gdk_xevent != NULL, 0);
	g_return_val_if_fail (gdk_event != NULL, 0);
	xevent = (XEvent*) gdk_xevent;
	_tmp0_ = xevent;
	_tmp1_ = (*_tmp0_).type;
	if (_tmp1_ == ((gint) KeyPress)) {
		GdkKeymap* keymap = NULL;
		GdkKeymap* _tmp2_;
		GdkKeymap* _tmp3_;
		GdkModifierType event_mods = 0;
		XEvent* _tmp4_;
		XKeyEvent _tmp5_;
		guint _tmp6_;
		GdkModifierType* _tmp7_;
		gint _tmp7__length1;
		GdkModifierType _tmp8_;
		GdkModifierType keyboard_state_mods = 0;
		guint keyval = 0U;
		GdkKeymap* _tmp9_;
		XEvent* _tmp10_;
		XKeyEvent _tmp11_;
		guint _tmp12_;
		GdkModifierType _tmp13_;
		guint _tmp14_ = 0U;
		GdkModifierType _tmp15_ = 0;
		GdkModifierType _tmp16_;
		GdkModifierType _tmp17_;
		GdkKeymap* _tmp18_;
		GdkModifierType _tmp19_;
		GdkModifierType _tmp20_;
		gchar* accelerator = NULL;
		guint _tmp22_;
		GdkModifierType _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		_tmp2_ = gdk_keymap_get_default ();
		_tmp3_ = _g_object_ref0 (_tmp2_);
		keymap = _tmp3_;
		_tmp4_ = xevent;
		_tmp5_ = (*_tmp4_).xkey;
		_tmp6_ = _tmp5_.state;
		_tmp7_ = nuvola_xkey_grabber_lock_modifiers;
		_tmp7__length1 = nuvola_xkey_grabber_lock_modifiers_length1;
		_tmp8_ = _tmp7_[7];
		event_mods = (GdkModifierType) (_tmp6_ & (~_tmp8_));
		_tmp9_ = keymap;
		_tmp10_ = xevent;
		_tmp11_ = (*_tmp10_).xkey;
		_tmp12_ = _tmp11_.keycode;
		_tmp13_ = event_mods;
		gdk_keymap_translate_keyboard_state (_tmp9_, _tmp12_, _tmp13_, 0, &_tmp14_, NULL, NULL, &_tmp15_);
		keyval = _tmp14_;
		keyboard_state_mods = _tmp15_;
		_tmp16_ = event_mods;
		_tmp17_ = keyboard_state_mods;
		event_mods = _tmp16_ & (~(_tmp17_ & (~GDK_SHIFT_MASK)));
		_tmp18_ = keymap;
		gdk_keymap_add_virtual_modifiers (_tmp18_, &event_mods);
		_tmp19_ = event_mods;
		event_mods = _tmp19_ & gtk_accelerator_get_default_mod_mask ();
		_tmp20_ = event_mods;
		if ((_tmp20_ & (GDK_SUPER_MASK | GDK_HYPER_MASK)) != 0) {
			GdkModifierType _tmp21_;
			_tmp21_ = event_mods;
			event_mods = _tmp21_ & (~GDK_HYPER_MASK);
		}
		_tmp22_ = keyval;
		_tmp23_ = event_mods;
		_tmp24_ = gtk_accelerator_name (_tmp22_, _tmp23_);
		accelerator = _tmp24_;
		_tmp25_ = accelerator;
		if (nuvola_xkey_grabber_is_grabbed (self, _tmp25_)) {
			const gchar* _tmp26_;
			_tmp26_ = accelerator;
			g_signal_emit (self, nuvola_xkey_grabber_signals[NUVOLA_XKEY_GRABBER_KEYBINDING_PRESSED_SIGNAL], 0, _tmp26_, gdk_event_get_time (gdk_event));
		} else {
			const gchar* _tmp27_;
			_tmp27_ = accelerator;
			g_warning ("XKeyGrabber.vala:162: Unknown keybinding %s", _tmp27_);
		}
		_g_free0 (accelerator);
		_g_object_unref0 (keymap);
	}
	result = GDK_FILTER_CONTINUE;
	return result;
}


static GdkFilterReturn
_nuvola_xkey_grabber_event_filter_gdk_filter_func (GdkXEvent* xevent,
                                                   GdkEvent* event,
                                                   gpointer self)
{
	GdkFilterReturn result;
	result = nuvola_xkey_grabber_event_filter ((NuvolaXKeyGrabber*) self, xevent, event);
	return result;
}


static void
nuvola_xkey_grabber_setup_display (NuvolaXKeyGrabber* self,
                                   GdkDisplay* display)
{
	GdkX11Window* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (display != NULL);
	_tmp0_ = self->priv->root_window;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = gdk_display_get_name (display);
		g_warning ("XKeyGrabber.vala:170: A display '%s' appeared but the root window had " \
"been already set.", _tmp1_);
	} else {
		GdkWindow* _tmp2_;
		GdkX11Window* _tmp3_;
		GdkX11Window* _tmp4_;
		_tmp2_ = gdk_get_default_root_window ();
		_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp2_) : NULL);
		_g_object_unref0 (self->priv->root_window);
		self->priv->root_window = _tmp3_;
		_tmp4_ = self->priv->root_window;
		if (_tmp4_ == NULL) {
			const gchar* _tmp5_;
			_tmp5_ = gdk_display_get_name (display);
			g_warning ("XKeyGrabber.vala:174: Failed to get a X11 Window for the display '%s'.", _tmp5_);
		} else {
			const gchar* _tmp6_;
			GdkX11Window* _tmp7_;
			_tmp6_ = gdk_display_get_name (display);
			g_debug ("XKeyGrabber.vala:176: Obtained a X11 Window for the display '%s'.", _tmp6_);
			_tmp7_ = self->priv->root_window;
			gdk_window_add_filter ((GdkWindow*) _tmp7_, _nuvola_xkey_grabber_event_filter_gdk_filter_func, self);
		}
	}
}


static void
g_cclosure_user_marshal_VOID__STRING_UINT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_UINT) (gpointer data1, const char* arg_1, guint32 arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_UINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_uint (param_values + 2), data2);
}


static void
nuvola_xkey_grabber_class_init (NuvolaXKeyGrabberClass * klass)
{
	GdkModifierType* _tmp0_;
	nuvola_xkey_grabber_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaXKeyGrabberPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_xkey_grabber_finalize;
	nuvola_xkey_grabber_signals[NUVOLA_XKEY_GRABBER_KEYBINDING_PRESSED_SIGNAL] = g_signal_new ("keybinding-pressed", NUVOLA_TYPE_XKEY_GRABBER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_UINT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_UINT);
	_tmp0_ = g_new0 (GdkModifierType, 8);
	_tmp0_[0] = 0;
	_tmp0_[1] = GDK_MOD2_MASK;
	_tmp0_[2] = GDK_LOCK_MASK;
	_tmp0_[3] = GDK_MOD5_MASK;
	_tmp0_[4] = GDK_MOD2_MASK | GDK_LOCK_MASK;
	_tmp0_[5] = GDK_MOD2_MASK | GDK_MOD5_MASK;
	_tmp0_[6] = GDK_LOCK_MASK | GDK_MOD5_MASK;
	_tmp0_[7] = (GDK_MOD2_MASK | GDK_LOCK_MASK) | GDK_MOD5_MASK;
	nuvola_xkey_grabber_lock_modifiers = _tmp0_;
	nuvola_xkey_grabber_lock_modifiers_length1 = 8;
}


static void
nuvola_xkey_grabber_instance_init (NuvolaXKeyGrabber * self)
{
	self->priv = NUVOLA_XKEY_GRABBER_GET_PRIVATE (self);
	self->priv->root_window = NULL;
}


static void
nuvola_xkey_grabber_finalize (GObject * obj)
{
	NuvolaXKeyGrabber * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_XKEY_GRABBER, NuvolaXKeyGrabber);
	_g_hash_table_unref0 (self->priv->keybindings);
	_g_object_unref0 (self->priv->root_window);
	G_OBJECT_CLASS (nuvola_xkey_grabber_parent_class)->finalize (obj);
}


GType
nuvola_xkey_grabber_get_type (void)
{
	static volatile gsize nuvola_xkey_grabber_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_xkey_grabber_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaXKeyGrabberClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_xkey_grabber_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaXKeyGrabber), 0, (GInstanceInitFunc) nuvola_xkey_grabber_instance_init, NULL };
		GType nuvola_xkey_grabber_type_id;
		nuvola_xkey_grabber_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaXKeyGrabber", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_xkey_grabber_type_id__volatile, nuvola_xkey_grabber_type_id);
	}
	return nuvola_xkey_grabber_type_id__volatile;
}



