/* main.c generated by valac 0.40.6, the Vala compiler
 * generated from main.vala, do not modify */

/*
 * Copyright 2014-2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <webkit2/webkit-web-extension.h>
#include <dioriteglib4.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


#define NUVOLA_TYPE_WEB_EXTENSION (nuvola_web_extension_get_type ())
#define NUVOLA_WEB_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_EXTENSION, NuvolaWebExtension))
#define NUVOLA_WEB_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_EXTENSION, NuvolaWebExtensionClass))
#define NUVOLA_IS_WEB_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_EXTENSION))
#define NUVOLA_IS_WEB_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_EXTENSION))
#define NUVOLA_WEB_EXTENSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_EXTENSION, NuvolaWebExtensionClass))

typedef struct _NuvolaWebExtension NuvolaWebExtension;
typedef struct _NuvolaWebExtensionClass NuvolaWebExtensionClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))


extern NuvolaWebExtension* nuvola_extension;
NuvolaWebExtension* nuvola_extension = NULL;

GType nuvola_web_extension_get_type (void) G_GNUC_CONST;
void webkit_web_extension_initialize_with_user_data (WebKitWebExtension* extension,
                                                     GVariant* data);
NuvolaWebExtension* nuvola_web_extension_new (WebKitWebExtension* extension,
                                              DrtRpcChannel* channel,
                                              GHashTable* worker_data);
NuvolaWebExtension* nuvola_web_extension_construct (GType object_type,
                                                    WebKitWebExtension* extension,
                                                    DrtRpcChannel* channel,
                                                    GHashTable* worker_data);


void
webkit_web_extension_initialize_with_user_data (WebKitWebExtension* extension,
                                                GVariant* data)
{
	FILE* _tmp0_;
	gchar* debug_sleep = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp9_;
	GHashTable* worker_data = NULL;
	GHashTable* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (extension != NULL);
	g_return_if_fail (data != NULL);
	_tmp0_ = stderr;
	drt_logger_init (_tmp0_, G_LOG_LEVEL_DEBUG, TRUE, "Worker");
	_tmp1_ = g_getenv ("NUVOLA_WEB_WORKER_SLEEP");
	_tmp2_ = g_strdup (_tmp1_);
	debug_sleep = _tmp2_;
	_tmp3_ = debug_sleep;
	if (_tmp3_ != NULL) {
		gint seconds = 0;
		const gchar* _tmp4_;
		gint _tmp5_;
		_tmp4_ = debug_sleep;
		seconds = atoi (_tmp4_);
		_tmp5_ = seconds;
		if (_tmp5_ > 0) {
			gint _tmp6_;
			gint _tmp7_;
			_tmp6_ = seconds;
			g_warning ("main.vala:38: WebWorker is going to sleep for %d seconds.", _tmp6_);
			g_warning ("main.vala:39: Run `gdb -p %d` to debug it with gdb.", (gint) getpid ());
			_tmp7_ = seconds;
			g_usleep ((gulong) (_tmp7_ * 1000000));
			g_warning ("main.vala:41: WebWorker is awake.");
		} else {
			const gchar* _tmp8_;
			_tmp8_ = debug_sleep;
			g_warning ("main.vala:43: Invalid NUVOLA_WEB_WORKER_SLEEP variable: %s", _tmp8_);
		}
	}
	_tmp9_ = g_getenv ("NUVOLA_TEST_ABORT");
	if (g_strcmp0 (_tmp9_, "worker") == 0) {
		g_error ("main.vala:48: Web Worker abort requested.");
	}
	_tmp10_ = drt_variant_to_hashtable (data);
	worker_data = _tmp10_;
	{
		DrtRpcChannel* channel = NULL;
		gconstpointer _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gconstpointer _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		DrtRpcChannel* _tmp17_;
		DrtRpcChannel* _tmp18_;
		NuvolaWebExtension* _tmp19_;
		_tmp11_ = g_hash_table_lookup (worker_data, "RUNNER_BUS_NAME");
		_tmp12_ = g_variant_dup_string ((GVariant*) _tmp11_, NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_hash_table_lookup (worker_data, "NUVOLA_API_ROUTER_TOKEN");
		_tmp15_ = g_variant_dup_string ((GVariant*) _tmp14_, NULL);
		_tmp16_ = _tmp15_;
		_tmp17_ = drt_rpc_channel_new_from_name ((guint) 0, _tmp13_, NULL, _tmp16_, (guint) 5000, &_inner_error_);
		_tmp18_ = _tmp17_;
		_g_free0 (_tmp16_);
		_g_free0 (_tmp13_);
		channel = _tmp18_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch11_g_error;
		}
		_tmp19_ = nuvola_web_extension_new (extension, channel, worker_data);
		_g_object_unref0 (nuvola_extension);
		nuvola_extension = _tmp19_;
		_g_object_unref0 (channel);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp20_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = e->message;
		g_error ("main.vala:58: Failed to connect to app runner. %s", _tmp20_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_hash_table_unref0 (worker_data);
		_g_free0 (debug_sleep);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_hash_table_unref0 (worker_data);
	_g_free0 (debug_sleep);
}



